
Declare SaveTextFile(TextFileContent.s, TextFileName.s, WriteStringFormat = #PB_Ascii)
Declare.s SaveCodeToTempX()

Enumeration #PB_Event_FirstCustomValue
	#AddLog
EndEnumeration

XIncludeFile "PB2Web.pbf"
XIncludeFile "functions.pbi"
XIncludeFile "profiles.pbi"
XIncludeFile "tokenizer.pb"

Global NewList FileToCopy.s()

Global TempFileName.s

Global SourceFile.s

Global PbCompiler.s = GetEnvironmentVariable("PB_TOOL_Compiler")

Global PbProject.s = GetEnvironmentVariable("PB_TOOL_Project")

Global PbFileContent.s

Global IniPath.s = GetAppDataPath("tuebbentools", "PB2Web") + "PB2Web.ini"

Global GlobalQuit

If  FileSize(GetExePath() + "PB2Web.ini")
	RenameFile(GetExePath() + "PB2Web.ini", IniPath)
EndIf

; ####################################################################

#APPNAME = "PB2Web"
#Version = "2016-12-20"

; ####################################################################

Procedure CopyNecessaryFiles()
  
  Protected TargetFile.s
  
  NewList IgnoreFiles.s()
  
  AddElement(IgnoreFiles()) : IgnoreFiles() = "index.html"
  AddElement(IgnoreFiles()) : IgnoreFiles() = "index_mobile.html"
  
  AddElement(IgnoreFiles()) : IgnoreFiles() = "templates/cgi.pb"
  AddElement(IgnoreFiles()) : IgnoreFiles() = "templates/php.php"
  AddElement(IgnoreFiles()) : IgnoreFiles() = "templates/nodejs.js"
  AddElement(IgnoreFiles()) : IgnoreFiles() = "templates/python.py"
  AddElement(IgnoreFiles()) : IgnoreFiles() = "templates/flask.py"
  AddElement(IgnoreFiles()) : IgnoreFiles() = "templates/aspx.aspx"
  AddElement(IgnoreFiles()) : IgnoreFiles() = "templates/asp.asp"
  
  AddElement(IgnoreFiles()) : IgnoreFiles() = "usertemplates/dummy.txt"
  AddElement(IgnoreFiles()) : IgnoreFiles() = "userlibraries/dummy.txt"
  
  If Not IsInUse\w2ui
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/w2ui"
  EndIf
  
  If Not IsInUse\TreeGadget
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/fancytree"
  EndIf
  
  If Not IsInUse\Pixi
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/pixi"
  EndIf
  
  If Not IsInUse\TouchSwipe
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.touchSwipe"
  EndIf
  
  If Not IsInUse\BlockUI
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.blockUI"
  EndIf
  
  If Not IsInUse\JsCookie
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/js.cookie"
  EndIf
  
  If Not IsInUse\Splitter
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.splitter"
  EndIf
  
  If Not IsInUse\KeyboardShortcut
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.hotkeys"
  EndIf
  
  If Not IsInUse\Database
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/alasql"
  EndIf
  
  If Not IsInUse\XML
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.xpath"
  EndIf
  
  If Not IsInUse\ColorRequester
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/evol.colorpicker"
  EndIf
  
  If Not IsInUse\CryptoJs
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/CryptoJS"
  EndIf
  
  If Not IsInUse\Preference
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jStorage"
  EndIf
  
  If Not IsInUse\JQueryMobile
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.mobile"
  EndIf
  
  If Not IsInUse\Menu
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.ui.menubar"
  EndIf
  
  If Not IsInUse\DateTimePicker
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.ui.datepicker"
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.timepicker"
  EndIf
  
  If Not IsInUse\TriState
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.tristate.js"
  EndIf
  
  If Not IsInUse\Websocket
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.websocket"
  EndIf
  
  If Not IsInUse\TrackBarGadget
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jquery.ui.slider.pips"
  EndIf
  
  If Not IsInUse\FileSaver And Not IsInUse\SaveImage
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/Blob.js"
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/canvas-toBlob.js"
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/FileSaver.js"
  EndIf
  
  If Not IsInUse\PDF
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/jspdf"
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "libraries/html2canvas"
  EndIf
  
  If Not IsInUse\GoogleMap
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "userlibraries/google-maps-utility-library"
  EndIf
  
  If Not IsInUse\MonacoEditor
  	AddElement(IgnoreFiles()) : IgnoreFiles() = "userlibraries/monaco-editor"
  EndIf
  
  ; ----
  
  ForEach FileToCopy()
  	ForEach IgnoreFiles()
  		If FindString(FileToCopy(), IgnoreFiles(), 1, #PB_String_NoCase)
  			FileToCopy() = ""
  		EndIf
  	Next
 	Next
 	
 	ForEach FileToCopy()
		
		If FileToCopy() <> ""
			
			TargetFile = ReplaceString(FileToCopy(), SourceFolder, "")
			
			; MakeSureDirectoryPathExists_(GetPathPart(CompilerInfo\TargetFolder + TargetFile))
			
			If FileSize(GetPathPart(CompilerInfo\TargetFolderJS + TargetFile)) <> -2
				CreateDirectoryEx(GetPathPart(CompilerInfo\TargetFolderJS + TargetFile))
			EndIf
			
			If FileSize(CompilerInfo\TargetFolderJS + TargetFile) = -1 Or 
			   GetFileDate(FileToCopy(), #PB_Date_Modified) <> GetFileDate(CompilerInfo\TargetFolderJS + TargetFile, #PB_Date_Modified)
				
				If CopyFile(FileToCopy(), CompilerInfo\TargetFolderJS + TargetFile) = 0
					AddLog("Couldn't copy file: '" + FileToCopy() + "' to '" + CompilerInfo\TargetFolderJS + TargetFile + "'", 1)
				EndIf
				
			EndIf
			
		EndIf
		
	Next
 	
 	; ----------
	
	Protected SourceFileFolder.s = GetPathPart(SourceFile)
	
	ForEach IncludeBinaryFile()
		; MakeSureDirectoryPathExists_(GetPathPart(CompilerInfo\TargetFolder + IncludeBinaryFile()))
		If FileSize(GetPathPart(CompilerInfo\TargetFolder + IncludeBinaryFile())) <> -2
			CreateDirectoryEx(GetPathPart(CompilerInfo\TargetFolder + IncludeBinaryFile()))
		EndIf
		If FileSize(CompilerInfo\TargetFolder + IncludeBinaryFile()) = -1 Or 
		   FileSize(SourceFileFolder + IncludeBinaryFile()) <> FileSize(CompilerInfo\TargetFolder + IncludeBinaryFile())
			If CopyFile(SourceFileFolder + IncludeBinaryFile(), CompilerInfo\TargetFolder + IncludeBinaryFile()) = 0
				AddLog("Couldn't copy file: '" + SourceFileFolder + IncludeBinaryFile() + "' to '" + CompilerInfo\TargetFolder + IncludeBinaryFile() + "'", 1)
			Else
				AddLog("Copy file: '" + SourceFileFolder + IncludeBinaryFile() + "' to '" + CompilerInfo\TargetFolder + IncludeBinaryFile() + "': success")
			EndIf
		EndIf
	Next
  
EndProcedure

Procedure SyntaxCheck()
  
  AddLog("")
  AddLog("Syntaxcheck. Starting PureBasic...")
  
  Protected Parameter.s = "/CHECK " + Chr(34) + SourceFile + Chr(34)
  
  Protected Compiler = RunProgram(Chr(34) + PbCompiler + Chr(34),
                                  Parameter, 
                                  "",
                                  #PB_Program_Open | #PB_Program_Read | #PB_Program_Hide)
  
  Protected ExitCode = 1
  
  If Compiler
    
    While ProgramRunning(Compiler)
      If AvailableProgramOutput(Compiler)
        AddLog(ReadProgramString(Compiler))
      EndIf
    Wend
    
    ExitCode = ProgramExitCode(Compiler)
    
    CloseProgram(Compiler) ; Close the connection to the program
    
  Else
    
    AddLog("")
    AddLog("Something went wrong :-(", 1)
    AddLog("")
    
  EndIf
  
  If ExitCode = 0
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf  
  
EndProcedure

Procedure PreProcess()
  
	AddLog("")
	AddLog("Preprocessing. Starting PureBasic...")
	
	Protected Parameter.s = Chr(34) + SourceFile + Chr(34) + " /PREPROCESS " + Chr(34) + SourceFile + ".pp" + Chr(34)
	
	Protected Compiler = RunProgram(Chr(34) + PbCompiler + Chr(34),
	                                Parameter, 
	                                "",
	                                #PB_Program_Open | #PB_Program_Read | #PB_Program_Hide)
	
	Protected ExitCode = 1
	
	If Compiler
		
		While ProgramRunning(Compiler)
			If AvailableProgramOutput(Compiler)
				AddLog(ReadProgramString(Compiler))
			EndIf
		Wend
		
		ExitCode = ProgramExitCode(Compiler)
		
		CloseProgram(Compiler) ; Close the connection to the program
		
	Else
		
		AddLog("")
		AddLog("Something went wrong :-(", 1)
		AddLog("")
		
	EndIf
	
	If ExitCode = 0
		
		; PbFileContent = LoadTextfile(SourceFile + ".pp")
		
		ProcedureReturn #True
		
	Else
		
		; PbFileContent = ""
		
		ProcedureReturn #False
		
	EndIf  
  
EndProcedure

Procedure.s GetMainSourceFromPbProject(PbProject.s)
	
	; i know: it's better to use the xml-parser
	; but using string-operations it's faster for me to code ;-)
	
	Protected ReturnValue.s
	Protected P1, P2
	
	If GetExtensionPart(PbProject) = ""
		PbProject + ".pbp" 
	EndIf
	
	Protected PbProjectContent.s = LoadTextFile(PbProject)
	
	P1 = FindString(PbProjectContent, "<inputfile value=")
	
	If P1 > 0
		P1 + Len("<inputfile value=")
		P2 = FindString(PbProjectContent, "/>", P1)
		If P2 > 0
			ReturnValue = Mid(PbProjectContent, P1, P2 - P1)
		EndIf
	EndIf
	
	If ReturnValue <> ""
		ReturnValue = Trim(RemoveString(ReturnValue, Chr(34)))
		If FileSize(ReturnValue) = -1
			ReturnValue = GetPathPart(PbProject) + ReturnValue
		EndIf
	EndIf
	
	ProcedureReturn ReturnValue
	
EndProcedure

Procedure.s GetStyleTag(Style.s, AdditionalInfo.s = "")
	
	Protected ReturnValue.s
	
	ReturnValue = "<link rel='stylesheet' type='text/css' " + AdditionalInfo 
	
	If CompilerInfo\UseFlask
		ReturnValue + " href=" + Chr(34) + "{{url_for('static', filename='" + Style + "')}}" + Chr(34) + " />"
	Else
		ReturnValue + " href='" + Style + "' />"	
	EndIf
	
	ProcedureReturn ReturnValue
	
	
EndProcedure

Procedure.s GetScriptTag(Script.s)
	
	Protected ReturnValue.s
	
	If CompilerInfo\UseFlask
		ReturnValue = "<script src=" + Chr(34) + "{{url_for('static', filename='" + Script + "')}}" + Chr(34) + "></script>"
	Else
		ReturnValue = "<script src='" + Script + "'></script>"
	EndIf
	
	ProcedureReturn ReturnValue
	
EndProcedure

Procedure Action(DummyParam)
	
	; ##############################
	
	Protected AppDataPath.s = GetAppDataPath("tuebbentools", "PB2Web")
	
	Protected SelectedWord.s = GetEnvironmentVariable("PB_TOOL_Word")
	
	If LCase(SelectedWord) = LCase("P2W_Converter_SetProfile")
		If FileSize(GetExePath() + "ProfileManager.exe") > 0
			RunProgram(GetExePath() + "ProfileManager.exe")
			End
		EndIf  
	EndIf
	
	Repeat
		
		; Compiler available?
		If FileSize( PbCompiler ) = -1
			AddLog("PBCompiler not found: '" + PbCompiler + "'", 1) 
			Break 1
		EndIf
		
		If FileSize(GetExePath() + "ProfileSelector.exe") = -1
			AddLog("ProfileSelector.exe not found", 1)
			Break
		EndIf
		
		If FileSize(GetExePath() + "ProfileManager.exe") = -1
			AddLog("ProfileManager.exe not found", 1)
			Break
		EndIf
		
		If FileSize(AppDataPath) <> -2
			AddLog("Couldn't create AppDataPath", 1)
			Break
		EndIf
		
		If FileSize(GetExePath() + "constants.txt") = -1
			AddLog("constants.txt not found", 1)
			Break
		EndIf
		
		If FileSize(GetExePath() + "libraries.txt") = -1
			AddLog("libraries.txt not found", 1)
			Break
		EndIf
		
		; Sourcefile-Handling
		If SourceFile = "" : SourceFile = ProgramParameter() : EndIf ; "%FILE"
		If SourceFile = "" : SourceFile = ProgramParameter() : EndIf ; "%TEMPFILE"
		
		If SourceFile = ""
			AddLog("Usage: PB2Web sourcefile.pb", 1)
			Break
		EndIf
		
		If FileSize(SourceFile) = -1
			AddLog("File not found: '" + SourceFile + "'", 1)
			Break
		EndIf  
		
		; ---
		
		PbFileContent = LoadTextFile(SourceFile) + #CRLF$
		
		PreProcess_GetCompilerInfos(PbFileContent)
		
		If CompilerInfo\ProfileName = ""
			If PbProject <> ""
				SourceFile = GetMainSourceFromPbProject(PbProject)
				PbFileContent = LoadTextFile(SourceFile)
			EndIf
		EndIf
		
		AddLog("SourceFile: '" + SourceFile + "'")
		AddLog("SourceFileLength: '" + Str(FileSize(SourceFile)) + "'")
		AddLog("PbFileContentSize: '" + Str(Len(PbFileContent)) + "'")
		
		Protected p2wpbiFound = #False
		
		If CreateRegularExpression(0, "^[\s]*[XIncludeFile|IncludeFile](.*?)p2w.pbi", #PB_RegularExpression_MultiLine | #PB_RegularExpression_NoCase)
			If MatchRegularExpression(0, PbFileContent)
				p2wpbiFound = #True	
			EndIf
			FreeRegularExpression(0)
		EndIf  
		
		If Not p2wpbiFound
			AddLog("p2w.pbi is not included!", 0)
			; Break
		EndIf  
		
		; SyntaxCheck
		
		If Not SyntaxCheck()
			AddLog("SyntaxCheck failed", 1)
			Break
		EndIf
		
		;   ; Preprocessing
		;   
		;   If Not PreProcess()
		;     AddLog("PreProcessing not OK", 1)
		;     Break
		;   EndIf
		;   
		;   PbFileContent = LoadTextFile(SourceFile + ".pp")
		;   
		;   ; after the Syntaxchecking and Preprocessing, we can remove p2w.pbi
		;   
		;   If CreateRegularExpression(0, "Global P2W_Start(.*?)Global P2W_End", #PB_RegularExpression_NoCase | #PB_RegularExpression_DotAll)
		;   	PbFileContent = ReplaceRegularExpression(0, PbFileContent, "")
		; 		FreeRegularExpression(0)
		;   Else
		;     AddLog(RegularExpressionError(), 1)
		;   EndIf
		;   
		;   SaveTextFile(PbFileContent, SourceFile + ".pp")
		
		If GetEnvironmentVariable("PB_TOOL_Debugger") = "0"
			PbFileContent = "DisableDebugger" + #CRLF$ + PbFileContent
		Else
			PbFileContent = "EnableDebugger" + #CRLF$ + PbFileContent
		EndIf
		
		PbFileContent = PreProcess_IgnoreParts(PbFileContent)
		
		If PbFileContent = ""
			ShitHappend = #True
			Break
		EndIf
		
		PbFileContent = PreProcess_IncludeFile(PbFileContent)
		
		PbFileContent = PreProcess_IgnoreParts(PbFileContent)
		
		AddLog("Analyzing CompilerInfos...")
		AddLog("")
		
		PreProcess_GetCompilerInfos(PbFileContent)
		
		If CompilerInfo\TargetFolder = ""
			
			If CompilerInfo\ProfileName = ""
				
				;	AddLog("Profile is not set")
				;	AddLog("Starting " + GetExePath() + "ProfileSelector.exe...")
				;	
				;	If OpenPreferences(AppDataPath + "ProfileSelector.ini")
				;		WritePreferenceString("SelectedProject", "")
				;		ClosePreferences()
				;	EndIf
				;	
				;	RunProgram(Chr(34) + GetExePath() + "ProfileSelector.exe" + Chr(34), "", GetExePath(), #PB_Program_Wait)
				;	
				;	If OpenPreferences(AppDataPath + "ProfileSelector.ini")
				;		CompilerInfo\ProfileName = ReadPreferenceString("SelectedProject", "")
				;		ClosePreferences()
				;	EndIf
				
			EndIf
			
			;	If CompilerInfo\ProfileName = ""
			;		AddLog("No profile found", 1)
			;		Break
			;	EndIf
			;	
			;	AddLog("ProfileName: '" + CompilerInfo\ProfileName + "'")
			
			LoadProfiles(IniPath)
			
			; specified Profile available in Ini-File?
			
			Protected ProfileFound = #False
			If CompilerInfo\ProfileName <> ""
				ForEach Profile()
					If Profile()\Name = CompilerInfo\ProfileName
						ProfileFound = #True
						Break
					EndIf
				Next
				
				If Not ProfileFound
					
					If MessageRequester(#APPNAME, "Profile '" + CompilerInfo\ProfileName + "' doesn't exists. Create a new one?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_No
						Break
					EndIf
					
					RunProgram(Chr(34) + GetExePath() + "ProfileManager.exe" + Chr(34), CompilerInfo\ProfileName, GetExePath(), #PB_Program_Wait)
					RunProgram(Chr(34) + GetExePath() + "ProfileSelector.exe" + Chr(34), "", GetExePath(), #PB_Program_Wait)
					
					If OpenPreferences(AppDataPath + "ProfileSelector.ini")
						CompilerInfo\ProfileName = ReadPreferenceString("SelectedProject", "")
						ClosePreferences()
					EndIf
					
					If CompilerInfo\ProfileName = ""
						AddLog("No profile found", 1)
						Break
					EndIf
					
				EndIf
				
			EndIf
			
			LoadProfiles(IniPath)
			
			; Set Defaults
			
			With CompilerInfo
				\TargetFolder    = GetTemporaryDirectory() 
				\IndexPage       = "index.html"
				\ServerAddress   = ""
				\Encoding        = "UTF8"
				\Theme           = "smoothness"
				\AdditionalScriptsAndStylesheets     = ""
				\AfterConvertingDoNothing            = #False
				\AfterConvertingStartDefaultBrowser  = #True
				\AfterConvertingStartSpecificBrowser = #False
				\AfterConvertingSpecificBrowser      = ""
			EndWith
			
			ForEach Profile()
				
				If Profile()\Name = CompilerInfo\ProfileName
					
					CompilerInfo\TargetFolder = Profile()\ServerPath
					AddLog("Setting ServerPath to: '" + CompilerInfo\TargetFolder + "'")
					
					CompilerInfo\IndexPage = Profile()\IndexPage
					If CompilerInfo\IndexPage = ""
						CompilerInfo\IndexPage = "index.html"
					EndIf
					
					CompilerInfo\ServerAddress = Profile()\ServerAddress
					AddLog("Setting ServerAddress to: '" + CompilerInfo\ServerAddress + "'")
					
					CompilerInfo\ApplicationName = Profile()\ApplicationName
					If CompilerInfo\ApplicationName <> ""
						AddLog("Setting ApplicationName to: '" + CompilerInfo\ApplicationName + "'")
					EndIf
					
					CompilerInfo\Encoding = Profile()\Encoding
					
					CompilerInfo\Theme = Profile()\Theme
					
					If CompilerInfo\Theme = ""
						CompilerInfo\Theme = "smoothness"
					EndIf
					
					; CGI
					
					If Profile()\CgiFilename <> ""
						AddLog("Setting CgiFilename to: '" + Profile()\CgiFilename + "'")
						CompilerInfo\CgiFilename = Profile()\CgiFilename
					EndIf
					
					If Profile()\CgiAddress <> ""
						AddLog("Setting CgiAddress to: '" + Profile()\CgiAddress + "'")
						CompilerInfo\CgiAddress = Profile()\CgiAddress
					EndIf
					
					; PHP
					
					If Profile()\PhpFilename <> ""
						AddLog("Setting PhpFilename to: '" + Profile()\PhpFilename + "'")
						CompilerInfo\PhpFilename = Profile()\PhpFilename
					EndIf
					
					If Profile()\PhpAddress <> "" 
						AddLog("Setting PhpAddress to: '" + Profile()\PhpAddress + "'")
						CompilerInfo\PhpAddress = Profile()\PhpAddress
					EndIf
					
					; ASP
					
					If Profile()\AspFilename <> ""
						AddLog("Setting AspFilename to: '" + Profile()\AspFilename + "'")
						CompilerInfo\AspFilename = Profile()\AspFilename
					EndIf
					
					If Profile()\AspAddress <> "" 
						AddLog("Setting AspAddress to: '" + Profile()\AspAddress + "'")
						CompilerInfo\AspAddress = Profile()\AspAddress
					EndIf
					
					; ASPX
					
					If Profile()\AspxFilename <> ""
						AddLog("Setting AspxFilename to: '" + Profile()\AspxFilename + "'")
						CompilerInfo\AspxFilename = Profile()\AspxFilename
					EndIf
					
					If Profile()\AspxAddress <> "" 
						AddLog("Setting AspxAddress to: '" + Profile()\AspxAddress + "'")
						CompilerInfo\AspxAddress = Profile()\AspxAddress
					EndIf
					
					; Python
					
					If Profile()\PythonFilename <> ""
						AddLog("Setting PythonFilename to: '" + Profile()\PythonFilename + "'")
						CompilerInfo\PythonFilename = Profile()\PythonFilename
					EndIf
					
					If Profile()\PythonAddress <> ""
						AddLog("Setting PythonAddress to: '" + Profile()\PythonAddress + "'")
						CompilerInfo\PythonAddress = Profile()\PythonAddress
					EndIf
					
					; FTP
					
					If Profile()\FtpHost <> ""
						AddLog("Setting FtpHost to: '" + Profile()\FtpHost + "'")
						CompilerInfo\FtpHost = Profile()\FtpHost
					EndIf
					
					If Profile()\FtpUser <> ""
						AddLog("Setting FtpUser to: '" + Profile()\FtpUser + "'")
						CompilerInfo\FtpUser = Profile()\FtpUser
					EndIf
					
					If Profile()\FtpPass <> ""
						AddLog("Setting FtpPass to: '" + "***********" + "'")
						CompilerInfo\FtpPass = Profile()\FtpPass
					EndIf
					
					; NodeJS
					
					If Profile()\NodeJsFilename <> ""
						AddLog("Setting NodeJsFilename to: '" + Profile()\NodeJsFilename + "'")
						CompilerInfo\NodeJsFilename = Profile()\NodeJsFilename
					EndIf
					
					If Profile()\NodeJsAddress <> ""
						AddLog("Setting NodeJsAddress to: '" + Profile()\NodeJsAddress + "'")
						CompilerInfo\NodeJsAddress = Profile()\NodeJsAddress
					EndIf
					
					CompilerInfo\AdditionalScriptsAndStylesheets = Profile()\AdditionalScriptsAndStylesheets
					
					CompilerInfo\AfterConvertingDoNothing            = Profile()\AfterConvertingDoNothing
					CompilerInfo\AfterConvertingStartDefaultBrowser  = Profile()\AfterConvertingStartDefaultBrowser
					CompilerInfo\AfterConvertingStartSpecificBrowser = Profile()\AfterConvertingStartSpecificBrowser
					CompilerInfo\AfterConvertingSpecificBrowser      = Profile()\AfterConvertingSpecificBrowser
					
				EndIf
				
			Next  
			
		EndIf
		
		If CompilerInfo\TargetFolderUser <> ""
			CompilerInfo\TargetFolder = CompilerInfo\TargetFolderUser
		EndIf
		
		If CompilerInfo\TargetFolder = ""
			AddLog("ServerPath is not set", 1)
			Break
		EndIf
		
		If Right(CompilerInfo\TargetFolder, 1) <> "/"
			CompilerInfo\TargetFolder + "/"
		EndIf
		
		If FileSize(CompilerInfo\TargetFolder) <> -2
			AddLog("ServerPath doesn't exists: '" + CompilerInfo\TargetFolder + "'", 1)
			Break
		EndIf
		
		If FileSize(SourceFolder + CompilerInfo\IndexPage) = -1
			AddLog("IndexPage doesn't exists: '" + SourceFolder + CompilerInfo\IndexPage + "'", 1)
			Break
		EndIf
		
		; Overwrite Profile-Settings with P2W_Config_* - Settings (if any):
		
		If CompilerInfo\ApplicationNameUser <> "" : CompilerInfo\ApplicationName = CompilerInfo\ApplicationNameUser : EndIf
		If CompilerInfo\ServerAddressUser <> ""   : CompilerInfo\ServerAddress   = CompilerInfo\ServerAddressUser : EndIf
		
		If CompilerInfo\AspFilenameUser <> ""     : CompilerInfo\AspFilename     = CompilerInfo\AspFilenameUser : EndIf
		If CompilerInfo\AspAddressUser <> ""      : CompilerInfo\AspAddress      = CompilerInfo\AspAddressUser : EndIf
		
		If CompilerInfo\AspxFilenameUser <> ""    : CompilerInfo\AspxFilename    = CompilerInfo\AspxFilenameUser : EndIf
		If CompilerInfo\AspxAddressUser <> ""     : CompilerInfo\AspxAddress     = CompilerInfo\AspxAddressUser : EndIf
		
		If CompilerInfo\CgiFilenameUser <> ""     : CompilerInfo\CgiFilename     = CompilerInfo\CgiFilenameUser : EndIf
		If CompilerInfo\CgiAddressUser <> ""      : CompilerInfo\CgiAddress      = CompilerInfo\CgiAddressUser : EndIf
		
		If CompilerInfo\PhpFilenameUser <> ""     : CompilerInfo\PhpFilename     = CompilerInfo\PhpFilenameUser : EndIf
		If CompilerInfo\PhpAddressUser <> ""      : CompilerInfo\PhpAddress      = CompilerInfo\PhpAddressUser : EndIf
		
		If CompilerInfo\NodeJsFilenameUser <> ""  : CompilerInfo\NodeJsFilename  = CompilerInfo\NodeJsFilenameUser : EndIf
		If CompilerInfo\NodeJsAddressUser <> ""   : CompilerInfo\NodeJsAddress   = CompilerInfo\NodeJsAddressUser : EndIf
		
		If CompilerInfo\PythonFilenameUser <> ""  : CompilerInfo\PythonFilename  = CompilerInfo\PythonFilenameUser : EndIf
		If CompilerInfo\PythonAddressUser <> ""   : CompilerInfo\PythonAddress   = CompilerInfo\PythonAddressUser : EndIf
		
		If CompilerInfo\UseFlaskUser <> ""        : CompilerInfo\UseFlask        = CompilerInfo\UseFlaskUser : EndIf
		If CompilerInfo\FlaskPortUser <> ""       : CompilerInfo\FlaskPort       = CompilerInfo\FlaskPortUser : EndIf
		
		
		If CompilerInfo\ServerAddress = ""
			CompilerInfo\ServerAddress =  Chr(34) + CompilerInfo\TargetFolder + CompilerInfo\IndexPage + Chr(34) ; "file:///" + ReplaceString(CompilerInfo\TargetFolder, "\", "/") + CompilerInfo\IndexPage
		EndIf
		
		If CompilerInfo\ApplicationName = ""
			CompilerInfo\ApplicationName = "application"
		EndIf
		
		If CompilerInfo\TargetFolderJS = ""
			CompilerInfo\TargetFolderJS = CompilerInfo\TargetFolder
		EndIf  
		
		If CompilerInfo\ServerAddressJS = ""
			CompilerInfo\ServerAddressJS = CompilerInfo\ServerAddress
		EndIf  
		
		If CompilerInfo\FlaskPort = ""
			CompilerInfo\FlaskPort = "5000"
		EndIf
		
		If CompilerInfo\UseFlask
			CompilerInfo\ServerAddress   = CompilerInfo\ServerAddress + ":" + CompilerInfo\FlaskPort
			CompilerInfo\PythonFilename  = CompilerInfo\TargetFolder + CompilerInfo\ApplicationName + ".py"
			CompilerInfo\TargetFolderJS  = CompilerInfo\TargetFolder + "static\"
			CompilerInfo\TargetFolder    = CompilerInfo\TargetFolder + "templates\"
		EndIf  
		
		; ---
		; ServerCode
		; ---
		
		PbFileContent = PreProcess_ServerCode_CGI(PbFileContent)
		If PbFileContent = "" : ShitHappend = #True : Break : EndIf
		
		PbFileContent = PreProcess_ServerCode_PHP(PbFileContent)
		If PbFileContent = "" : ShitHappend = #True : Break : EndIf  
		
		PbFileContent = PreProcess_ServerCode_Python(PbFileContent)
		If PbFileContent = "" : ShitHappend = #True : Break : EndIf  
		
		PbFileContent = PreProcess_ServerCode_NodeJs(PbFileContent)
		If PbFileContent = "" : ShitHappend = #True : Break : EndIf  
		
		PbFileContent = PreProcess_ServerCode_ASPX(PbFileContent)
		If PbFileContent = "" : ShitHappend = #True : Break : EndIf  
		
		PbFileContent = PreProcess_ServerCode_ASP(PbFileContent)
		If PbFileContent = "" : ShitHappend = #True : Break : EndIf  
		
		; ---  
		
		PbFileContent = PreProcess_RemoveMacros(PbFileContent)
		
		PbFileContent = PreProcess_InlineJS(PbFileContent)
		
		PbFileContent = PreProcess_DataSection(PbFileContent)
		
		PbFileContent = PreProcess_IncludeBinary(PbFileContent)
		
		PbFileContent = PreProcess_MoveGlobalsOutOfProcedures(PbFileContent)
		
		PbFileContent = Convert(PbFileContent)
		
		If PbFileContent = ""
			Break
		EndIf
		
		PbFileContent = PostProcess_Raw(PbFileContent)
		
		PostProcess_RemoveCompilerDirectives(PbFileContent)
		
		PbFileContent = PostProcess_Finish(Token())
		
		If IsInUse\JQueryMobile
			
			PbFileContent = "$(function () { $(document).ready(function () { " + 
			                #LF$ + PbFileContent + #LF$ + " }); });"
			
		Else
			
			Protected MceFix.s = ""
			
			If IsInUse\TinyMce
				MceFix = #LF$ + "$(document).on('focusin', function (e) { if ($(e.target).closest('.mce-window').length) { e.stopImmediatePropagation(); } });"
			EndIf  	
			
			PbFileContent = "$(function () { $(document).ready(function () { " + 
			                #LF$ + "$('#loader').remove();" + 
			                #LF$ + "$(document).mousemove(function (e) { cCommon.CurrentMouseX = e.pageX; cCommon.CurrentMouseY = e.pageY; });" + 
			                MceFix + 
			                #LF$ + " $.fn.WindowsEvents = null; " + 
			                #LF$ + " $.fn.GadgetsEvents = null; " + 
			                #LF$ + PbFileContent + #LF$ + " }); });"
			
		EndIf
		
		
		If Not(CompilerInfo\DoNotCopy)
			AddLog("")
			AddLog("Copying...")
			CopyNecessaryFiles()
		EndIf
		
		AddLog("")
		AddLog("Ready :-)")
		AddLog("")
		
		Protected Encoding
		
		Select LCase(CompilerInfo\Encoding)
			Case "ascii"   : Encoding = #PB_Ascii
			Case "utf8"    : Encoding = #PB_UTF8
			Case "unicode" : Encoding = #PB_Unicode
			Default        : Encoding = #PB_UTF8
		EndSelect
		
		SaveTextFile(PbFileContent, CompilerInfo\TargetFolderJS + CompilerInfo\ApplicationName + ".js", Encoding)
		
		; ##########################
		
		
		Protected IndexHtml.s
		
		IndexHtml = LoadTextFile(SourceFolder + CompilerInfo\IndexPage)
		
		IndexHtml = ReplaceString(IndexHtml,
		                          "<!-- #JQueryJs# -->",
		                          "<!-- jQuery (https://jquery.com/) -->" + #CRLF$ + #TAB$  + 
		                          GetScriptTag("libraries/jquery/jquery.min.js"))
		
		; ----------------
		
		Protected Replacement.s = ""
		
		If CompilerInfo\UseFlask
			Replacement = "{{url_for('static', filename='wait.gif')}}"
		Else
			Replacement = "wait.gif"
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "#wait.gif#", Replacement)
		
		; ----------------		
		
		If IsInUse\JQueryMobile
			
			IndexHtml = ReplaceString(IndexHtml, 
			                          "<!-- #JQueryMobileJs# -->", 
			                          "<!-- jQuery Mobile JS (https://jquerymobile.com/) -->" + #CRLF$ + #TAB$  + 
			                          GetScriptTag("libraries/jquery.mobile/jquery.mobile.js"))
			
			IndexHtml = ReplaceString(IndexHtml,
			                          "<!-- #JQueryMobileCss# -->",
			                          "<!-- jQuery Mobile CSS (https://jquerymobile.com/) -->" + #CRLF$ + #TAB$  + 
			                          GetStyleTag("libraries/jquery.mobile/jquery.mobile.css"))
			
		Else ; jQuery UI
			
			IndexHtml = ReplaceString(IndexHtml,
			                          "<!-- #JQueryUiJs# -->", 
			                          "<!-- jQuery UI JS (https://jqueryui.com/) -->" + #CRLF$ + #TAB$  + 
			                          GetScriptTag("libraries/jquery.ui/jquery-ui.min.js"))
			
			IndexHtml = ReplaceString(IndexHtml, 
			                          "<!-- #JQueryUiCss# -->", 
			                          "<!-- jQuery UI CSS (https://jqueryui.com/) -->" + #CRLF$ + #TAB$  + 
			                          GetStyleTag("libraries/jquery.ui/themes/" + CompilerInfo\Theme + "/jquery-ui.min.css", "id='jquery_ui_stylesheet'"))
			
			IndexHtml = ReplaceString(IndexHtml, "<!-- #Pb2WebCss# -->", GetStyleTag("Pb2Web.css"))
			
		EndIf
		
		IndexHtml = RemoveString(IndexHtml, "<!-- #Pb2WebCss# -->")
		IndexHtml = RemoveString(IndexHtml, "<!-- #JQueryUiJs# -->")
		IndexHtml = RemoveString(IndexHtml, "<!-- #JQueryUiCss# -->")
		IndexHtml = RemoveString(IndexHtml, "<!-- #JQueryMobileJs# -->")
		IndexHtml = RemoveString(IndexHtml, "<!-- #JQueryMobileCss# -->")
		
		; ----------------
		
		Replacement = "<!-- JQuery Color -->" + #CRLF$ + #TAB$ + 
		              GetScriptTag("libraries/jquery.color/jquery.color.js")
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #jquerycolor# -->", Replacement)
		
		; ----------------
		
		Replacement = "<!-- jquery-dialogextend (https://github.com/ROMB/jquery-dialogextend) -->" + #CRLF$ + #TAB$ + 
		              GetScriptTag("libraries/jquery.ui.dialogextend/jquery.ui.dialogextend.js")
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #jquerydialogextend# -->", Replacement)
		
		; ----------------
		
		Replacement = "<!-- moment (http://momentjs.com/) -->" + #CRLF$ + #TAB$ + 
		              GetScriptTag("libraries/moment/moment-with-locales.min.js")
		; GetScriptTag("libraries/moment/moment.min.js")
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #moment# -->", Replacement)
		
		; ----------------
		
		Replacement = "<!-- jquery.ui.touch.punch (http://touchpunch.furf.com/) -->" + #CRLF$ + #TAB$ + 
		              GetScriptTag("libraries/jquery.ui.touch.punch/jquery.ui.touch-punch.min.js")
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #jqueryuitouchpunch# -->", Replacement)
		
		; ----------------
		
		Replacement = ""
		
		If IsInUse\TreeGadget
			
			Replacement = "<!-- FancyTree (https://github.com/mar10/fancytree) -->" + #CRLF$ + #TAB$ + 
			              GetStyleTag("libraries/fancytree/skin-themeroller/ui.fancytree.css") + #CRLF$ + #TAB$ +
			              GetScriptTag("libraries/fancytree/jquery.fancytree-all.min.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #fancytree# -->", Replacement)
		
		; ----------------
		
		Replacement = ""
		
		If IsInUse\TrackBarGadget
			
			Replacement = "<!-- jquery.ui.slider.pips (https://github.com/simeydotme/jQuery-ui-Slider-Pips)  -->" + #CRLF$ + #TAB$ + 
			              GetStyleTag ("libraries/jquery.ui.slider.pips/jquery-ui-slider-pips.css") + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/jquery.ui.slider.pips/jquery-ui-slider-pips.js")
			
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #jqueryuisliderpips# -->", Replacement)
		
		; ----------------
		
		Replacement = ""
		
		If IsInUse\DateTimePicker
			
			Replacement = 	"<!-- datetimepicker (http://trentrichardson.com/examples/timepicker/) -->" + #CRLF$ + #TAB$ + 
			              	GetStyleTag ("libraries/jquery.timepicker/jquery-ui-timepicker-addon.min.css") + #CRLF$ + #TAB$ + 
			              	GetScriptTag("libraries/jquery.timepicker/jquery-ui-timepicker-addon.min.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #datetimepicker# -->", Replacement)
		
		; ----------------
		
		Replacement = ""
		
		If IsInUse\GoogleMap
			
			Replacement = "<!-- GoogleMap (https://developers.google.com/maps/) -->" + #CRLF$ + #TAB$ + 
			              "<script src='https://maps.googleapis.com/maps/api/js' type='text/javascript'></script>" + #CRLF$ + #TAB$ + 
			              GetScriptTag("userlibraries/google-maps-utility-library/markerclusterer/markerclusterer.js") + #CRLF$ + #TAB$ + 
			              GetScriptTag("userlibraries/google-maps-utility-library/keydragzoom/keydragzoom.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #googlemap# -->", Replacement)
		
		; ----------------
		
		Replacement = ""
		
		If IsInUse\BlockUI
			
			Replacement = "<!-- BlockUI (http://malsup.com/jquery/block/) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/jquery.blockUI/jquery.blockUI.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #blockui# -->", Replacement)
		
		; ------------------
		
		Replacement = ""
		
		If IsInUse\CryptoJs
			
			Replacement = "<!-- CryptoJs (https://code.google.com/p/crypto-js/) -->" + #CRLF$ + #TAB$  + 
			              GetScriptTag("libraries/CryptoJS/rollups/sha256.js") + #CRLF$ + #TAB$  + 
			              GetScriptTag("libraries/CryptoJS/rollups/rc4.js") + #CRLF$ + #TAB$  + 
			              GetScriptTag("libraries/CryptoJS/rollups/md5.js") + #CRLF$ + #TAB$  + 
			              GetScriptTag("libraries/CryptoJS/components/enc-base64-min.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #cryptojs# -->", Replacement)
		
		; ------------------
		
		Replacement = ""
		
		If IsInUse\Pixi
			
			Replacement = "<!-- PixiJs (http://www.pixijs.com/) -->" + #CRLF$ + #TAB$  + 
			              GetScriptTag("libraries/pixi/pixi.min.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #pixijs# -->", Replacement)
		
		; ------------------
		
		Replacement = ""
		
		If IsInUse\Menu
			
			Replacement = "<!-- Menubar -->" + #CRLF$ + #TAB$  + 
			              GetStyleTag("libraries/jquery.ui.menubar/jquery.ui.menubar.css") + #CRLF$ + #TAB$  + 
			              GetScriptTag("libraries/jquery.ui.menubar/jquery.ui.menubar.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #menubar# -->", Replacement)
		
		; ----------------
		
		Replacement = ""
		
		If IsInUse\PDF
			
			Replacement = "<!-- jsPDF (https://github.com/MrRio/jsPDF) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/jsPDF/jspdf.debug.js") + #CRLF$ + #TAB$ +
			              "<!-- html2canvas (http://html2canvas.hertzen.com/) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/html2canvas/html2canvas.js") + #CRLF$
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #pdf# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\GoogleChart
    
			Replacement = "<!-- GoogleChart (https://developers.google.com/chart/) -->" + #CRLF$ + #TAB$ + 
			              "<script type='text/javascript' src='https://www.google.com/jsapi'></script>" + #CRLF$ + #TAB$ + 
			              "<script type='text/javascript'>" + #CRLF$ + #TAB$ + 
			              "google.charts.load('current', {'packages':['map']})" + #CRLF$ + #TAB$ + 
			              "</script>"
			
			
			Replacement = "<!-- GoogleChart (https://developers.google.com/chart/) -->" + #CRLF$ + #TAB$ + 
			              "<script type='text/javascript' src='https://www.google.com/jsapi'></script>" + #CRLF$ + #TAB$ + 
			              "<script type='text/javascript'>" + #CRLF$ + #TAB$ + 
			              "google.load('visualization', '1', {'packages':['map']});" + #CRLF$ + #TAB$ + 
			              "</script>"
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #googlechart# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\JsCookie
			
			Replacement = "<!-- JavaScript Cookie (https://github.com/js-cookie/js-cookie) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/js.cookie/js.cookie.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #jscookie# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\w2ui
			
			Replacement = "<!-- w2ui (http://w2ui.com) -->" + #CRLF$ + #TAB$ + 
			              GetStyleTag("libraries/w2ui/w2ui.min.css") + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/w2ui/w2ui.min.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #w2ui# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\TouchSwipe
			
			Replacement = "<!-- TouchSwipe (https://github.com/mattbryson/TouchSwipe-Jquery-Plugin) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/jquery.touchSwipe/jquery.touchSwipe.min.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #touchswipe# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\Database
			
			Replacement = "<!-- alasql (https://github.com/agershun/alasql) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/alasql/alasql.min.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #database# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\Splitter
			
			Replacement = "<!-- jquery.splitter (https://github.com/jcubic/jquery.splitter) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/jquery.splitter/jquery.splitter.js") + #CRLF$ + #TAB$ + 
			              GetStyleTag("libraries/jquery.splitter/jquery.splitter.css")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #jquerysplitter# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\XML
			
			Replacement = "<!-- jQuery XPath plugin: https://github.com/ilinsky/jquery-xpath -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/jquery.xpath/jquery.xpath.js") + #CRLF$ + #TAB$ + 
			              "<!-- JavaScript XML/XSLT library: http://jsxml.net/ -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/jsxml/jsxmlstand.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #xml# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\ColorRequester
			
			Replacement = "<!-- evol.colorpicker: http://evoluteur.github.io/colorpicker/ -->" + #CRLF$ + #TAB$ + 
			              GetStyleTag("libraries/evol.colorpicker/css/evol-colorpicker.min.css") + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/evol.colorpicker/js/evol-colorpicker.min.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #colorpicker# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\FileSaver Or IsInUse\SaveImage
			
			Replacement = "<!-- FileSaver & Co (https://github.com/eligrey) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/Blob.js/Blob.js") + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/canvas-toBlob.js/canvas-toBlob.js") + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/FileSaver.js/FileSaver.min.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #filesaver# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\KeyboardShortcut
			
			Replacement = "<!-- jQuery.Hotkeys (https://github.com/jeresig/jquery.hotkeys) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/jquery.hotkeys/jquery.hotkeys.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #jqueryhotkeys# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\Preference
			
			Replacement = "<!-- jStorage (http://www.jstorage.info/) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/jStorage/jStorage.min.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #jstorage# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\Cordova
			
			Replacement = "<!-- Cordova (http://cordova.apache.org/) -->" + #CRLF$ + #TAB$ + 
			              "<script type='text/javascript' src='cordova.js'></script>"
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #cordova# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\TriState
			
			Replacement = "<!-- jQuery Tristate (https://github.com/vanderlee/tristate) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/jquery.tristate.js/jquery.tristate.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #tristate# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\Websocket
			
			Replacement = "<!-- Websocket (https://github.com/clickalicious/jQuery.WebSocket) -->" + #CRLF$ + #TAB$ + 
			              GetScriptTag("libraries/jquery.websocket/jquery.WebSocket.js")
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #websocket# -->", Replacement)
		
		; ----
		
		Replacement = "<!-- isMobile (https://github.com/kaimallea/isMobile) -->" + #CRLF$ + #TAB$ + 
		              GetScriptTag("libraries/isMobile/isMobile.min.js")
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #ismobile# -->", Replacement)
		
		; ----
		
		Replacement = "<!-- Numeral.js (http://numeraljs.com/) -->" + #CRLF$ + #TAB$ + 
		              GetScriptTag("libraries/numeral/numeral.min.js")
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #numeral# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\FontAwesome
			
			Replacement = "<!-- Font Awesome (https://fortawesome.github.io/Font-Awesome/) -->" + #CRLF$ + #TAB$ + 
			              "<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css'>"
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #fontawesome# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\Bootstrap
			
			Replacement = "<!-- Bootstrap (http://getbootstrap.com/) -->" + #CRLF$ + #TAB$ + 
			              "<link href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.5/css/bootstrap.min.css' rel='stylesheet' integrity='sha256-MfvZlkHCEqatNoGiOXveE8FIwMzZg4W85qfrfIFBfYc= sha512-dTfge/zgoMYpP7QbHy4gWMEGsbsdZeCXz7irItjcC3sPUFtf0kuFbDz/ixG7ArTxmDjLXDmezHubeNikyKGVyQ==' crossorigin='anonymous'>" + #CRLF$ + #TAB$ + 
			              "<script src='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.5/js/bootstrap.min.js' integrity='sha256-Sk3nkD6mLTMOF0EOpNtsIry+s1CsaqQC1rVLTAy+0yc= sha512-K1qjQ+NcF2TYO/eI3M6v8EiNYZfA95pQumfvcVrTHtwQVDG+aHRqLi/ETn2uB+1JqwYqVG3LIvdm9lj6imS/pQ==' crossorigin='anonymous'></script>"  	              
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #bootstrap# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		If IsInUse\MonacoEditor
			
			Replacement = "<!-- Monaco-Editor -->" + #CRLF$ + #TAB$ + 
			              "<script src='userlibraries/monaco-editor/min/vs/loader.js'></script>"
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #monacoeditor# -->", Replacement)
		
		; ----
		
		Replacement = ""
		
		Replacement = "<!-- jQuery BinaryTransport (https://github.com/henrya/js-jquery/tree/master/BinaryTransport) -->" + #CRLF$ + #TAB$ + 
		              GetScriptTag("libraries/BinaryTransport/jquery.binarytransport.js")
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #binarytransport# -->", Replacement)
		
		; ----
		
		Protected AdditionalScriptsAndStylesheets.s = ""
		
		If CompilerInfo\AdditionalScriptsAndStylesheets <> ""
			
			AdditionalScriptsAndStylesheets = "<!-- Additional Scripts and Stylesheets -->" + #CRLF$ + #TAB$ + 
			                                  CompilerInfo\AdditionalScriptsAndStylesheets
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #additionalscriptsandstylesheets# -->", AdditionalScriptsAndStylesheets)
		
		; ----------------
		
		Protected PB2WebJs.s
		
		If GetEnvironmentVariable("PB_TOOL_Debugger") = "0"
			
			If IsInUse\JQueryMobile
				PB2WebJs = GetScriptTag("libraries/pb2web/pb2web.mobile.min.js?rnd=" + Str(ElapsedMilliseconds()))
			Else
				PB2WebJs = GetScriptTag("libraries/pb2web/pb2web.min.js?rnd=" + Str(ElapsedMilliseconds()))
			EndIf
			
		Else ;
			
			If IsInUse\JQueryMobile
				PB2WebJs = GetScriptTag("libraries/pb2web/pb2web.mobile.js?rnd=" + Str(ElapsedMilliseconds()))
			Else
				PB2WebJs = GetScriptTag("libraries/pb2web/pb2web.debug.js?rnd=" + Str(ElapsedMilliseconds()))
			EndIf
			
		EndIf
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #pb2web# -->", PB2WebJs )
		
		; ----------------
		
		IndexHtml = ReplaceString(IndexHtml, "<!-- #application# -->", GetScriptTag(CompilerInfo\ApplicationName + ".js?rnd=" + Str(ElapsedMilliseconds())))
		
		While FindString(IndexHtml, #TAB$ + #CRLF$)
			IndexHtml = RemoveString(IndexHtml, #TAB$ + #CRLF$)
		Wend	
		
		; ----
		
		If Not(CompilerInfo\DoNotCopy)
			SaveTextFile(IndexHtml, CompilerInfo\TargetFolder + "index.html", Encoding)
		EndIf
		
		If TempFileName <> "" : DeleteFile(TempFileName) : EndIf
		
		Break 
		
	ForEver
	
	; ShitHappend = #True
	
	If ShitHappend
		
		AddLog("")
		AddLog("something went wrong! :-(")
		AddLog("")
		
	Else
		
		If CompilerInfo\AfterConvertingStartDefaultBrowser = 1
			AddLog("Running " + CompilerInfo\ServerAddress + "...")
			RunProgram(CompilerInfo\ServerAddress)
			
		ElseIf CompilerInfo\AfterConvertingStartSpecificBrowser = 1
			RunProgram(Chr(34) + CompilerInfo\AfterConvertingSpecificBrowser + Chr(34), CompilerInfo\ServerAddress, "")
			
		EndIf
		
		GlobalQuit = #True
		
	EndIf
	
EndProcedure

OpenfrmMain()

#frmMain_Shortcut_Escape_Event = 0

SetGadgetText(#frmMain_txtProgramVersion,	"Version " + #Version)

CompilerSelect #PB_Compiler_OS
	CompilerCase #PB_OS_Windows
		SetWindowLongPtr_(GadgetID(#frmMain_Log), #GWL_STYLE, GetWindowLongPtr_(GadgetID(#frmMain_Log), #GWL_STYLE)|#LVS_NOCOLUMNHEADER)
CompilerEndSelect

WindowBounds(#frmMain, 448, 400, #PB_Ignore, #PB_Ignore)

AddKeyboardShortcut(#frmMain, #PB_Shortcut_Escape, #frmMain_Shortcut_Escape_Event)

BindEvent(#PB_Event_SizeWindow, @ResizeGadgetsfrmMain(), #frmMain)

Define ActionThread

ActionThread = CreateThread(@Action(), 42)

Define WWE

Repeat
	
	WWE = WaitWindowEvent(100)
	
	Select WWE
			
		Case #PB_Event_Menu
			Select EventMenu()
				Case #frmMain_Shortcut_Escape_Event
					If Not IsThread(ActionThread)
						Break
					EndIf
			EndSelect
			
		Case #PB_Event_Gadget
			Select EventGadget()
				Case #frmMain_imgLogo
					RunProgram("http://pb2web.de")
				Case #frmMain_Log
					Select EventType()
						Case #AddLog
							
							Define LogMessage.s = PeekS(EventData())
							
							AddGadgetItem(#frmMain_Log, -1, LogMessage)
							
							If FindString(LogMessage, "Error: ")
								SetGadgetItemColor(#frmMain_Log, CountGadgetItems(#frmMain_Log) - 1, #PB_Gadget_FrontColor, RGB(255, 0, 0))
							EndIf
							
							FreeMemory(EventData())
							
							SetGadgetState(#frmMain_Log, CountGadgetItems(#frmMain_Log) - 1)
							
							CompilerSelect #PB_Compiler_OS
								CompilerCase #PB_OS_Windows
									SendMessage_(GadgetID(#frmMain_Log), #LVM_SETCOLUMNWIDTH, 0, #LVSCW_AUTOSIZE_USEHEADER)
							CompilerEndSelect
							
					EndSelect
			EndSelect
			
			
		Case #PB_Event_CloseWindow
			Break
			
		Default
			
			If GlobalQuit = #True
				Break
			EndIf
			
	EndSelect
	
ForEver


; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 36
; Folding = D+
; EnableThread
; EnableXP
; UseIcon = gfx\favicon.ico
; Executable = Pb2Web.exe
; IncludeVersionInfo
; VersionField0 = 2015.05.04
; VersionField1 = 2015.05.04
; VersionField2 = tuebbentools
; VersionField3 = PB2Web
; VersionField4 = 2015.05.04
; VersionField5 = 2015.05.04
; VersionField6 = A PureBasic to JavaScript-Converter
; VersionField7 = PB2Web
; VersionField8 = PB2Web
; VersionField13 = tuebben@gmail.com
; VersionField14 = http://pb2web.de/
; EnableUnicode