XIncludeFile "..\functions.pbi"
XIncludeFile "..\profiles.pbi"

XIncludeFile "ProfileSelector.pbf"

EnableExplicit

#APPNAME = "ProfileSelector"
#Version = "2016-08-11"

Global IniPath.s = GetAppDataPath("tuebbentools", "PB2Web") + "PB2Web.ini"

If  FileSize(GetExePath() + "PB2Web.ini")
	RenameFile(GetExePath() + "PB2Web.ini", IniPath)
EndIf

Enumeration #PB_Event_FirstCustomValue
  #EventBeginProcessing
  #EventProcessingFinished
EndEnumeration

Enumeration
  #frmProfileSelector_Shortcut_Escape
  #frmProfileSelector_Shortcut_Return
EndEnumeration

Procedure CheckButtons()
  
	Protected Flag
	
	If GetGadgetState(#frmProfileSelector_lstProfiles) = -1
		Flag = #True
	Else
		Flag = #False
	EndIf
	
	DisableGadget(#frmProfileSelector_cmdOK, Flag)
  
EndProcedure

Procedure frmProfileSelector_cmdOK_Event()
  
  If GetGadgetState(#frmProfileSelector_lstProfiles) = -1
    ProcedureReturn 
  EndIf
  
  If CreatePreferences(GetAppDataPath("tuebbentools", "PB2Web") + #AppName + ".ini")
  	WritePreferenceString("SelectedProject", GetGadgetText(#frmProfileSelector_lstProfiles))
  	ClosePreferences()
  EndIf
  
  CloseWindow(#frmProfileSelector)
  
EndProcedure

Procedure frmProfileSelector_cmdCancel_Event()
	
	If CreatePreferences(GetAppDataPath("tuebbentools", "PB2Web") + #AppName + ".ini")
		WritePreferenceString("SelectedProject", "")
		ClosePreferences()
	EndIf

  CloseWindow(#frmProfileSelector)
  
EndProcedure

Procedure frmProfileSelector_cmdManage_Event(Dummy)
  
  RunProgram(Chr(34) + GetExePath() + "ProfileManager.exe" + Chr(34), "", "", #PB_Program_Wait)
  
  PostEvent(#EventProcessingFinished, #frmProfileSelector, 0)
  
EndProcedure

Procedure ChooseProfile()
  
  OpenfrmProfileSelector()
  
  AddKeyboardShortcut(#frmProfileSelector, #PB_Shortcut_Escape, #frmProfileSelector_Shortcut_Escape)
  AddKeyboardShortcut(#frmProfileSelector, #PB_Shortcut_Return, #frmProfileSelector_Shortcut_Return)
  
  ForEach Profile()
    AddGadgetItem(#frmProfileSelector_lstProfiles, -1, Profile()\Name)
  Next
  
  SetGadgetState(#frmProfileSelector_lstProfiles, 0)
  
  SetActiveGadget(#frmProfileSelector_lstProfiles)
  
  CheckButtons()
  
  Protected WWE, Quit
  Protected ManageThread
  
  Repeat
    
    If Not IsWindow(#frmProfileSelector)
      Break
    EndIf
    
    WWE = WaitWindowEvent()
    
    Select WWE
        
      Case #PB_Event_Menu
        
        Select EventMenu()
            
          Case #frmProfileSelector_Shortcut_Return
            frmProfileSelector_cmdOK_Event()
            
          Case #frmProfileSelector_Shortcut_Escape
            frmProfileSelector_cmdCancel_Event()
            
        EndSelect
        
      Case #PB_Event_Gadget
        
        Select EventGadget()
            
          Case #frmProfileSelector_lstProfiles
            CheckButtons()
            
          Case #frmProfileSelector_cmdOK     
            frmProfileSelector_cmdOK_Event()
            
          Case #frmProfileSelector_cmdCancel
            frmProfileSelector_cmdCancel_Event()
            
          Case #frmProfileSelector_cmdManage
            
            DisableGadget(#frmProfileSelector_cmdOK, #True)
            DisableGadget(#frmProfileSelector_cmdCancel, #True)
            DisableGadget(#frmProfileSelector_cmdManage, #True)
            DisableGadget(#frmProfileSelector_lstProfiles, #True)
            
            ManageThread = CreateThread(@frmProfileSelector_cmdManage_Event(), 42)
            
        EndSelect
        
      Case #EventProcessingFinished
        
        LoadProfiles(IniPath)
        ClearGadgetItems(#frmProfileSelector_lstProfiles)
        ForEach Profile()
          AddGadgetItem(#frmProfileSelector_lstProfiles, -1, Profile()\Name)
        Next
        
        DisableGadget(#frmProfileSelector_cmdOK, #False)
        DisableGadget(#frmProfileSelector_cmdCancel, #False)
        DisableGadget(#frmProfileSelector_cmdManage, #False)
        DisableGadget(#frmProfileSelector_lstProfiles, #False)
        
        CheckButtons()
        
      Case #PB_Event_CloseWindow
        
        If Not IsThread(ManageThread)
          Quit = #True
        EndIf
        
    EndSelect
    
  Until Quit = #True
  
  
EndProcedure

LoadProfiles(IniPath)

ChooseProfile()


; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 7
; Folding = A-
; EnableXP
; UseIcon = ..\gfx\p2w.ico
; Executable = ..\ProfileSelector.exe
; IncludeVersionInfo
; VersionField0 = 20.15.12.10
; VersionField1 = 20.15.12.10
; VersionField2 = tuebbentools
; VersionField3 = ProfileSelector
; VersionField4 = 2015-12-10
; VersionField5 = 2015-12-10
; VersionField6 = ProfileSelector for PB2Web
; VersionField7 = ProfileSelector
; VersionField8 = ProfileSelector.exe
; VersionField15 = VOS_NT
; VersionField16 = VFT_APP