; DateTimePickerGadget - Include

EnableExplicit

OpenLibrary(#PB_Any, "userlibraries/datetimepicker/jquery.datetimepicker.min.css")
OpenLibrary(#PB_Any, "userlibraries/datetimepicker/jquery.datetimepicker.full.min.js")

Global DateTimePickerGadgetFormat.s = "d.m.Y H:i"

Procedure DateTimePickerGadgetSetLocale(Locale.s)
	! $.datetimepicker.setLocale(Locale);
EndProcedure

Procedure DateTimePickerGadgetSetFormat(Format.s)
	DateTimePickerGadgetFormat = Format
EndProcedure

Procedure DateTimePickerGadget(Gadget, x, y, Width, Height, Date.s, Flags = 0)
	
	! Width = Width - 1;
	! Height = Height - 3;
	
	! Gadget = cCommon.SetGadgetAndStuff(Gadget);

	! var selector = $("<input type='text' />");
	
	! selector.val(Date);
	
	! selector.attr("id", "g_" + Gadget);
	
	! cCommon.CurrentContainer.append(selector);
	
	! selector.addClass("ui-widget ui-widget-content ui-corner-all");

	! selector.datetimepicker({ 
	!		format: DateTimePickerGadgetFormat
	!	});
	
	! cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	
	!	selector.data("GadgetType", "DateTimePickerGadget");
	
; 	!	selector.bind("click", function (event) {
; 	!		cb = selector.data("onLeftClick");
; 	!		if (typeof cb === "function") {
; 	!			if (event.which === 1) {
; 	!				cEvent.eventGadget = Gadget;
; 	!				cEvent.eventType = cConstants.PB_EventType_LeftClick;
; 	!				cb();
; 	!			}
; 	!		}
; 	!	});
; 
; 	!	selector.bind("dblclick", function (event) {
; 	!		cb = selector.data("onLeftDoubleClick");
; 	!		if (typeof cb === "function") {
; 	!			if (event.which === 1) {
; 	!				cEvent.eventGadget = Gadget;
; 	!				cEvent.eventType = cConstants.PB_EventType_LeftDoubleClick;
; 	!				cb();
; 	!			}
; 	!		}
; 	!	});
; 	
; 	!	selector.bind("contextmenu", function (event) {
; 	!		cb = selector.data("onRightClick");
; 	!		if (typeof cb === "function") {
; 	!			event.preventDefault();
; 	!			cEvent.eventGadget = Gadget;
; 	!			cEvent.eventType = cConstants.PB_EventType_RightClick;
; 	!			cb();
; 	!		}
; 	!	});	
; 	
; 	!	selector.bind("input", function (event) {
; 	!		cb = selector.data("onChange");
; 	!		if (typeof cb === "function") {
; 	!			cEvent.eventGadget = Gadget;
; 	!			cEvent.eventType = cConstants.PB_EventType_Change;
; 	!			cb();
; 	!		}
; 	!	});	
	
	! return Gadget;	
	
EndProcedure

Procedure DateTimePickerGadget_GetGadgetText(Gadget)
	!	var selector = $("#g_" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("GetGadgetText");
	! return selector.val();
EndProcedure
RegisterUserGadgetProcedure("DateTimePickerGadget", "GetGadgetText", @DateTimePickerGadget_GetGadgetText())

Procedure DateTimePickerGadget_BindGadgetEvent(Gadget, Callback, EventType)
	
	!	var selector = $("#g_" + Gadget);
	
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("DateTimePickerGadget_BindGadgetEvent");
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_LeftClick |
		            #PB_EventType_LeftDoubleClick |
		            #PB_EventType_RightClick |
		            #PB_EventType_Change |
		            #PB_EventType_Focus |
		            #PB_EventType_LostFocus
		
	EndIf
	
	!	var cb = Callback;
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", cb);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick)) selector.data("onLeftDoubleClick", cb);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick)) selector.data("onRightClick", cb);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change)) selector.data("onChange", cb);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Focus)) selector.data("onFocus", cb);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LostFocus)) selector.data("onLostFocus", cb);
	
EndProcedure
RegisterUserGadgetProcedure("DateTimePickerGadget", "BindGadgetEvent", @DateTimePickerGadget_BindGadgetEvent())

Procedure DateTimePickerGadget_FreeGadget(Gadget)
	!	var selector = $("#" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("FreeGadget");	
	! selector.datetimepicker('destroy');
	! selector.remove();
EndProcedure
RegisterUserGadgetProcedure("DateTimePickerGadget", "FreeGadget", @DateTimePickerGadget_FreeGadget())
; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 98
; FirstLine = 3
; Folding = 8-
; EnableXP