﻿; DeviceGadget

Enumeration
	#PB_Device_Motion = 105
	#PB_Device_Orientation = 106
	
	#PB_EventType_DeviceMotion = 1
	#PB_EventType_DeviceOrientation = 2
EndEnumeration

Procedure DeviceGadget_FreeGadget(Gadget)
	
	! var selector = $("#g_" + Gadget);
	! cGadget.UnbindGadgetEvent(Gadget, selector.data("DeviceMotionCallback"), PB_EventType_DeviceMotion);
	! cGadget.UnbindGadgetEvent(Gadget, selector.data("DeviceOrientationCallback"), PB_EventType_DeviceOrientation);	
	
EndProcedure
RegisterUserGadgetProcedure("DeviceGadget", "FreeGadget", @DeviceGadget_FreeGadget())

Procedure DeviceGadget_BindGadgetEvent(Gadget, Callback, EventType, bind)
	
	! var selector = $("#g_" + Gadget);
	
	! // http://mobiforge.com/design-development/html5-mobile-web-device-orientation-events
	
	If EventType = #PB_All
		EventType = #PB_EventType_DeviceMotion |
		            #PB_EventType_DeviceOrientation;
	EndIf	
	
	If bind
		
		!	if (cCommon.CheckFlag(EventType, PB_EventType_DeviceMotion)) {
		!
		!		selector.data("DeviceMotionCallback", Callback());
		!
		!		window.addEventListener("devicemotion", function (event) {
		!
		!			if (event.acceleration) {
		!				selector.data("AccelerationX", event.acceleration.x);
		!				selector.data("AccelerationY", event.acceleration.y);
		!				selector.data("AccelerationZ", event.acceleration.z);
		!			}
		!
		!			if (event.rotationRate) {
		!				selector.data("RotationRateAlpha", event.rotationRate.alpha);
		!				selector.data("RotationRateBeta", event.rotationRate.beta);
		!				selector.data("RotationRateGamma", event.rotationRate.gamma);
		!			}
		!
		!			cEvent.eventGadget = Gadget;
		!			cEvent.eventType = PB_EventType_DeviceMotion;
		!			Callback();
		!
		!		});
		!
		!	}
		
		!	if (cCommon.CheckFlag(EventType, PB_EventType_DeviceOrientation)) {
		!
		!		selector.data("DeviceOrientationCallback", Callback());
		!
		!		window.addEventListener("deviceorientation", function (event) {
		!			selector.data("OrientationAlpha", event.alpha);
		!			selector.data("OrientationBeta", event.beta);
		!			selector.data("OrientationGamma", event.gamma);
		!			cEvent.eventGadget = Gadget;
		!			cEvent.eventType = PB_EventType_DeviceOrientation;
		!			Callback();
		!		});
		!
		!	}
		
	Else
		
		!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_DeviceMotion)) {
		!		selector.data("DeviceMotionCallback", null);
		!		window.removeEventListener('devicemotion', Callback);
		!	}
		
		!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_DeviceOrientation)) {
		!		selector.data("DeviceOrientationCallback", null);
		!		window.removeEventListener('deviceorientation', Callback);
		!	}
		
	EndIf	
	
EndProcedure
RegisterUserGadgetProcedure("DeviceGadget", "BindGadgetEvent", @DeviceGadget_BindGadgetEvent())

Procedure DeviceGadget_GetGadgetItemText(Gadget, Item, Column)
	
	! var selector = $("#g_" + Gadget);
	
	Select Item
			
		Case #PB_Device_Motion
			
			!	return selector.data("AccelerationX") + ";" +
			!		selector.data("AccelerationY") + ";" +
			!		selector.data("AccelerationZ") + ";" +
			!		selector.data("RotationRateAlpha") + ";" +
			!		selector.data("RotationRateBeta") + ";" +
			!		selector.data("RotationRateGamma");
			
		Case #PB_Device_Orientation
			
			!	return selector.data("OrientationAlpha") + ";" +
			!		selector.data("OrientationBeta") + ";" +
			!		selector.data("OrientationGamma");
			
		Default
			
			! return "";
			
	EndSelect
	
EndProcedure
RegisterUserGadgetProcedure("DeviceGadget", "GetGadgetItemText", @DeviceGadget_GetGadgetItemText())

; ----------------

Procedure DeviceGadget(Gadget, Flags = 0)

!		var Gadget = cCommon.SetGadgetAndStuff(Gadget);
!
!		var selector = $("<div />");
!
!		selector.attr("id", "g_" + Gadget);
!
!		window.addEventListener('devicemotion', null)
!		selector.data("AccelerationX", null);
!		selector.data("AccelerationY", null);
!		selector.data("AccelerationZ", null);
!		selector.data("RotationRateAlpha", null);
!		selector.data("RotationRateBeta", null);
!		selector.data("RotationRateGamma", null);
!
!		selector.data("DeviceOrientationCallback", null);
!		selector.data("OrientationAlpha", null);
!		selector.data("OrientationBeta", null);
!		selector.data("OrientationGamma", null);
!
!		selector.data("GadgetType", "DeviceGadget");
!
!		cCommon.CurrentContainer.append(selector);
!
!		return Gadget;

EndProcedure
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 119
; Folding = x
; EnableUnicode
; EnableXP