﻿; GoogleChart-Include

EnableExplicit

Enumeration
	#GoogleChartGadgetBorder = 1
EndEnumeration

#GoogleChartTypeAnnotation  = "AnnotationChart"
#GoogleChartTypeArea        = "AreaChart"
#GoogleChartTypeBar         = "BarChart"
#GoogleChartTypeBubble      = "BubbleChart"
#GoogleChartTypeCandleStick = "CandlestickChart"
#GoogleChartTypeCalendar    = "Calendar"
#GoogleChartTypeColumn      = "ColumnChart"
#GoogleChartTypeCombo       = "ComboChart"
#GoogleChartTypeGantt       = "Gantt"
#GoogleChartTypeGauge       = "Gauge"
#GoogleChartTypeGeo         = "GeoChart"
#GoogleChartTypeHistogram   = "Histogram"
#GoogleChartTypeLine        = "LineChart"
#GoogleChartTypeMap         = "Map"
#GoogleChartTypeOrg         = "OrgChart"
#GoogleChartTypePie         = "PieChart"
#GoogleChartTypeSankey      = "Sankey"
#GoogleChartTypeScatter     = "ScatterChart"
#GoogleChartTypeSteppedArea = "SteppedAreaChart"
#GoogleChartTypeTable       = "Table"
#GoogleChartTypeTimeline    = "Timeline"
#GoogleChartTypeTreeMap     = "TreeMap"
#GoogleChartTypeWordTree    = "WordTree"

Enumeration
	#GoogleChartGadgetOptions
	#GoogleChartGadgetData
	#GoogleChartGadgetQuery
EndEnumeration

Procedure GoogleChartGadget(Gadget, x, y, Width, Height, ChartType.s = #GoogleChartTypeLine, Flags = 0)
	
	!	var Gadget = cCommon.SetGadgetAndStuff(Gadget);
	
	!	var selector = $("<div />");
	
	!	selector.attr("id", "g_" + Gadget);
	
	!	if (cCommon.CheckFlag(Flags, cConstants.PB_GoogleChart_Border)) {
	!		selector.css("border", "1px solid black");
	!	}
	
	!	cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	
	!	cCommon.CurrentContainer.append(selector);
	
	! var chart = new google.visualization.ChartWrapper ({
	!   chartType: ChartType,
	!   containerId: selector[0].id
	! });
	
	! chart.setOptions( {} );
	! chart.setDataTable( [] );
	
	! selector.data("GoogleChart", chart);
	!	selector.data("GadgetType", "GoogleChartGadget");
	! chart.draw();
	
	!	return Gadget;
	
EndProcedure

Procedure GoogleChartGadget_SetGadgetAttribute(Gadget, Attribute, Value)
	
	!	selector = $("#g_" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("SetGadgetAttribute");
	
	! var chart = selector.data("GoogleChart");
	
	Select Attribute
		Case #GoogleChartGadgetData
			! chart.setDataTable(Value);
		Case #GoogleChartGadgetOptions
			! chart.setOptions($.extend(Value, chart.getOptions()));
		Case #GoogleChartGadgetQuery
			! chart.setQuery(Value);
	EndSelect
	
	! chart.draw();
	
EndProcedure
RegisterUserGadgetProcedure("GoogleChartGadget", "SetGadgetAttribute", @GoogleChartGadget_SetGadgetAttribute())

Procedure.s GoogleChartGadget_GetGadgetItemText(Gadget, Position, Column = 0)
	!	selector = $("#g_" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("GetGadgetItemText");
	! var chart = selector.data("GoogleChart");
	! var dt = chart.getDataTable();
	! return dt.getValue(Position, Column);
EndProcedure
RegisterUserGadgetProcedure("GoogleChartGadget", "GetGadgetItemText", @GoogleChartGadget_GetGadgetItemText())

; ---
; Asorted
; ---

Procedure GoogleChartGadget_GetDataTable(Gadget)
	!	selector = $("#g_" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("GoogleChartGadget_GetDataTable");
	! var chart = selector.data("GoogleChart");
	! return chart.getDataTable();
EndProcedure

Procedure GoogleChartGadget_DataTableAddColumn(DataTable, Text.s, Type.s="string")
	! DataTable.addColumn(Type, Text);
EndProcedure

Procedure GoogleChartGadget_DataTableAddRow(DataTable, JsArray)
	! DataTable.addRow(JsArray);
EndProcedure

Procedure GoogleChartGadget_ClearDataTable(Gadget)
	!	selector = $("#g_" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("GoogleChartGadget_ClearDataTable");
	! var chart = selector.data("GoogleChart");
	! var dt = chart.getDataTable();
	! dt.removeRows(0, dt.getNumberOfRows());
EndProcedure

Procedure GoogleChartGadget_Refresh(Gadget)
	!	selector = $("#g_" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("GoogleChartGadget_Refresh");
	! var chart = selector.data("GoogleChart");
	! chart.draw();
EndProcedure
; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 36
; FirstLine = 15
; Folding = v9
; EnableXP