﻿; jsGrid-Include
; http://js-grid.com/

EnableExplicit

OpenLibrary(#PB_Any, "userlibraries/jsGrid/jsgrid.min.css")
OpenLibrary(#PB_Any, "userlibraries/jsGrid/jsgrid-theme.min.css")
OpenLibrary(#PB_Any, "userlibraries/jsGrid/jsgrid.min.js")

Enumeration
	
	; SetGadgetAttribute
	#JsGrid_Autoload
	#JsGrid_ConfirmDeleting
	#JsGrid_Controller
	#JsGrid_Data
	#JsGrid_DeleteConfirm
	#JsGrid_EditRowRenderer
	#JsGrid_Editing
	#JsGrid_Fields
	#JsGrid_FilterRowRenderer
	#JsGrid_Filtering
	#JsGrid_HeaderRowRenderer
	#JsGrid_Heading
	#JsGrid_InsertRowRenderer
	#JsGrid_Inserting
	#JsGrid_InvalidMessage
	#JsGrid_InvalidNotify
	#JsGrid_LoadIndication
	#JsGrid_LoadIndicationDelay
	#JsGrid_LoadMessage
	#JsGrid_LoadShading
	#JsGrid_NoDataContent
	#JsGrid_PageButtonCount
	#JsGrid_PageFirstText
	#JsGrid_PageIndex
	#JsGrid_PageLastText
	#JsGrid_PageLoading
	#JsGrid_PageNavigatorNextText
	#JsGrid_PageNavigatorPrevText
	#JsGrid_PageNextText
	#JsGrid_PagePrevText
	#JsGrid_PageSize
	#JsGrid_PagerContainer
	#JsGrid_PagerFormat
	#JsGrid_PagerRenderer
	#JsGrid_Paging
	#JsGrid_RowClass
	#JsGrid_RowRenderer
	#JsGrid_Selecting
	#JsGrid_Sorting
	#JsGrid_UpdateOnResize
	
EndEnumeration

EnumerationBinary
	
	; EventTypes
	
	#JsGrid_EventType_DataLoaded
	#JsGrid_EventType_DataLoading
	#JsGrid_EventType_Error
	#JsGrid_EventType_Init
	#JsGrid_EventType_ItemDeleted
	#JsGrid_EventType_ItemDeleting
	#JsGrid_EventType_ItemInserted
	#JsGrid_EventType_ItemInserting
	#JsGrid_EventType_ItemInvalid
	#JsGrid_EventType_ItemUpdated
	#JsGrid_EventType_ItemUpdating
	#JsGrid_EventType_OptionChanged
	#JsGrid_EventType_OptionChanging
	#JsGrid_EventType_PageChanged
	#JsGrid_EventType_Refreshed
	#JsGrid_EventType_Refreshing
	#JsGrid_EventType_RowClick
	#JsGrid_EventType_RowDoubleClick
	
EndEnumeration

Procedure JsGridGadget(Gadget, x, y, Width, Height)
	
	If Gadget = #PB_Any
		Gadget = ContainerGadget(Gadget, x, y, Width, Height)
	Else
		ContainerGadget(Gadget, x, y, Width, Height)
	EndIf
	
	CloseGadgetList()
	
	Protected cb
	
	!	selector = $("#g_" + Gadget);	
	
	!	selector.data("GadgetType", "JsGridGadget");
	
	! selector.jsGrid({
	
	!   width: "100%",
	!   height: "100%",
	
	!   onDataLoading: function(e) { // before controller.loadData
	!			cb = selector.data("onDataLoading");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_DataLoading; cb(e); }
	!   },
	!   onDataLoaded: function(e) { // on done of controller.loadData
	!			cb = selector.data("onDataLoaded");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_DataLoaded; cb(e); }
	!   },
	!   onError: function(e) { // on fail of any controller call
	!			cb = selector.data("onError");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_Error; cb(e); }
	!   },
	!   onInit: function(e) { // after grid initialization
	!			cb = selector.data("onInit");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_Init; cb(e); }
	!   },
	!   onItemInserting: function(e) { // before controller.insertItem
	!			cb = selector.data("onItemInserting");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_ItemInserting; cb(e); }
	!   },
	!   onItemInserted: function(e) { // on done of controller.insertItem
	!			cb = selector.data("onItemInserted");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_ItemInserted; cb(e); }
	!   },
	!   onItemUpdating: function(e) { // before controller.updateItem
	!			cb = selector.data("onItemUpdating");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_ItemUpdating; cb(event); }
	!   },
	!   onItemUpdated: function(e) { // on done of controller.updateItem
	!			cb = selector.data("onItemUpdated");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_ItemUpdated; cb(e); }
	!   },
	!   onItemDeleting: function(e) { // before controller.deleteItem
	!			cb = selector.data("onItemDeleting");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_ItemDeleting; cb(e); }
	!   },
	!   onItemDeleted: function(e) { // on done of controller.deleteItem
	!			cb = selector.data("onItemDeleted");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_ItemDeleted; cb(e); }
	!   },
	!   onItemInvalid: function(e) { // after item validation, in case data is invalid
	!			cb = selector.data("onItemInvalid");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_ItemInvalid; cb(e); }
	!   },
	!   onOptionChanging: function(e) { // before changing the grid option
	!			cb = selector.data("onOptionChanging");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_OptionChanging; cb(e); }
	!   },
	!   onOptionChanged: function(e) { // after changing the grid option
	!			cb = selector.data("onOptionChanged");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_OptionChanged; cb(e); }
	!   },
	!   onPageChanged: function(e) { // after changing the current page
	!			cb = selector.data("onPageChanged");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_PageChanged; cb(e); }
	!   },
	!   onRefreshing: function(e) { // before grid refresh
	!			cb = selector.data("onRefreshing");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_Refreshing; cb(e); }
	!   },
	!   onRefreshed: function(e) { // after grid refresh
	!			cb = selector.data("onRefreshed");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_Refreshed; cb(e); }
	!   },
	
	!   rowClick: function(e) { // click-event
	!			cb = selector.data("onRowClick");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_RowClick; cb(e); }
	!   },
	!   rowDoubleClick: function(e) { // doubleclick-event
	!			cb = selector.data("onRowDoubleClick");
	!			if (typeof cb == 'function') { cEvent.eventGadget = Gadget; cEvent.eventType = JsGrid_EventType_RowDoubleClick; cb(e); }
	!   }
	
	! });	
	
	ProcedureReturn Gadget	
	
EndProcedure

Procedure JsGridGadget_GetGadgetAttribute(Gadget, Attribute)
	
	Protected selector
	
	!	selector = $("#g_" + Gadget);	
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("SetGadgetAttribute");
	
	If selector
		
		Select Attribute
				
			Case #JsGrid_Fields
				! return selector.jsGrid("option", "fields");
			Case #JsGrid_Data
				! return selector.jsGrid("option", "data");
			Case #JsGrid_Autoload
				! return selector.jsGrid("option", "autoload");
			Case #JsGrid_Controller
				! return selector.jsGrid("option", "controller");
			Case #JsGrid_Heading
				! return selector.jsGrid("option", "heading");
			Case #JsGrid_Filtering
				! return selector.jsGrid("option", "filtering");
			Case #JsGrid_Inserting
				! return selector.jsGrid("option", "inserting");
			Case #JsGrid_Editing
				! return selector.jsGrid("option", "editing");
			Case #JsGrid_Selecting
				! return selector.jsGrid("option", "selecting");
			Case #JsGrid_Sorting
				! return selector.jsGrid("option", "sorting");
			Case #JsGrid_Paging
				! return selector.jsGrid("option", "paging");
			Case #JsGrid_PageLoading
				! return selector.jsGrid("option", "pageLoading");
			Case #JsGrid_RowClass
				! return selector.jsGrid("option", "rowClass");
			Case #JsGrid_ConfirmDeleting
				! return selector.jsGrid("option", "confirmDeleting");
			Case #JsGrid_PagerContainer
				! return selector.jsGrid("option", "pagerContainer");
			Case #JsGrid_PageIndex
				! return selector.jsGrid("option", "pageIndex");
			Case #JsGrid_PageSize
				! return selector.jsGrid("option", "pageSize");
			Case #JsGrid_PageButtonCount
				! return selector.jsGrid("option", "pageButtonCount");
			Case #JsGrid_InvalidNotify
				! return selector.jsGrid("option", "invalidNotify");
			Case #JsGrid_LoadIndication
				! return selector.jsGrid("option", "loadIndication");
			Case #JsGrid_LoadIndicationDelay
				! return selector.jsGrid("option", "loadIndicationDelay");
			Case #JsGrid_LoadShading
				! return selector.jsGrid("option", "loadShading");
			Case #JsGrid_UpdateOnResize
				! return selector.jsGrid("option", "updateOnResize");
			Case #JsGrid_RowRenderer
				! return selector.jsGrid("option", "rowRenderer");
			Case #JsGrid_HeaderRowRenderer
				! return selector.jsGrid("option", "headerRowRenderer");
			Case #JsGrid_FilterRowRenderer
				! return selector.jsGrid("option", "filterRowRenderer");
			Case #JsGrid_InsertRowRenderer
				! return selector.jsGrid("option", "insertRowRenderer");
			Case #JsGrid_EditRowRenderer
				! return selector.jsGrid("option", "editRowRenderer");
			Case #JsGrid_PagerRenderer
				! return selector.jsGrid("option", "pagerRenderer");
			Case #JsGrid_NoDataContent
				! return selector.jsGrid("option", "noDataContent");
			Case #JsGrid_DeleteConfirm
				! return selector.jsGrid("option", "deleteConfirm");
			Case #JsGrid_PagerFormat
				! return selector.jsGrid("option", "pagerFormat");
			Case #JsGrid_PageNextText
				! return selector.jsGrid("option", "pageNextText");
			Case #JsGrid_PagePrevText
				! return selector.jsGrid("option", "pagePrevText");
			Case #JsGrid_PageFirstText
				! return selector.jsGrid("option", "pageFirstText");
			Case #JsGrid_PageLastText
				! return selector.jsGrid("option", "pageLastText");
			Case #JsGrid_PageNavigatorNextText
				! return selector.jsGrid("option", "pageNavigatorNextText");
			Case #JsGrid_PageNavigatorPrevText
				! return selector.jsGrid("option", "pageNavigatorPrevText");
			Case #JsGrid_InvalidMessage
				! return selector.jsGrid("option", "invalidMessage");
			Case #JsGrid_LoadMessage
				! return selector.jsGrid("option", "loadMessage");				
				
			Default
				Debug "Unknown Attribute"
				
		EndSelect
		
	EndIf
EndProcedure
RegisterUserGadgetProcedure("JsGridGadget", "GetGadgetAttribute", @JsGridGadget_GetGadgetAttribute())

Procedure JsGridGadget_SetGadgetAttribute(Gadget, Attribute, Value)
	
	Protected selector
	
	!	selector = $("#g_" + Gadget);	
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("SetGadgetAttribute");
	
	If selector
		
		Select Attribute
				
			Case #JsGrid_Fields
				! selector.jsGrid("option", "fields", Value);
			Case #JsGrid_Data
				! selector.jsGrid("option", "data", Value);
			Case #JsGrid_Autoload
				! selector.jsGrid("option", "autoload", Value);
			Case #JsGrid_Controller
				! selector.jsGrid("option", "controller", Value);
			Case #JsGrid_Heading
				! selector.jsGrid("option", "heading", Value);
			Case #JsGrid_Filtering
				! selector.jsGrid("option", "filtering", Value);
			Case #JsGrid_Inserting
				! selector.jsGrid("option", "inserting", Value);
			Case #JsGrid_Editing
				! selector.jsGrid("option", "editing", Value);
			Case #JsGrid_Selecting
				! selector.jsGrid("option", "selecting", Value);
			Case #JsGrid_Sorting
				! selector.jsGrid("option", "sorting", Value);
			Case #JsGrid_Paging
				! selector.jsGrid("option", "paging", Value);
			Case #JsGrid_PageLoading
				! selector.jsGrid("option", "pageLoading", Value);
			Case #JsGrid_RowClass
				! selector.jsGrid("option", "rowClass", Value);
			Case #JsGrid_ConfirmDeleting
				! selector.jsGrid("option", "confirmDeleting", Value);
			Case #JsGrid_PagerContainer
				! selector.jsGrid("option", "pagerContainer", Value);
			Case #JsGrid_PageIndex
				! selector.jsGrid("option", "pageIndex", Value);
			Case #JsGrid_PageSize
				! selector.jsGrid("option", "pageSize", Value);
			Case #JsGrid_PageButtonCount
				! selector.jsGrid("option", "pageButtonCount", Value);
			Case #JsGrid_InvalidNotify
				! selector.jsGrid("option", "invalidNotify", Value);
			Case #JsGrid_LoadIndication
				! selector.jsGrid("option", "loadIndication", Value);
			Case #JsGrid_LoadIndicationDelay
				! selector.jsGrid("option", "loadIndicationDelay", Value);
			Case #JsGrid_LoadShading
				! selector.jsGrid("option", "loadShading", Value);
			Case #JsGrid_UpdateOnResize
				! selector.jsGrid("option", "updateOnResize", Value);
			Case #JsGrid_RowRenderer
				! selector.jsGrid("option", "rowRenderer", Value);
			Case #JsGrid_HeaderRowRenderer
				! selector.jsGrid("option", "headerRowRenderer", Value);
			Case #JsGrid_FilterRowRenderer
				! selector.jsGrid("option", "filterRowRenderer", Value);
			Case #JsGrid_InsertRowRenderer
				! selector.jsGrid("option", "insertRowRenderer", Value);
			Case #JsGrid_EditRowRenderer
				! selector.jsGrid("option", "editRowRenderer", Value);
			Case #JsGrid_PagerRenderer
				! selector.jsGrid("option", "pagerRenderer", Value);
			Case #JsGrid_NoDataContent
				! selector.jsGrid("option", "noDataContent", Value);
			Case #JsGrid_DeleteConfirm
				! selector.jsGrid("option", "deleteConfirm", Value);
			Case #JsGrid_PagerFormat
				! selector.jsGrid("option", "pagerFormat", Value);
			Case #JsGrid_PageNextText
				! selector.jsGrid("option", "pageNextText", Value);
			Case #JsGrid_PagePrevText
				! selector.jsGrid("option", "pagePrevText", Value);
			Case #JsGrid_PageFirstText
				! selector.jsGrid("option", "pageFirstText", Value);
			Case #JsGrid_PageLastText
				! selector.jsGrid("option", "pageLastText", Value);
			Case #JsGrid_PageNavigatorNextText
				! selector.jsGrid("option", "pageNavigatorNextText", Value);
			Case #JsGrid_PageNavigatorPrevText
				! selector.jsGrid("option", "pageNavigatorPrevText", Value);
			Case #JsGrid_InvalidMessage
				! selector.jsGrid("option", "invalidMessage", Value);
			Case #JsGrid_LoadMessage
				! selector.jsGrid("option", "loadMessage", Value);				
				
			Default
				Debug "Unknown Attribute"
				
		EndSelect
		
		! selector.jsGrid("refresh");
		
	EndIf
EndProcedure
RegisterUserGadgetProcedure("JsGridGadget", "SetGadgetAttribute", @JsGridGadget_SetGadgetAttribute())

Procedure JsGridGadget_BindGadgetEvent(Gadget, Callback, EventType = #PB_All)
	
	! var selector = $("#g_" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("BindGadgetEvent");
	
	If EventType = #PB_All
		
		EventType = #JsGrid_EventType_DataLoaded |
		            #JsGrid_EventType_DataLoading |
		            #JsGrid_EventType_Error |
		            #JsGrid_EventType_Init |
		            #JsGrid_EventType_ItemDeleted |
		            #JsGrid_EventType_ItemDeleting |
		            #JsGrid_EventType_ItemInserted |
		            #JsGrid_EventType_ItemInserting |
		            #JsGrid_EventType_ItemInvalid |
		            #JsGrid_EventType_ItemUpdated |
		            #JsGrid_EventType_ItemUpdating |
		            #JsGrid_EventType_OptionChanged |
		            #JsGrid_EventType_OptionChanging |
		            #JsGrid_EventType_PageChanged |
		            #JsGrid_EventType_Refreshed |
		            #JsGrid_EventType_Refreshing |
		            #JsGrid_EventType_RowClick |
		            #JsGrid_EventType_RowDoubleClick
		
	EndIf
	
	!	var cb = Callback;
	
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_DataLoaded))     selector.data("onDataLoaded", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_DataLoading))    selector.data("onDataLoading", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_Error))          selector.data("onError", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_Init))           selector.data("onInit", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemDeleted))    selector.data("onItemDeleted", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemDeleting))   selector.data("onItemDeleting", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemInserted))   selector.data("onItemInserted", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemInserting))  selector.data("onItemInserting", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemInvalid))    selector.data("onItemInvalid", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemUpdated))    selector.data("onItemUpdated", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemUpdating))   selector.data("onItemUpdating", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_OptionChanged))  selector.data("onOptionChanged", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_OptionChanging)) selector.data("onOptionChanging", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_PageChanged))    selector.data("onPageChanged", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_Refreshed))      selector.data("onRefreshed", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_Refreshing))     selector.data("onRefreshing", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_RowClick))       selector.data("onRowClick", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_RowDoubleClick)) selector.data("onRowDoubleClick", cb);
	
EndProcedure
RegisterUserGadgetProcedure("JsGridGadget", "BindGadgetEvent", @JsGridGadget_BindGadgetEvent())

Procedure JsGridGadget_UnbindGadgetEvent(Gadget, Callback, EventType = #PB_All)
	
	! var selector = $("#g_" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("BindGadgetEvent");
	
	If EventType = #PB_All
		
		EventType = #JsGrid_EventType_DataLoaded |
		            #JsGrid_EventType_DataLoading |
		            #JsGrid_EventType_Error |
		            #JsGrid_EventType_Init |
		            #JsGrid_EventType_ItemDeleted |
		            #JsGrid_EventType_ItemDeleting |
		            #JsGrid_EventType_ItemInserted |
		            #JsGrid_EventType_ItemInserting |
		            #JsGrid_EventType_ItemInvalid |
		            #JsGrid_EventType_ItemUpdated |
		            #JsGrid_EventType_ItemUpdating |
		            #JsGrid_EventType_OptionChanged |
		            #JsGrid_EventType_OptionChanging |
		            #JsGrid_EventType_PageChanged |
		            #JsGrid_EventType_Refreshed |
		            #JsGrid_EventType_Refreshing |
		            #JsGrid_EventType_RowClick |
		            #JsGrid_EventType_RowDoubleClick
		
	EndIf
	
	!	var cb = null;
	
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_DataLoaded))     selector.data("onDataLoaded", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_DataLoading))    selector.data("onDataLoading", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_Error))          selector.data("onError", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_Init))           selector.data("onInit", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemDeleted))    selector.data("onItemDeleted", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemDeleting))   selector.data("onItemDeleting", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemInserted))   selector.data("onItemInserted", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemInserting))  selector.data("onItemInserting", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemInvalid))    selector.data("onItemInvalid", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemUpdated))    selector.data("onItemUpdated", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_ItemUpdating))   selector.data("onItemUpdating", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_OptionChanged))  selector.data("onOptionChanged", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_OptionChanging)) selector.data("onOptionChanging", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_PageChanged))    selector.data("onPageChanged", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_Refreshed))      selector.data("onRefreshed", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_Refreshing))     selector.data("onRefreshing", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_RowClick))       selector.data("onRowClick", cb);
	!	if (cCommon.CheckFlag(EventType, JsGrid_EventType_RowDoubleClick)) selector.data("onRowDoubleClick", cb);
	
EndProcedure
RegisterUserGadgetProcedure("JsGridGadget", "UnbindGadgetEvent", @JsGridGadget_UnbindGadgetEvent())

Procedure JsGridGadget_FreeGadget(Gadget)
	
	! var selector = $("#" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("FreeGadget");
	! selector.jsGrid("destroy");
	!	selector.remove();
	
EndProcedure
RegisterUserGadgetProcedure("JsGridGadget", "FreeGadget", @JsGridGadget_FreeGadget())

Procedure JsGridGadget_ResizeGadget(Gadget, x, y, Width, Height)
	
	! var selector = $("#g_" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("ResizeGadget");
	
	!	if (x !== cConstants.PB_Ignore) selector.css("left", x);
	!	if (y !== cConstants.PB_Ignore) selector.css("top", y);
	!	if (Width !== cConstants.PB_Ignore) selector.css("width", Width);	
	!	if (Height !== cConstants.PB_Ignore) selector.css("height", Height);	
	
	! selector.jsGrid("refresh");
	
EndProcedure
RegisterUserGadgetProcedure("JsGridGadget", "ResizeGadget", @JsGridGadget_ResizeGadget())

; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 20
; Folding = R5
; EnableXP