﻿
; LeafletGadget-Include

; http://leafletjs.com/

EnableExplicit

#PB_Leaflet_Border = 1

OpenLibrary(#PB_Any, "userlibraries/Leaflet/leaflet.css")
OpenLibrary(#PB_Any, "userlibraries/Leaflet/leaflet.js")

Procedure LeafletGadget_ResizeGadget(Gadget, x, y, Width, Height)
	
	! var selector = $("#g_" + Gadget);
	
	!	if (x !== cConstants.PB_Ignore) selector.css("left", x);
	!	if (y !== cConstants.PB_Ignore) selector.css("top", y);
	!	if (Width !== cConstants.PB_Ignore) selector.css("width", Width);	
	!	if (Height !== cConstants.PB_Ignore) selector.css("height", Height);	
	
	! var map = selector.data("leafletmap");
	! map.invalidateSize();
	
EndProcedure
RegisterUserGadgetProcedure("LeafletGadget", "ResizeGadget", @LeafletGadget_ResizeGadget())

Procedure LeafletGadget(Gadget, x, y, Width, Height, Flags = 0)
	
	!	var Gadget = cCommon.SetGadgetAndStuff(Gadget);
	!	var selector = $("<div />");
	!	selector.attr("id", "g_" + Gadget);
	
	!	if (cCommon.CheckFlag(Flags, PB_Leaflet_Border)) {
	!		selector.css("border", "1px solid black");
	!	}
	
	!	cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	
	!	cCommon.CurrentContainer.append(selector);
	
	! var map = L.map('map').setView([51.505, -0.09], 13);

	! L.tileLayer('http://{s}.tile.osm.org/{z}/{x}/{y}.png', {
	!     attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
	! }).addTo(map);

	! L.marker([51.5, -0.09]).addTo(map)
	!     .bindPopup('A pretty CSS3 popup.<br> Easily customizable.')
	!     .openPopup();	
	
	! selector.data("leafletmap", map);
	
	
	!	selector.data("GadgetType", "LeafletGadget");
	
	!	return Gadget;	
	
EndProcedure

; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 42
; FirstLine = 3
; Folding = -
; EnableXP
; EnableUnicode