﻿Procedure SplitButtonGadget_BindGadgetEvent(Gadget, Callback, EventType)

	!		var selector = $("#g_" + Gadget);
	!
	!		if (EventType === cConstants.PB_All) {
	!			EventType = cConstants.PB_EventType_LeftClick;
	!		}
	!
	!		if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) {
	!			$("#g_" + Gadget + "_b1").data("onLeftClick", Callback);
	!			$("#g_" + Gadget + "_m").data("onLeftClick", Callback);
	!		}

EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "BindGadgetEvent", @SplitButtonGadget_BindGadgetEvent())

Procedure SplitButtonGadget_UnbindGadgetEvent(Gadget, Callback, EventType)

	!		var selector = $("#g_" + Gadget);
	!
	!		if (EventType === cConstants.PB_All) {
	!			EventType = cConstants.PB_EventType_LeftClick;
	!		}
	!
	!		if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) {
	!			$("#g_" + Gadget + "_b1").data("onLeftClick", null);
	!			$("#g_" + Gadget + "_m").data("onLeftClick", null);
	!		}

EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "UnbindGadgetEvent", @SplitButtonGadget_UnbindGadgetEvent())

Procedure SplitButtonGadget_AddGadgetItem(Gadget, Position, Text.s, ImageID, Flags)
	
	!	var selector = $("#g_" + Gadget + "_m"); // UL
	!	var liArray = selector.children().toArray();
	!	if (liArray === null) liArray = [];
	!	if (Position === -1) Position = liArray.length;
	
	!	if ($("#i_" + ImageID).attr("src")) {
	!		var Image = "";
	!		var src = $("#i_" + ImageID).attr("src")
	!		// var w = $("#i_" + ImageID).css("width");
	!		// var h = $("#i_" + ImageID).css("height");
	!		// Image = "<img src='" + src + "' style='vertical-align:middle;width:" + w + ";height:" + h + ";' />";
	!		Image = "<img src='" + src + "' style='vertical-align:middle;' />";
	!		Text = Image + "&nbsp;" + Text;
	!	}
	
	!	liArray.splice(Position, 0, "<li>" + Text + "</li>");
	
	!	selector.empty();
	!	selector.append(liArray);
	!	$("#g_" + Gadget + "_m").menu("refresh");
	
EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "AddGadgetItem", @SplitButtonGadget_AddGadgetItem())

Procedure SplitButtonGadget_ClearGadgetItems(Gadget)
	!	var selector = $("#g_" + Gadget + "_m");
	!	selector.empty();
EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "ClearGadgetItems", @SplitButtonGadget_ClearGadgetItems())

Procedure SplitButtonGadget_CountGadgetItems(Gadget)
	!	var selector = $("#g_" + Gadget + "_m");
	!	return selector.children().length;
EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "CountGadgetItems", @SplitButtonGadget_CountGadgetItems())

Procedure SplitButtonGadget_GetGadgetItemText(Gadget, Item)
	!	var selector = $("#g_" + Gadget + "_m");
	!	var liArray = selector.children().toArray();
	!	if (liArray === null || liArray.length === 0) return "";
	!	if (Item < 0) Item = 0;
	!	if (Item > liArray.length - 1) Item = liArray.length - 1;
	!	return $(liArray[Item]).text();
EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "GetGadgetItemText", @SplitButtonGadget_GetGadgetItemText())

Procedure SplitButtonGadget_GetGadgetState(Gadget)
	!	var selectedIndex = $("#g_" + Gadget + "_m").data("selectedItem");
	!	if (selectedIndex !== null) return selectedIndex;
	!	return -1;
EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "GetGadgetState", @SplitButtonGadget_GetGadgetState())

Procedure SplitButtonGadget_GetGadgetText(Gadget)
	!	var selector = $("#g_" + Gadget + "_b1");
	!	return selector.button().text();
EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "GetGadgetText", @SplitButtonGadget_GetGadgetText())

Procedure SplitButtonGadget_RemoveGadgetItem(Gadget, Position)
	!	var selector = $("#g_" + Gadget + "_m"); // UL
	!	var liArray = selector.children().toArray();
	!	if (liArray === null || liArray.length === 0) return;
	!	liArray.splice(Position, 1);
	!	selector.empty();
	!	selector.append(liArray);
	!	$("#g_" + Gadget + "_m").menu("refresh");
EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "RemoveGadgetItem", @SplitButtonGadget_RemoveGadgetItem())

Procedure SplitButtonGadget_ResizeGadget(Gadget, x, y, Width, Height)
	
	!	var selector = $("#g_" + Gadget)
	
	!	if (x !== cConstants.PB_Ignore) selector.css("left", x);
	!	if (y !== cConstants.PB_Ignore) selector.css("top", y);
	!	if (Width !== cConstants.PB_Ignore) selector.css("width", Width);
	!	if (Height !== cConstants.PB_Ignore) selector.css("height", Height);
	
	!	var nw = parseInt($("#g_" + Gadget).css("width")) - parseInt($("#g_" + Gadget + "_b2").css("width"));
	
	!	$("#g_" + Gadget + "_b1").width(nw);
	!	$("#g_" + Gadget + "_m").width($("#g_" + Gadget).width);
	
EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "ResizeGadget", @SplitButtonGadget_ResizeGadget())

Procedure SplitButtonGadget_SetGadgetItemText(Gadget, Item, Text.s, Column)
	
	!	var selector = $("#g_" + Gadget + "_m"); // UL
	!	var liArray = selector.children().toArray();
	!	if (liArray === null || liArray.length === 0) return;
	
	!	if (Item < 0) Item = 0;
	!	if (Item > liArray.length - 1) Item = liArray.length - 1;
	
	!	$(liArray[Item]).text(Text);
	
	!	selector.empty();
	!	selector.append(liArray);
	!	selector.menu("refresh");
	
EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "SetGadgetItemText", @SplitButtonGadget_SetGadgetItemText())

Procedure SplitButtonGadget_SetGadgetText(Gadget, Text.s)
	!	var selector = $("#g_" + Gadget + "_b1");
	!	selector.button().text(Text);
EndProcedure
RegisterUserGadgetProcedure("SplitButtonGadget", "SetGadgetText", @SplitButtonGadget_SetGadgetText())

Procedure SplitButtonGadget(Gadget, x, y, Width, Height, Text.s)
	
	!	var Gadget = cCommon.SetGadgetAndStuff(Gadget);
	
	!	var html =
	!		"<div id='g_" + Gadget + "'>" +
	!		"	<div style='width:100%;height:100%'>" +
	!		"		<button id='g_" + Gadget + "_b1' style='height:100%'>" + Text + "</button>" +
	!		"		<button id='g_" + Gadget + "_b2' style='height:100%'></button>" +
	!		"	</div>" +
	!		" <ul id='g_" + Gadget + "_m' />" +
	!		"</div>";
	!
	!	var splitButtonGadget = $(html);
	!
	!	cCommon.CurrentContainer.append(splitButtonGadget);
	!
	!	var b1 = $("#g_" + Gadget + "_b1");
	!	var b2 = $("#g_" + Gadget + "_b2");
	!	var m = $("#g_" + Gadget + "_m");
	!
	!	b1.button().click(function (event, ui) {
	!
	!		m.data("selectedItem", null);
	!
	!		if (b1.data("onLeftClick")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = cConstants.PB_Event_LeftClick;
	!			b1.data("onLeftClick")();
	!		}
	
	!	});
	
	!	b2.button({
	!		text: false,
	!		icons: {
	!			primary: "ui-icon-triangle-1-s"
	!		},
	!	});
	
	!	b2.button().click(function () {
	
	!		if (m.is(':visible')) {
	!			m.hide();
	!		} else {
	!			m.width(splitButtonGadget.width());
	!			m.show().position({
	!				my: "left top",
	!				at: "left bottom",
	!				of: b1
	!			});
	!		}
	
	!		$(document).one("click", function () {
	!			m.hide();
	!		});
	
	!		return false;
	
	!	});
	
	!	b1.parent().buttonset();
	
	!		m.hide().menu({
	
	!		select: function (event, ui) {
	
	!			m.data("selectedItem", ui.item.index());
	
	!			if (m.data("onLeftClick")) {
	!				cEvent.eventGadget = Gadget;
	!				cEvent.eventType = cConstants.PB_Event_LeftClick;
	!				m.data("onLeftClick")();
	!			}
	
	!		}
	
	!	});
	
	!	m.addClass("ui-corner-all");
	
	!	splitButtonGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });
	
	!	b2.css("width", "30px");
	
	!	b1.css("width", parseInt(splitButtonGadget.css("width")) - parseInt(b2.css("width")));
	
	!	splitButtonGadget.data("GadgetType", "SplitButtonGadget");
	
	!	return Gadget;
	
EndProcedure
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 147
; Folding = AA+
; EnableUnicode
; EnableXP