Global PB_TinyMceGadget_ToolBar.s = ""
Global PB_TinyMceGadget_Plugins.s = ""
Global PB_TinyMceGadget_MenuBar.s = ""
Global PB_TinyMceGadget_Language.s = ""
Global PB_TinyMceGadget_PdfFilename.s = "download.pdf"
Global PB_TinyMceGadget_StatusBar = #False
Global PB_TinyMceGadget_Visual = #True

; OpenLibrary(#PB_Any, "userlibraries/tinymce/tinymce.min.js")
OpenLibrary(#PB_Any, "userlibraries/tinymce/tinymce.js")

Procedure TinyMceGadget_FreeGadget(Gadget)
	!	tinymce.get("g_" + Gadget).remove();
EndProcedure
RegisterUserGadgetProcedure("TinyMceGadget", "FreeGadget", @TinyMceGadget_FreeGadget())

Procedure TinyMceGadget_GadgetHeight(Gadget)
	!	var selector = $("#mceg_" + Gadget); 
	!	return selector.height();
EndProcedure
RegisterUserGadgetProcedure("TinyMceGadget", "GadgetHeight", @TinyMceGadget_GadgetHeight())

Procedure TinyMceGadget_GadgetWidth(Gadget)
	!	var selector = $("#mceg_" + Gadget); 
	!	return selector.width();
EndProcedure
RegisterUserGadgetProcedure("TinyMceGadget", "GadgetWidth", @TinyMceGadget_GadgetWidth())

Procedure TinyMceGadget_GetGadgetText(Gadget)
	!	return tinymce.get("g_" + Gadget).getContent({ format: 'text' });
EndProcedure
RegisterUserGadgetProcedure("TinyMceGadget", "GetGadgetText", @TinyMceGadget_GetGadgetText())

Procedure TinyMceGadget_SetGadgetText(Gadget, Text.s)
	!	tinymce.get("g_" + Gadget).setContent(Text);
EndProcedure
RegisterUserGadgetProcedure("TinyMceGadget", "SetGadgetText", @TinyMceGadget_SetGadgetText())

Procedure TinyMceGadget_GetGadgetHtml(Gadget)
	!	return tinymce.get("g_" + Gadget).getContent();
EndProcedure
RegisterUserGadgetProcedure("TinyMceGadget", "GetGadgetHtml", @TinyMceGadget_GetGadgetHtml())

Procedure TinyMceGadget_SetGadgetHtml(Gadget, Html.s)
	!	tinymce.get("g_" + Gadget).setContent(Html);
EndProcedure
RegisterUserGadgetProcedure("TinyMceGadget", "SetGadgetHtml", @TinyMceGadget_SetGadgetHtml())

Procedure TinyMceGadget_ResizeGadget(Gadget, x, y, Width, Height)
	! var selector = $("#g_" + Gadget);
	!	if (x !== cConstants.PB_Ignore) selector.css("left", x);
	!	if (y !== cConstants.PB_Ignore) selector.css("top", y);
	!	if (Width !== cConstants.PB_Ignore) selector.css("width", Width);	
	!	if (Height !== cConstants.PB_Ignore) selector.css("height", Height);	
	! selector.data("ed").execCommand("mceRepaint");
EndProcedure
RegisterUserGadgetProcedure("TinyMceGadget", "ResizeGadget", @TinyMceGadget_ResizeGadget())

Procedure TinyMceGadget_SetGadgetAttribute(Gadget, Attribute, Value)
	
!	var selector = $("#g_" + Gadget);
!	var ed = tinymce.get("g_" + Gadget);
!	switch (Attribute) {
!		case PB_TinyMceGadget_ToolBar:
!			ed.settings.toolbar = Value;
!			ed.execCommand('mceRemoveControl', false, "toolbar");
!			ed.execCommand('mceAddControl', false, "toolbar");
!			break;
!		case PB_TinyMceGadget_Plugins:
!			ed.settings.plugins = Value;
!			ed.init();
!			break;
!		case PB_TinyMceGadget_MenuBar:
!			ed.settings.menubar = Value;
!			ed.init();
!			break;
!	}
EndProcedure
RegisterUserGadgetProcedure("TinyMceGadget", "SetGadgetAttribute", @TinyMceGadget_SetGadgetAttribute())

Procedure TinyMceGadget(Gadget, x, y, Width, Height, Flags = 0, Callback = 0)
	
	! var editorGadget = new cControl(Gadget, x, y, Width, Height, "<textarea />");
	
	! cCommon.CurrentContainer.append(editorGadget.selector);
	
	!	editorGadget.selector.data("GadgetType", "TinyMceGadget");
	
	! tinyMCE.baseURL = "userlibraries/tinymce"
	
	!	var ed = new tinymce.Editor("g_" + editorGadget.ident, {
	!		selector: "g_" + editorGadget.ident,
	!		statusbar: PB_TinyMceGadget_StatusBar,
	!		width: Width,
	!		height: Height,
	!	}, tinymce.EditorManager);
	
	!	if (PB_TinyMceGadget_Language !== "") ed.settings.language = PB_TinyMceGadget_Language;
	!	if (PB_TinyMceGadget_ToolBar !== "")  ed.settings.toolbar  = PB_TinyMceGadget_ToolBar;
	!	if (PB_TinyMceGadget_MenuBar !== "")  ed.settings.menubar  = PB_TinyMceGadget_MenuBar;
	!	if (PB_TinyMceGadget_Plugins !== "")  ed.settings.plugins  = PB_TinyMceGadget_Plugins;
	
	!	ed.settings.visual = PB_TinyMceGadget_Visual;
	!
	!	ed.on('init', function (e) {
	!		$(".mce-tinymce").each(function () {
	!			var editor = $(this);
	!			if (cString.FindString(editor.attr("id"), "mce")) {
	!				editorGadget.selector.data("ed", ed);
	!				// ed.dom.setStyle(ed.id + '_ifr', 'height', '100%');
	!				// ed.dom.setStyle(ed.id + '_ifr', 'width', '100%');
	!				editor.attr("id", "mceg_" + editorGadget.ident);
	!				editor.css("position", "absolute");
	!				editor.css("top", y);
	!				editor.css("left", x);
	!				if (Callback) Callback();
	!			}
	!		});
	!	});
	
	!	ed.render();
	
	! return editorGadget.ident;
	
EndProcedure
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 29
; FirstLine = 6
; Folding = 56
; EnableXP