; VisGadget - Include

EnableExplicit

Enumeration
	#PB_Vis_Border
EndEnumeration

OpenLibrary(#PB_Any, "userlibraries/vis.js/vis.min.css")
OpenLibrary(#PB_Any, "userlibraries/vis.js/vis.min.js")

Procedure VisGadget_AddNode(Gadget, ID.s, Label.s)
	
	! var selector = $("#g_" + Gadget);
	! var nodes = selector.data("Nodes");
	! if (!nodes.get(ID)) {
	! 	var node = {id:ID, label:Label};
	! 	nodes.add(node);
	! }
	
EndProcedure

Procedure VisGadget_ClearNodes(Gadget)
	
	! var selector = $("#g_" + Gadget);
	! var nodes = selector.data("Nodes");
	! nodes.clear();
	
EndProcedure

Procedure VisGadget_AddEdge(Gadget, FromNode.s, ToNode.s)
	
	! var selector = $("#g_" + Gadget);
	! var edges = selector.data("Edges");
	!	var edge = {from:FromNode, to:ToNode, arrows:'to'};
	!	edges.add(edge);
	
EndProcedure

Procedure VisGadget_ClearEdges(Gadget)
	
	! var selector = $("#g_" + Gadget);
	! var edges = selector.data("Edges");
	! edges.clear();
	
EndProcedure

Procedure VisGadget(Gadget, x, y, Width, Height, Flags = 0)
	
	! Gadget = cCommon.SetGadgetAndStuff(Gadget);

	! var selector = $("<div />");

	! selector.attr("id", "g_" + Gadget);
	
	!	if (cCommon.CheckFlag(Flags, PB_Vis_Border)) {
	!		selector.css("border", "1px solid black");
	! }

	! cCommon.CurrentContainer.append(selector);

	! cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	
	! var Nodes = new vis.DataSet([]);
	! var Edges = new vis.DataSet([]);
	
	!	selector.data("Nodes", Nodes);
	!	selector.data("Edges", Edges);
	
	!	// provide the data in the vis format
	!	var data = {
	!		nodes: Nodes,
	!		edges: Edges
	!	};
	
	!	var options = {
	!		nodes: {
	!			shape: 'box'
	!		},
	!		edges: {
	!		},
	! 	groups: {
	!			useDefaultGroups: true,
	!			settings: {color:{background:'red'}, borderWidth:10}
	!		},
	!   physics: {
	!   } 	
	!	};
	
	!	// initialize your network!
	!	var network = new vis.Network(selector[0], data, options);	
	
	!	selector.data("GadgetType", "VisGadget");
	
	! return Gadget;	
	
EndProcedure
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 69
; FirstLine = 49
; Folding = --
; EnableXP