﻿EnableExplicit

OpenLibrary(#PB_Any, "libraries/w2ui/w2ui.min.css")
OpenLibrary(#PB_Any, "libraries/w2ui/w2ui.min.js")


Enumeration
	#w2uiGridGadgetColumnCaption        ; : '',     // column caption 
	#w2uiGridGadgetColumnField					; : '',     // field name to map column to a record
	#w2uiGridGadgetColumnSize						; : null,   // size of column in px or %
	#w2uiGridGadgetColumnMin						; : 15,     // minimum width of column in px
	#w2uiGridGadgetColumnMax						; : null,   // maximum width of column in px
	#w2uiGridGadgetColumnGridMinWidth		; : null,   // minimum width of the grid when column is visible
	#w2uiGridGadgetColumnSizeCorrected	; : null,   // read only, corrected size (see explanation below)
	#w2uiGridGadgetColumnSizeCalculated	; : null,   // read only, size in px (see explanation below)
	#w2uiGridGadgetColumnHidden					; : false,  // indicates if column is hidden
	#w2uiGridGadgetColumnSortable				; : false,  // indicates if column is sortable
	#w2uiGridGadgetColumnSearchable			; : false,  // indicates if column is searchable, bool/string: int,float,date,...
	#w2uiGridGadgetColumnResizable			; : true,   // indicates if column is resiable
	#w2uiGridGadgetColumnHideable				; : true,   // indicates if column can be hidden
	#w2uiGridGadgetColumnAttr						; : '',     // string that will be inside the <td ... attr> tag
	#w2uiGridGadgetColumnStyle					; : '',     // additional style for the td tag
	#w2uiGridGadgetColumnRender					; : null,   // string or render function
	#w2uiGridGadgetColumnTitle					; : null,   // string or function for the title property for the column cells
	#w2uiGridGadgetColumnEditable				; : {}      // editable object if column fields are editable  
EndEnumeration

Enumeration
	
	#w2uiGridGadgetShowHeader          ; : false,  // indicates if header is visible
	#w2uiGridGadgetHeaderText
	#w2uiGridGadgetShowToolbar         ; : false,  // indicates if toolbar is visible
	#w2uiGridGadgetShowFooter					 ; : false,  // indicates if footer is visible
	#w2uiGridGadgetShowColumnHeaders	 ; : true,   // indicates if columns is visible
	#w2uiGridGadgetShowLineNumbers		 ; : false,  // indicates if line numbers column is visible
	#w2uiGridGadgetShowExpandColumn		 ; : false,  // indicates if expand column is visible
	#w2uiGridGadgetShowSelectColumn		 ; : false,  // indicates if select column is visible
	#w2uiGridGadgetShowEmptyRecords		 ; : true,   // indicates if empty records are visible
	#w2uiGridGadgetShowToolbarReload	 ; : true,   // indicates if toolbar reload button is visible
	#w2uiGridGadgetShowToolbarColumns	 ; : true,   // indicates if toolbar columns button is visible
	#w2uiGridGadgetShowToolbarSearch	 ; : true,   // indicates if toolbar search controls are visible
	#w2uiGridGadgetShowToolbarAdd			 ; : true,   // indicates if toolbar add new button is visible
	#w2uiGridGadgetShowToolbarEdit		 ; : true,   // indicates if toolbar edit button is visible
	#w2uiGridGadgetShowToolbarDelete	 ; : true,   // indicates if toolbar delete button is visible
	#w2uiGridGadgetShowToolbarSave		 ; : true,   // indicates if toolbar save button is visible
	#w2uiGridGadgetShowSelectionBorder ; : true,   // display border arround selection (for selectType = 'cell')
	#w2uiGridGadgetShowRecordTitles		 ; : true,   // indicates if to define titles for records
	#w2uiGridGadgetShowSkipRecords		 ; : true    // indicates if skip records should be visible
	
	#w2uiGridGadgetUrl
	#w2uiGridGadgetUrlLoadCallback
	
	#w2uiGridGadgetColumns
	#w2uiGridGadgetRecords
	
EndEnumeration

Enumeration ; EventTypes
	#w2ui_EventType_OnAdd							=	1 ; Called when user clicks the Add New button on the toolbar. 
	#w2ui_EventType_OnChange					=	2 ; Called when user changes any field in the editable row. 
	#w2ui_EventType_OnClick						=	4 ; Called when user clicks a record. 
	#w2ui_EventType_OnCollapse				=	8 ; Called when user collapses epxandable record. 
	#w2ui_EventType_OnColumnClick			=	16 ; Called when user clicks a column. 
	#w2ui_EventType_OnColumnOnOff			=	32 ; Called when user shows or hides a column selecting it in the grid settings menu. 
	#w2ui_EventType_OnColumnResize		=	64 ; Called when user resizes a column. 
	#w2ui_EventType_OnContextMenu			=	128 ; Called when user clicks right mouse button. 
	#w2ui_EventType_OnCopy						=	256 ; Called when user copies selected records to clipboard (ctrl+c or cmd+c). 
	#w2ui_EventType_OnDblClick				=	512 ; Called when user double clicks a record. 
	#w2ui_EventType_OnDelete					=	1024 ; Called when user clicks the Delete button on the toolbar. 
	#w2ui_EventType_OnDeleted					=	2048 ; Called when server responds back after delete request. 
	#w2ui_EventType_OnDestroy					=	4096 ; Called when object is destroyed. 
	#w2ui_EventType_OnEdit						=	8192 ; Called when user clicks the Edit button on the toolbar. 
	#w2ui_EventType_OnEditField				=	16384 ; Called when user enters into editable mode for the field. 
	#w2ui_EventType_OnError						=	32768 ; Called when server returns an error. 
	#w2ui_EventType_OnExpand					=	65536 ; Called when user expands expandable record. 
	#w2ui_EventType_OnKeydown					=	131072 ; Called when user presess a keyboard key and grid is active. 
	#w2ui_EventType_OnLoad						=	262144 ; Called when server responds to a get-records request. 
	#w2ui_EventType_OnMenuClick				=	524288 ; Called when user selects an item from the context menu. 
	#w2ui_EventType_OnPaste						=	1048576 ; Called when user pastes from clipboard (ctrl+v or cmd+v). 
	#w2ui_EventType_OnRefresh					=	2097152 ; Called when object is refreshed. 
	#w2ui_EventType_OnReload					=	4194304 ; Called when user clicks Reload button on the toolbar. 
	#w2ui_EventType_OnRender					=	8388608 ; Called when object is rendered. 
	#w2ui_EventType_OnRequest					=	16777216 ; Called on any server request. 
	#w2ui_EventType_OnResize					=	33554432 ; Called when object is resized.
	#w2ui_EventType_OnRestore					=	67108864 ; Called when user changes an editable records but it restores to its original value. 
	#w2ui_EventType_OnSave						=	134217728 ; Called when server responds back after save request. 
	#w2ui_EventType_OnSearch					=	268435456 ; Called when user applies a search. 
	#w2ui_EventType_OnSelect					=	536870912 ; Called when user selects a record. 
	#w2ui_EventType_OnSelectionExtend	=	1073741824 ; Called when user extends selection by draggind small dot at the bottom right cornder of selection. 
	#w2ui_EventType_OnSort						=	2147483648 ; Called when user applies a sort. 
	#w2ui_EventType_OnStateRestore		=	4294967296 ; Called when user selects "Restore Default State". 
	#w2ui_EventType_OnStateSave				=	8589934592 ; Called when user selects "Save Grid State". 
	#w2ui_EventType_OnSubmit					=	17179869184 ; Called on user changed data is saved. 
	#w2ui_EventType_OnToolbar					=	34359738368 ; Called when user clicks any button on the toolbar. 
	#w2ui_EventType_OnUnselect				=	68719476736 ; Called when user unselects a record.
EndEnumeration

Procedure w2uiGridGadget(Gadget, x, y, Width, Height, Flags = 0)
	
; 	If Gadget = #PB_Any
; 		Gadget = ContainerGadget(Gadget, x, y, Width, Height)
; 	Else
; 		ContainerGadget(Gadget, x, y, Width, Height)
; 	EndIf
; 	
; 	CloseGadgetList()
		
	!	var Gadget = cCommon.SetGadgetAndStuff(Gadget);
	
	!	var selector = $("<div />");
	
	!	selector.attr("id", "g_" + Gadget);
	
	!	cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	
	!	cCommon.CurrentContainer.append(selector);
	
	
	; ! var selector = $("#g_" + Gadget);
	
	!	selector.data("GadgetType", "w2uiGridGadget");
	
	! selector.data("ColumnDelimiter", String.fromCharCode(10));
	! selector.data("RecordDelimiter", String.fromCharCode(13));
	
	! var cb;
	
	!	selector.w2grid({
	!		name: 'g_' + Gadget,
	!   show: {
	!     header: false,
	!     toolbar: false,
	!     footer: false,
	!     columnHeaders: true,
	!     lineNumbers: false,
	!     expandColumn: false,
	!     selectColumn: false,
	!     emptyRecords: true,
	!     toolbarReload: true,
	!     toolbarColumns: true,
	!     toolbarSearch: true,
	!     toolbarAdd: true,
	!     toolbarEdit: true,
	!     toolbarDelete: true,
	!     toolbarSave: true,
	!     selectionBorder: true,
	!     recordTitles: true,
	!     skipRecords: true,
	!     multiSelect: false,
	!     reorderColumns: false
	!		},
	
	!		onRender: function(event) {
	!			event.onComplete = function(event) {
	!   		cb = selector.data("onRender");
	!   		if (cb) { cEvent.eventGadget = Gadget; cEvent.eventType = w2ui_EventType_OnRender; cb(event); }
	!			}
	!		},
	
	!		onClick: function(event) {
	!   	event.onComplete = function(event) {
	!     	cb = selector.data("onClick");
	!     	if (cb) { cEvent.eventGadget = Gadget; cEvent.eventType = w2ui_EventType_OnClick; cb(event); }
	!   	}
	!		}
	
	!	});
	
	! var ow2ui = w2ui["g_" + Gadget];
	
	
	! ow2ui.on('add', function (event) {
	!     cb = selector.data("onAdd");
	!     if (cb) {
	!				cEvent.eventGadget = Gadget;
	!				cEvent.eventType = w2ui_EventType_OnAdd;
	!				cb(event);
	!     }
	! });
	
	! ow2ui.on('change', function (event) {
	!   event.onComplete = function () {
	!     cb = selector.data("onChange");
	!     if (cb) {
	!				cEvent.eventGadget = Gadget;
	!				cEvent.eventType = w2ui_EventType_OnChange;
	!				cb(event);
	!     }
	!   };
	! });
	
	
	; onCollapse: function(event) {},
	; onColumnClick: function(event) {},
	; onColumnOnOff: function(event) {},
	; onColumnResize: function(event) {},
	; onContextMenu: function(event) {},
	; onCopy: function(event) {},
	; onDblClick: function(event) {},
	; onDelete: function(event) {},
	; onDeleted: function(event) {},
	; onDestroy: function(event) {},
	
	! ow2ui.on('edit', function (event) {
	!   cb = selector.data("onEdit");
	!   if (cb) {
	!				cEvent.eventGadget = Gadget;
	!				cEvent.eventType = w2ui_EventType_OnEdit;
	!				cb(event);
	!   }
	! });
	
	; onEditField: function(event) {},
	; onError: function(event) {},
	; onExpand: function(event) {},
	; onKeydown: function(event) {},
	
	! ow2ui.on('load', function (event) {
	!   cb = selector.data("onLoad");
	!   if (cb) { cEvent.eventGadget = Gadget; cEvent.eventType = w2ui_EventType_OnLoad; cb(event); }
	! });	
	
	; onMenuClick: function(event) {},
	; onPaste: function(event) {},
	; onRefresh: function(event) {},
	; onReload: function(event) {},
	
	! ow2ui.on('request', function (event) {
	!   cb = selector.data("onRequest");
	!   if (cb) {
	!				cEvent.eventGadget = Gadget;
	!				cEvent.eventType = w2ui_EventType_OnRequest;
	!				cb(event);
	!   }
	! });
	
	! ow2ui.on('resize', function (event) {
	!   cb = selector.data("onResize");
	!   if (cb) {
	!				cEvent.eventGadget = Gadget;
	!				cEvent.eventType = w2ui_EventType_OnResize;
	!				cb(event);
	!   }
	! });
	
	! ow2ui.on('restore', function (event) {
	!   cb = selector.data("onRestore");
	!   if (cb) {
	!				cEvent.eventGadget = Gadget;
	!				cEvent.eventType = w2ui_EventType_OnRestore;
	!				cb(event);
	!   }
	! });
	
	! ow2ui.on('save', function (event) {
	!   cb = selector.data("onSave");
	!   if (cb) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = w2ui_EventType_OnSave;
	!			cb(event);
	!   }
	! });	
	
	; onSearch: function(event) {},
	
	! ow2ui.on('select', function (event) {
	!   event.onComplete = function () {
	!     cb = selector.data("onSelect");
	!     if (cb) {
	!				cEvent.eventGadget = Gadget;
	!				cEvent.eventType = w2ui_EventType_OnSelect;
	!				cb(event);
	!     }
	!   };
	! });	
	
	; onSelectionExtend: function(event) {},
	; onSort: function(event) {},
	; onStateRestore: function(event) {},
	; onStateSave: function(event) {},
	
	! ow2ui.on('submit', function (event) {
	!   cb = selector.data("onSubmit");
	!   if (cb) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = w2ui_EventType_OnSubmit;
	!     cb(event);
	!   }
	! });	
	
	; onToolbar: function(event) {},
	
	! ow2ui.on('unselect', function (event) {
	!   event.onComplete = function () {
	!     cb = selector.data("onUnselect");
	!     if (cb) {
	!				cEvent.eventGadget = Gadget;
	!				cEvent.eventType = w2ui_EventType_OnUnselect;
	!				cb(event);
	!     }
	!   };
	! });	
	
	ProcedureReturn Gadget
	
EndProcedure

; --------------------

Procedure w2uiGridGadget_AddGadgetColumn(Gadget, Position, Title.s, Width)
	
	! var grid = w2ui["g_" + Gadget];
	! if (grid) {
	!   var columns = grid.columns;
	!   if (Position < -1) Position = 0;
	!   if (Position >= columns.length) Position = columns.length;
	!   if (Position == -1) Position = columns.length;
	Protected sWidth.s = Str(Width)
	If Right(sWidth, 1) <> "%" And Right(sWidth, 2) <> "px" : sWidth + "px" : EndIf
	!   grid.addColumn(Position, { field: Title, caption: Title, size: sWidth, sortable: true, resizable: true });
	!   grid.refresh();	
	! }
	
EndProcedure
RegisterUserGadgetProcedure("w2uiGridGadget", "AddGadgetColumn", @w2uiGridGadget_AddGadgetColumn())

Procedure w2uiGridGadget_AddGadgetItem(Gadget, Position, Text.s, ImageID = #PB_Ignore, Flags = 0)
	
	! var selector = $("#g_" + Gadget);
	
	! var Columns = w2ui["g_" + Gadget].columns;
	! var Records = w2ui["g_" + Gadget].records;
	! if (Position < -1) Position = 0;
	! if (Position >= Records.length) Position = Records.length;
	! if (Position === -1) Position = Records.length;
	! var myLineArray = Text.split(selector.data("RecordDelimiter"));
	! for (var lineCounter = 0; lineCounter <= myLineArray.length - 1; lineCounter++) {
	!		var newRecord = {};
	!		var myFieldArray = myLineArray[lineCounter].split(selector.data("ColumnDelimiter"));
	!		for (var fieldCounter = 0; fieldCounter <= Columns.length - 1; fieldCounter++) {
	!			newRecord[Columns[fieldCounter].field] = myFieldArray[fieldCounter];
	!		}
	!		Records.splice(Position, 0, newRecord);
	!		Position += 1;
	! }
	!	for (var i = 0; i <= Records.length - 1; i++) {
	!		Records[i].recid = i;
	!	}
	! w2ui["g_" + Gadget].clear();
	! w2ui["g_" + Gadget].reset();
	! w2ui["g_" + Gadget].add(Records);
	
EndProcedure
RegisterUserGadgetProcedure("w2uiGridGadget", "AddGadgetItem", @w2uiGridGadget_AddGadgetItem())

Procedure w2uiGridGadget_SetGadgetAttribute(Gadget, Attribute, Value)
	
	! ow2ui = w2ui["g_" + Gadget];
	
	! if (!ow2ui) return;
	
	Select Attribute
		Case #w2uiGridGadgetShowHeader
			! ow2ui.show.header = Value;
		Case #w2uiGridGadgetHeaderText
			! ow2ui.header = Value;
		Case #w2uiGridGadgetShowToolbar
			! ow2ui.show.toolbar = Value;
		Case #w2uiGridGadgetShowFooter
			! ow2ui.show.footer = Value;
		Case #w2uiGridGadgetShowColumnHeaders
			! ow2ui.show.columnHeaders = Value;
		Case #w2uiGridGadgetShowLineNumbers
			! ow2ui.show.lineNumbers = Value;
		Case #w2uiGridGadgetShowExpandColumn
			! ow2ui.show.expandColumn = Value;
		Case #w2uiGridGadgetShowSelectColumn
			! ow2ui.show.selectColumn = Value;
		Case #w2uiGridGadgetShowEmptyRecords
			! ow2ui.show.emptyRecords = Value;
		Case #w2uiGridGadgetShowToolbarReload
			! if (Value) { ow2ui.toolbar.show("w2ui-reload"); } else { ow2ui.toolbar.hide("w2ui-reload"); }
		Case #w2uiGridGadgetShowToolbarColumns
			! if (Value) { ow2ui.toolbar.show("w2ui-column-on-off"); } else { ow2ui.toolbar.hide("w2ui-column-on-off"); }
		Case #w2uiGridGadgetShowToolbarSearch
			! if (Value) { ow2ui.toolbar.show("w2ui-search"); } else { ow2ui.toolbar.hide("w2ui-search"); }
		Case #w2uiGridGadgetShowToolbarAdd
			! if (Value) { ow2ui.toolbar.show("w2ui-add"); } else { ow2ui.toolbar.hide("w2ui-add"); }
		Case #w2uiGridGadgetShowToolbarEdit
			! if (Value) { ow2ui.toolbar.show("w2ui-edit"); } else { ow2ui.toolbar.hide("w2ui-edit"); }
		Case #w2uiGridGadgetShowToolbarDelete
			! if (Value) { ow2ui.toolbar.show("w2ui-delete"); } else { ow2ui.toolbar.hide("w2ui-delete"); }
		Case #w2uiGridGadgetShowToolbarSave
			! if (Value) { ow2ui.toolbar.show("w2ui-save"); } else { ow2ui.toolbar.hide("w2ui-save"); }
		Case #w2uiGridGadgetShowSelectionBorder
			! ow2ui.show.selectionBorder = Value;
		Case #w2uiGridGadgetShowRecordTitles
			! ow2ui.show.recordTitles = Value;
		Case #w2uiGridGadgetShowSkipRecords
			! ow2ui.show.skipRecords = Value;
		Case #w2uiGridGadgetUrl
			! ow2ui.url = Value;
			! ow2ui.load(Value, $(ow2ui).data("UrlLoadCallback"));
		Case #w2uiGridGadgetUrlLoadCallback
			! $(ow2ui).data("UrlLoadCallback", Value);
			
		Case #w2uiGridGadgetRecords
			!	ow2ui.records = Value;
		Case #w2uiGridGadgetColumns
			!	ow2ui.columns = Value;
			
	EndSelect
	
	! ow2ui.refresh();
	
	
	;   ! case cConstants.PB_ListIcon_MultiSelect:
	;   !     w2ui["g_" + Gadget].multiSelect = Value;
	;   !     w2ui["g_" + Gadget].refresh();
	;   !     break;
	;   ! case cConstants.PB_ListIcon_HeaderDragDrop:
	;   !     w2ui["g_" + Gadget].reorderColumns = Value;
	;   !     w2ui["g_" + Gadget].refresh();
	;   !     break;
	;   !             case cConstants.PB_ListIcon_SelectTypeCell:
	;   !                 if (Value === 1) {
	;   !                     w2ui["g_" + Gadget].selectType = 'cell';
	;   !                 }
	;   !                 else {
	;   !                     w2ui["g_" + Gadget].selectType = 'row';
	;   !                 }
	;   !                 w2ui["g_" + Gadget].refresh();
	;   !                 break;
	;   
	;   
	;   
	;   !   cGadget.SetGadgetAttribute_ListIcon = function (Gadget, Attribute, Value, functionName, gadgetType) {
	;   !         var selector = $("#g_" + Gadget);
	;   !         switch (Attribute) {
	;   !             case cConstants.PB_ListIcon_ToolbarEdit:
	;   !             case cConstants.PB_ListIcon_ToolbarDelete:
	;   !             case cConstants.PB_ListIcon_ToolbarSave:
	;   !             case cConstants.PB_ListIcon_Columns:
	;   !                 var colArr = [];
	;   !                 for (var colCounter = 0; colCounter <= Value.length - 1; colCounter++) {
	;   !                     var newColumn = {
	;   !                         caption: '',
	;   !                         field: '',
	;   !                         size: null,
	;   !                         min: 15,
	;   !                         max: null,
	;   !                         gridMinWidth: null,
	;   !                         hidden: false,
	;   !                         sortable: false,
	;   !                         searchable: false,
	;   !                         resizable: false,
	;   !                         attr: '',
	;   !                         style: '',
	;   !                         render: null,
	;   !                         editable: {}
	;   !                     };
	;   !                     Object.keys(Value[colCounter]).forEach(function (key) {
	;   !                         if (Value[colCounter][key] !== null) {
	;   !                             newColumn[key] = Value[colCounter][key];
	;   !                         }
	;   !                         else {
	;   !                             delete newColumn[key];
	;   !                         }
	;   !                     });
	;   !                     colArr.push(newColumn);
	;   !                 }
	;   !                 Value = colArr;
	;   !                 w2ui["g_" + Gadget].columns = Value;
	;   !                 w2ui["g_" + Gadget].refresh();
	;   !                 break;
	;   !             case cConstants.PB_ListIcon_Records:
	;   !                 w2ui["g_" + Gadget].records = Value;
	;   !                 w2ui["g_" + Gadget].refresh();
	;   !                 break;
	;   !             case cConstants.PB_ListIcon_SearchFields:
	;   !                 w2ui["g_" + Gadget].searches = Value;
	;   !                 w2ui["g_" + Gadget].refresh();
	;   !                 break;
	;   !             case cConstants.PB_ListIcon_URL:
	;   !                 w2ui["g_" + Gadget].url = Value;
	;   !                 w2ui["g_" + Gadget].reload();
	;   !                 break;
	;   !             default:
	;   !                 
	;   !                 break;
	;   !         }
	;   !     };  
	
EndProcedure
RegisterUserGadgetProcedure("w2uiGridGadget", "SetGadgetAttribute", @w2uiGridGadget_SetGadgetAttribute())

Procedure w2uiGridGadget_SetGadgetItemAttribute(Gadget, Item, Attribute, Value, Column = #PB_Ignore)
	
	Select Attribute
			
		Case #w2uiGridGadgetColumnCaption
			! var column = w2ui["g_" + Gadget].columns[Column];
			! column.caption = Value;
		Case #w2uiGridGadgetColumnField
			! var column = w2ui["g_" + Gadget].columns[Column];
			! column.field = Value;
		Case #w2uiGridGadgetColumnSize
		Case #w2uiGridGadgetColumnMin
		Case #w2uiGridGadgetColumnMax
		Case #w2uiGridGadgetColumnGridMinWidth
		Case #w2uiGridGadgetColumnSizeCorrected ; ReadOnly
		Case #w2uiGridGadgetColumnSizeCalculated; ReadOnly
		Case #w2uiGridGadgetColumnHidden
		Case #w2uiGridGadgetColumnSortable
			! var column = w2ui["g_" + Gadget].columns[Column];
			! column.sortable = Value;
		Case #w2uiGridGadgetColumnSearchable
		Case #w2uiGridGadgetColumnResizable
		Case #w2uiGridGadgetColumnHideable
		Case #w2uiGridGadgetColumnAttr
		Case #w2uiGridGadgetColumnStyle
		Case #w2uiGridGadgetColumnRender
			! var column = w2ui["g_" + Gadget].columns[Column];
			! column.render = Value;
		Case #w2uiGridGadgetColumnTitle
		Case #w2uiGridGadgetColumnEditable
			
	EndSelect
	
EndProcedure
RegisterUserGadgetProcedure("w2uiGridGadget", "SetGadgetItemAttribute", @w2uiGridGadget_SetGadgetItemAttribute())

Procedure w2uiGridGadget_BindUnbindEvent(Gadget, Callback, EventType.q = #PB_All, bind = #True) 
	
	Debug "bind"
	
	! var selector = $("#g_" + Gadget);
	
	Protected cb = Callback
	
	If bind = #False
		cb = #Null
	EndIf
	
	If EventType = #PB_All  
		
		EventType = #w2ui_EventType_OnAdd |
		            #w2ui_EventType_OnChange |
		            #w2ui_EventType_OnClick |
		            #w2ui_EventType_OnCollapse |
		            #w2ui_EventType_OnColumnClick |
		            #w2ui_EventType_OnColumnOnOff |
		            #w2ui_EventType_OnColumnResize |
		            #w2ui_EventType_OnContextMenu |
		            #w2ui_EventType_OnCopy |
		            #w2ui_EventType_OnDblClick |
		            #w2ui_EventType_OnDelete |
		            #w2ui_EventType_OnDeleted |
		            #w2ui_EventType_OnDestroy |
		            #w2ui_EventType_OnEdit |
		            #w2ui_EventType_OnEditField |
		            #w2ui_EventType_OnError |
		            #w2ui_EventType_OnExpand |
		            #w2ui_EventType_OnKeydown |
		            #w2ui_EventType_OnLoad |
		            #w2ui_EventType_OnMenuClick |
		            #w2ui_EventType_OnPaste |
		            #w2ui_EventType_OnRefresh |
		            #w2ui_EventType_OnReload |
		            #w2ui_EventType_OnRender |
		            #w2ui_EventType_OnRequest |
		            #w2ui_EventType_OnResize |
		            #w2ui_EventType_OnRestore |
		            #w2ui_EventType_OnSave |
		            #w2ui_EventType_OnSearch |
		            #w2ui_EventType_OnSelect |
		            #w2ui_EventType_OnSelectionExtend |
		            #w2ui_EventType_OnSort |
		            #w2ui_EventType_OnStateRestore |
		            #w2ui_EventType_OnStateSave |
		            #w2ui_EventType_OnSubmit |
		            #w2ui_EventType_OnToolbar |
		            #w2ui_EventType_OnUnselect        
		
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnAdd))        selector.data("onAdd", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnChange))        selector.data("onChange", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnClick))        selector.data("onClick", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnCollapse))        selector.data("onCollapse", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnColumnClick))        selector.data("onColumnClick", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnColumnOnOff))        selector.data("onColumnOnOff", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnColumnResize))        selector.data("onColumnResize", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnContextMenu))        selector.data("onContextMenu", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnCopy))        selector.data("onCopy", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnDblClick))        selector.data("onDblClick", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnDelete))        selector.data("onDelete", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnDeleted))        selector.data("onDeleted", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnDestroy))        selector.data("onDestroy", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnEdit))        selector.data("onEdit", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnEditField))				selector.data("onEditField", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnError))						selector.data("onError", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnExpand))					selector.data("onExpand", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnKeydown))					selector.data("onKeydown", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnLoad))						selector.data("onLoad", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnMenuClick))				selector.data("onMenuClick", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnPaste))						selector.data("onPaste", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnRefresh))					selector.data("onRefresh", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnReload))					selector.data("onReload", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnRender))					selector.data("onRender", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnRequest))					selector.data("onRequest", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnResize))					selector.data("onResize", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnRestore))					selector.data("onRestore", cb);	
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnSave))						selector.data("onSave", cb);
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnSearch))					selector.data("onSearch", cb);
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnSelect))					selector.data("onSelect", cb);
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnSelectionExtend))	selector.data("onSelectionExtend", cb);
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnSort))						selector.data("onSort", cb);
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnStateRestore))		selector.data("onStateRestore", cb);
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnStateSave))				selector.data("onStateSave", cb);
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnSubmit))					selector.data("onSubmit", cb);
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnToolbar))					selector.data("onToolbar", cb);
	!	if (cCommon.CheckFlag(EventType, w2ui_EventType_OnUnselect))				selector.data("onUnselect", cb);
	
EndProcedure

Procedure w2uiGridGadget_BindGadgetEvent(Gadget, Callback, EventType = #PB_All) 
	w2uiGridGadget_BindUnbindEvent(Gadget, Callback, EventType, #True)
EndProcedure
RegisterUserGadgetProcedure("w2uiGridGadget", "BindGadgetEvent", @w2uiGridGadget_BindGadgetEvent())

Procedure w2uiGridGadget_UnbindGadgetEvent(Gadget, Callback, EventType = #PB_All) 
	w2uiGridGadget_BindUnbindEvent(Gadget, Callback, EventType, #False)
EndProcedure
RegisterUserGadgetProcedure("w2uiGridGadget", "UnbindGadgetEvent", @w2uiGridGadget_UnbindGadgetEvent())

; --------------------

Procedure RefreshGrid(Gadget)
	
	! if (w2ui["g_" + Gadget]) w2ui["g_" + Gadget].refresh();	
	
EndProcedure

Procedure ClearGrid(Gadget)
	
	! if (w2ui["g_" + Gadget]) {
	!   w2ui["g_" + Gadget].clear();
	!   w2ui["g_" + Gadget].columns = [];
	!   w2ui["g_" + Gadget].refresh();
	! }
	
EndProcedure


; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 166
; FirstLine = 84
; Folding = MJ+
; EnableXP