; http://www.purebasic.fr/german/viewtopic.php?f=4&t=25828&start=10

XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

EnableExplicit

Enumeration
  #Window
  #Gadget
  #Timer
  #Button
  #Text
EndEnumeration

#TimeFactor = 200

Structure Wheel
  Position.i
  Length.i
  Time.i
EndStructure

Global Dim Wheel.Wheel(2)

Wheel(0)\Time = -1
Wheel(1)\Time = 0
Wheel(2)\Time = 0

Wheel(0)\Position = 0
Wheel(1)\Position = 0
Wheel(2)\Position = 0

Wheel(0)\Length = 0
Wheel(1)\Length = 0
Wheel(2)\Length = 0

Global Dim Symbols(9)

Symbols(0) = 0
Symbols(1) = 3
Symbols(2) = 2
Symbols(3) = 1
Symbols(4) = 3
Symbols(5) = 2
Symbols(6) = 3
Symbols(7) = 1
Symbols(8) = 2
Symbols(9) = 3

Global Money = 10

Procedure RandomWheel()
	
	Protected Index.i
	
  For Index = 0 To 2
    Wheel(Index)\Position = Wheel(Index)\Position + Wheel(Index)\Length
    Wheel(Index)\Length = 10 + Random(39)
    Wheel(Index)\Time = ElapsedMilliseconds() + Wheel(Index)\Length * #TimeFactor
  Next
  
  DisableGadget(#Button, #True)
  
EndProcedure

Procedure DrawWheel(x.i, y.i, Position.f)
  
  Protected Index.i = Int(Mod(Position, 10))
  Protected I
  Protected Image
  
  For I = -2 To 2
    Image = Symbols( (10 + Index + I) % 10)
    DrawImage(ImageID(Image), x - 16, y - 16 - (I - Mod(Position, 1)) * 40)
  Next
  
EndProcedure

Procedure.f WheelPosition(Index.i)
  
  Protected Time = ElapsedMilliseconds()
  Protected x.f = ( Wheel(Index)\Time-Time ) / #TimeFactor / Wheel(Index)\Length
  
  If x > 0
    ProcedureReturn Wheel(Index)\Position + Wheel(Index)\Length * ( 1 - Pow(Cos( ( 1 - x ) * #PI / 2 ), 4))
  Else
    If Wheel(Index)\Time > 0
      Wheel(Index)\Time = 0
    EndIf
    ProcedureReturn Wheel(Index)\Position + Wheel(Index)\Length
  EndIf
  
EndProcedure

Procedure UpdateGadget(Gadget.i)
  
  Protected Value.i, Index.i
  Protected wp0.f, wp1.f, wp2.f
  
  If StartDrawing(CanvasOutput(Gadget))
    
    ; DrawingMode(#PB_2DDrawing_AlphaBlend)
    
    Box(0, 0, OutputWidth(), OutputHeight())
    
    wp0 = WheelPosition(0)
    DrawWheel(OutputWidth()*0.20, OutputHeight()*0.5, wp0)
    
    wp1 = WheelPosition(1)
    DrawWheel(OutputWidth()*0.5, OutputHeight()*0.5, wp1)
    
    wp2 = WheelPosition(2)
    DrawWheel(OutputWidth()*0.8, OutputHeight()*0.5, wp2)
    
    StopDrawing()
    
  EndIf
  
  ; Debug StrF(wp0) + " / " + StrF(wp1) + " / " + StrF(wp2)
  
  If Wheel(0)\Time = 0 And Wheel(1)\Time = 0 And Wheel(2)\Time = 0
    
    Value = 0
    
    For Index = 0 To 2
      Value + Pow(10, Symbols((Wheel(Index)\Position+Wheel(Index)\Length)%10))
    Next
    
    Value / 10
    
    Select Value
      Case 300 : Money + 2
      Case 30  : Money + 5
      Case 3   : Money + 15
      Case 200 : Money + 4
      Case 20  : Money + 10
      Case 2   : Money + 30
      Case 100 : Money + 8
      Case 10  : Money + 20
      Case 1   : Money + 60
      Case 0   : Money + 100
    EndSelect
    
    DisableGadget(#Button, #False)
    SetGadgetText(#Text, "Guthaben: " + Str(Money) + " ")
    
    Wheel(0)\Time = -1
    
  EndIf
  
EndProcedure

UsePNGImageDecoder()

LoadImage(0, "i0.png")
LoadImage(1, "i1.png")
LoadImage(2, "i2.png")
LoadImage(3, "i3.png")

OpenWindow(#Window, 0, 0, 340, 180, "SlotMachine by STARGTE", #PB_Window_ScreenCentered)

TextGadget(#Text, 170, 10, 120, 30, "Guthaben: " + Str(Money) + " ")

ButtonGadget(#Button, 170, 30, 100, 30, "GO ( -1  )")

CanvasGadget(#Gadget, 10, 10, 150, 100, #PB_Canvas_Border)

AddWindowTimer(#Window, #Timer, 50)

TextGadget(#PB_Any, 10, 120, 320, 50, "3 Wanzen = 2, 3 Kfer = 5, 3 Schmetterlinge = 15" + #LF$ + "jedes Blatt ist ein Joker und verdoppelt den Gewinn" + #LF$ + "3 Bltter = 100", #PB_Text_Center)

Procedure ButtonEvent()
  Money - 1
  SetGadgetText(#Text, "Guthaben: " + Str(Money) + " ")
  RandomWheel()
EndProcedure

Procedure TimerEvent()
  UpdateGadget(#Gadget)
EndProcedure

BindGadgetEvent(#Button, @ButtonEvent())
BindEvent(#PB_Event_Timer, @TimerEvent(), #Window, #Timer)

P2W_Converter_Begin_Comment
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
P2W_Converter_End_Comment


DataSection
  
  IncludeBinary "i0.png"
  IncludeBinary "i1.png"
  IncludeBinary "i2.png"
  IncludeBinary "i3.png"
  
EndDataSection
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 22
; Folding = --