XIncludeFile "..\..\p2w.pbi"

EnableExplicit

P2W_Converter_SetProfile("pb2webtest")

Global myWebsocket

Enumeration
	#cmdCallWebSocketSub
	#cmdGetDataFromWebSocket
EndEnumeration


Procedure WS_OnOpen()
	
	Debug("WS_OnOpen")
	
	DisableGadget(#cmdCallWebSocketSub, #False)
	DisableGadget(#cmdGetDataFromWebSocket, #False)
	
EndProcedure

Procedure WS_OnClose()
	Debug("WS_OnClose")
EndProcedure

Procedure WS_OnMessage(Message.s)
	
	Debug("WS_OnMessage: " + Message)
	
	Protected ed = P2W_ParseJSON(Message)
	
	Protected eType.s  = P2W_GetJSONValue(ed, "etype")
	Protected eID.s    = P2W_GetJSONValue(ed, "id")
	Protected eProp.s  = P2W_GetJSONValue(ed, "prop")
	Protected eValue.s = P2W_GetJSONValue(ed, "value")
	
	Protected myData.s
	
	Select eType
			
		Case "runmethod"
			EnableJS
			; $(ed.id)[ed.method].apply($(ed.id), ed.params);
			DisableJS
			
		Case "runmethodWithResult"
			EnableJS
			; b4j_sendData($(ed.id)[ed.method].apply($(ed.id), ed.params));
			DisableJS
			
		Case "setAutomaticEvents"
			EnableJS
			; b4j_addAutomaticEvents(ed.data);
			DisableJS
			
		Case "runFunction"
			P2W_RunFunction(eProp, eValue)
			
		Case "runFunctionWithResult"
			myData = P2W_RunFunction(eProp, eValue)
			P2W_SendWebsocketString(myWebsocket, "{type: 'data', data: " + myData + "}")
			
		Case "eval"
			P2W_EvalFunction(eProp, eValue)
			
		Case "evalWithResult"
			myData = P2W_EvalFunction(eProp, eValue)
			P2W_SendWebsocketString(myWebsocket, myData)
			
		Case "alert"
			P2W_Alert(eProp)
			
	EndSelect
	
EndProcedure

Procedure WS_OnError(Error.s)
	Debug("WS_OnError: " + Error)
EndProcedure

Procedure CallWebsocketSub()
	
	Protected Params.s
	
	Params = "myParam1: 1, myParam2: 2"
	
	P2W_SendWebsocketString(myWebsocket, "{type: 'event', event: 'SubCalledFromPB2Web_Event', params: {" + Params + "}}")
	
	MessageRequester("Info", "Sub was called. Now look into the B4J-Log")
	
EndProcedure

Procedure RequestDataFromWebSocket()
	
	P2W_SendWebsocketString(myWebsocket, "{type: 'event', event: 'RequestDataFromWebSocket_Event', params: {}}")
	
EndProcedure

Procedure ResponseDataFromWebSocket(SentData)
	
	Debug "Data from Websocket: " + SentData
	
EndProcedure


ButtonGadget(#cmdCallWebSocketSub, 10, 10, 200, 30, "Call a WebSocket-Sub")
DisableGadget(#cmdCallWebSocketSub, #True)
BindGadgetEvent(#cmdCallWebSocketSub, @CallWebsocketSub())

ButtonGadget(#cmdGetDataFromWebSocket, 10, 50, 200, 30, "Get data from WebSocket")
DisableGadget(#cmdGetDataFromWebSocket, #True)
BindGadgetEvent(#cmdGetDataFromWebSocket, @RequestDataFromWebSocket())

myWebsocket = P2W_OpenWebsocket("ws://localhost:51234/ws")

If myWebsocket
	
	P2W_BindNetworkEvent(myWebsocket, @WS_OnOpen(),    #PB_Event_Websocket_OnOpen)
	P2W_BindNetworkEvent(myWebsocket, @WS_OnClose(),   #PB_Event_Websocket_OnClose)
	P2W_BindNetworkEvent(myWebsocket, @WS_OnMessage(), #PB_Event_Websocket_OnMessage)
	P2W_BindNetworkEvent(myWebsocket, @WS_OnError(),   #PB_Event_Websocket_OnError)
	
	Debug("myWebsocket: OK")
	
Else
	
	Debug("myWebsocket: not OK!")
	
EndIf		
; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 102
; FirstLine = 75
; Folding = --
; EnableXP