EnableExplicit

Enumeration 
	#frmMain
EndEnumeration

Enumeration
	#WebGadget
EndEnumeration

Procedure.s GetExePath()
	Protected ExePath.s = GetPathPart(ProgramFilename())
	If LCase(ExePath) = LCase(GetTemporaryDirectory()) : ExePath = GetCurrentDirectory() : EndIf
	If Right(ExePath, 1) <> "\" : ExePath + "\" : EndIf
	ProcedureReturn ExePath
EndProcedure

Procedure SetBrowserEmulation()
	
	; https://msdn.microsoft.com/en-us/library/ee330730(v=vs.85).aspx
	
	Protected IEVersion.s = "2AF9"
	
	; 11001 (0x2AF9) IE11. Webpages are displayed in IE11 edge mode, regardless of the declared !DOCTYPE directive. Failing to declare a !DOCTYPE directive causes the page to load in Quirks.
	; 11000 (0x2AF8) IE11. Webpages containing standards-based !DOCTYPE directives are displayed in IE11 edge mode. Default value for IE11.
	; 10001 (0x2711) IE10. Webpages are displayed in IE10 Standards mode, regardless of the !DOCTYPE directive.
	; 10000 (0x2710) IE10. Webpages containing standards-based !DOCTYPE directives are displayed in IE10 Standards mode. Default value for IE 10.
	;  9999 (0x270F) IE9.  Webpages are displayed in IE9 Standards mode, regardless of the declared !DOCTYPE directive. Failing to declare a !DOCTYPE directive causes the page to load in Quirks.
	;  9000 (0x2328) IE9.  Webpages containing standards-based !DOCTYPE directives are displayed in IE9 mode. Default value for IE 9. Important  In IE 10, Webpages containing standards-based !DOCTYPE directives are displayed in IE10 Standards mode.
	;  8888 (0x22B8) IE8.  Webpages are displayed in IE8 Standards mode, regardless of the declared !DOCTYPE directive. Failing to declare a !DOCTYPE directive causes the page to load in Quirks.
	;  8000 (0x1F40) IE8.  Webpages containing standards-based !DOCTYPE directives are displayed in IE8 mode. Default value for IE 8 Important  In IE 10, Webpages containing standards-based !DOCTYPE directives are displayed in IE10 Standards mode.
	;  7000 (0x1B58) IE7.  Webpages containing standards-based !DOCTYPE directives are displayed in IE7 Standards mode. Default value for applications hosting the WebBrowser Control.	
	
	Protected RegistryString.s
	Protected TempRegFile.s
	Protected FF
	
	RegistryString = "Windows Registry Editor Version 5.00" + #CRLF$ +
	                 "" + #CRLF$ +
	                 "[HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION]" + #CRLF$ +
	                 Chr(34) + GetFilePart(ProgramFilename()) + Chr(34) + "=dword:" + IEVersion + #CRLF$
	
	TempRegFile = GetTemporaryDirectory() + "SetBrowserEmulation.reg"
	
	FF = CreateFile(#PB_Any, TempRegFile)
	
	If FF
		WriteString(FF, RegistryString)
		CloseFile(FF)
		RunProgram("regedit", "/s " + Chr(34) + TempRegFile + Chr(34), "", #PB_Program_Hide | #PB_Program_Wait)
		DeleteFile(TempRegFile)
		ProcedureReturn #True
	EndIf
	
EndProcedure

; SetBrowserEmulation()

Define ExePath.s = GetExePath()

Define TW

Define Port.s = "8008"

TW = RunProgram( ExePath + "TinyWeb\Tiny.exe",
                 ExePath + "www\ " + Port,
                 ExePath + "www\logs\", 
                 #PB_Program_Open)

If TW
	
	OpenWindow(#frmMain, #PB_Ignore, #PB_Ignore, 800, 600, "MyDesktopApp", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	WebGadget(#WebGadget, 0, 0, 800, 600, "http://localhost:" + Port + "/index.html?rnd=" + ElapsedMilliseconds())
	
	Repeat
	Until WaitWindowEvent() = #PB_Event_CloseWindow
	
	KillProgram(TW)
	CloseProgram(TW)
	
Else
	
	MessageRequester("!", "!")
	
EndIf

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 39
; FirstLine = 33
; Folding = 8
; EnableUnicode
; Executable = DesktopApp.exe
; CompileSourceDirectory