XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

Global LastX = 0

Procedure OpenFileRequester2Callback(UploadEvent, Message.s)
	
	; Note: If upload to a server, CurrentFileNumber and 
	; TotalFileNumber is always 1 (regardless, how many files
	; do you have selected), FileName and FileType is 'unknown'
	; and FileSize is 0
	
	; FileContent is only filled if you upload to the client
	
	Debug "!"
	
	Protected CurrentFileNumber.s  = ""
	Protected TotalFileNumber.s    = ""
	Protected FileName.s           = ""
	Protected FileType.s           = ""
	Protected FileSize.s           = ""
	Protected FileContent.s        = ""
	Protected Position.s           = ""
	Protected Total.s              = ""
	Protected PercentageComplete.s = ""
	
	Select UploadEvent
			
		Case #PB_Event_Upload_BeforeSend 
			
			Debug("PB_Event_Upload_BeforeSend: " + ReplaceString(Message, #LF$, " "))
			
			CurrentFileNumber.s = StringField(Message, 1, #LF$)
			TotalFileNumber.s   = StringField(Message, 2, #LF$)
			FileName.s          = StringField(Message, 3, #LF$)
			FileType.s          = StringField(Message, 4, #LF$)
			FileSize.s          = StringField(Message, 5, #LF$)
			
			Debug "File: " + CurrentFileNumber + " from " + TotalFileNumber
			Debug "Filename: " + FileName
			Debug "Filetype: " + FileType
			Debug "FileSize: " + FileSize
			
			If Val(FileSize) > 100000 ; for demonstration:
				Debug "Filesize is to large. Canceling upload..."
				ProcedureReturn #True ; cancel upload (only on client-upload)
			EndIf
			
		Case #PB_Event_Upload_Complete 
			
			Debug("PB_Event_Upload_Complete")
			
			CurrentFileNumber.s  = StringField(Message, 1, #LF$)
			TotalFileNumber.s    = StringField(Message, 2, #LF$)
			FileContent.s        = StringField(Message, 3, #LF$)
			
			If Left(FileContent, Len("data:image/png")) = "data:image/png"
				
				; Now we have Imagedata to catch
				
				Protected UploadedImage = CatchImage(#PB_Any, @FileContent)
				
				; ... and load the catched image to an ImageGadget
				
				Protected myImageGadget = ImageGadget(#PB_Any, LastX, 100, ImageWidth(UploadedImage), ImageHeight(UploadedImage), UploadedImage)
				
				LastX = GadgetX(myImageGadget) + GadgetWidth(myImageGadget) + 10
				
				FreeImage(UploadedImage)
				
			Else
				
				; ordinary message from the server, we have uploaded the image
				
				Debug Message
				
			EndIf	
			
		Case #PB_Event_Upload_Error          
			
			Debug("PB_Event_Upload_Error: " + ReplaceString(Message, #LF$, " "))
			
		Case #PB_Event_Upload_Success
			
			Debug("PB_Event_Upload_Success: " + ReplaceString(Message, #LF$, " "))
			
		Case #PB_Event_Upload_UploadProgress
			
			Debug("PB_Event_Upload_UploadProgress: " + ReplaceString(Message, #LF$, " "))
			
			; Progressinformations (e.g. to display a progressbar)
			; Note: these Informations are asynchronously. You must
			; consider the CurrentFileNumber
			
			CurrentFileNumber.s  = StringField(Message, 1, #LF$)
			TotalFileNumber.s    = StringField(Message, 2, #LF$)
			Position.s           = StringField(Message, 3, #LF$)
			Total.s              = StringField(Message, 4, #LF$)
			PercentageComplete.s = StringField(Message, 5, #LF$)
			
			Debug "CurrentFileNumber: "  + CurrentFileNumber
			Debug "TotalFileNumber: "    + TotalFileNumber
			Debug "Position: "           + Position
			Debug "Total: "              + Total
			Debug "PercentageComplete: " + PercentageComplete + "%"
			
			Debug "---"
			
		Default
			
			Debug UploadEvent
			
	EndSelect
	
EndProcedure

Procedure OpenFileRequester2Callback2(UploadEvent, Message.s)
	
	Select UploadEvent
		Case #PB_Event_Upload_Complete
			Debug Message
	EndSelect
	
EndProcedure

Procedure OpenOpenFileRequester2()
	
	; 1. Parameter: Ignored
	; 2. Parameter: Upload-URL
	; 3. Parameter: Mime-Type (see: http://www.webmaster-toolkit.com/mime-types.shtml)
	; 4. Parameter: MaxFileSize in bytes
	; 5: 0 or #PB_Requester_MultiSelection (works only in browser with HTML5-Support)
	; 6: A callback to get the upload events
	
	; Upload to a php-file:
	
	; 	OpenFileRequester2("", 
	; 	                  "http://localhost/pb2webtest/upload.php",
	; 	                  "image/*", 
	; 	                  10000,
	; 	                  #PB_Requester_MultiSelection,
	; 	                  @OpenFileRequester2Callback())
	
	; Upload to the client (leave DefaultFile empty). No need for a server
	
	; for images...
	
	 	OpenFileRequester2("", 
	 	                  "",
	 	                  "image/*", 
	 	                  10000,
	 	                  #PB_Requester_MultiSelection,
	 	                  @OpenFileRequester2Callback())
	
	
	; for text-files...
	
; 	OpenFileRequester2("", 
; 	                   "",
; 	                   "text/plain", 
; 	                   0,
; 	                   0,
; 	                   @OpenFileRequester2Callback2())
	
EndProcedure

LoadFont(0, "Arial", 14)

TextGadget(0, 10, 10, 250, 30, "Please copy 'upload.php' to your webserver before uploading.")

SetGadgetFont(0, 0)

FreeFont(0)

ButtonGadget(1, 10, 50, 250, 30, "OpenFileRequester2()")

BindGadgetEvent(1, @OpenOpenFileRequester2())

DataSection
	IncludeBinary "upload.php"
EndDataSection
; IDE Options = PureBasic 5.30 Beta 3 (Windows - x86)
; CursorPosition = 140
; FirstLine = 42
; Folding = -
; EnableXP