XIncludeFile "TreeGadget2.pbf"

XIncludeFile "..\p2w.pbi"

OpenfrmMain()

Procedure cmdAddGadgetItem_Event()
  AddGadgetItem(#Tree_0, -1, "Node " + Str(CountGadgetItems(#Tree_0)))
EndProcedure

Procedure cmdAddGadgetItemAsChild_Event()
  Protected SelectedIndex = GetGadgetState(#Tree_0)
  If SelectedIndex > -1
    AddGadgetItem(#Tree_0, SelectedIndex + 1, "ChildNode", 0, 1)
  EndIf
EndProcedure

Procedure cmdRemoveGadgetItem_Event()
  Protected SelectedIndex = GetGadgetState(#Tree_0)
  If SelectedIndex > -1
    RemoveGadgetItem(#Tree_0, SelectedIndex)
  EndIf
EndProcedure

Procedure cmdGetGadgetState_Event()
  MessageRequester("TreeGadget", Str(GetGadgetState(#Tree_0)))
EndProcedure

Procedure cmdClearGadgetItems_Event()
  ClearGadgetItems(#Tree_0)
EndProcedure

Procedure cmdCountGadgetItems_Event()
  MessageRequester("TreeGadget", Str(CountGadgetItems(#Tree_0)))
EndProcedure

Procedure cmdGetGadgetItemState_Event()
  
  Protected SelectedIndex
  Protected ItemState 
  Protected ItemStateText.s
  
  SelectedIndex = GetGadgetState(#Tree_0)
  
  If SelectedIndex > -1
    
    ItemState = GetGadgetItemState(#Tree_0, SelectedIndex)
    
    ItemStateText = "ItemState " + Str(ItemState) + ":" + #LF$
    
    If (ItemState & #PB_Tree_Selected) = #PB_Tree_Selected
      ItemStateText = ItemStateText + "Item is selected" + #LF$
    Else
      ItemStateText = ItemStateText + "Item is not selected" + #LF$
    EndIf
    
    If (ItemState & #PB_Tree_Checked) = #PB_Tree_Checked
      ItemStateText = ItemStateText + "Item is checked" + #LF$
    Else
      ItemStateText = ItemStateText + "Item is not checked" + #LF$
    EndIf
    
    If (ItemState & #PB_Tree_Expanded)
      ItemStateText = ItemStateText + "Item is expanded" + #LF$
    Else
      ItemStateText = ItemStateText + "Item is not expanded" + #LF$
    EndIf
    
    If (ItemState & #PB_Tree_Collapsed)
      ItemStateText = ItemStateText + "Item is collapsed" + #LF$
    Else
      ItemStateText = ItemStateText + "Item is not collapsed" + #LF$
    EndIf
    
    MessageRequester("TreeGadget", ItemStateText)
    
  EndIf
  
EndProcedure

Procedure cmdGetGadgetItemText_Event()
  
  Protected SelectedIndex = GetGadgetState(#Tree_0)
  
  If SelectedIndex > -1
    MessageRequester("TreeGadget", GetGadgetItemText(#Tree_0, SelectedIndex))
  EndIf
  
EndProcedure

Procedure cmdSetGadgetItemText_Event()
  
  Protected SelectedIndex = GetGadgetState(#Tree_0)
  
  If SelectedIndex > -1
    SetGadgetItemText(#Tree_0, SelectedIndex, GetGadgetText(#txtSetGadgetItemText))
  EndIf
  
EndProcedure

Procedure cmdSetGadgetText_Event()
  
  SetGadgetText(#Tree_0, GetGadgetText(#txtSetGadgetText))
  
EndProcedure

Procedure cmdGetGadgetText_Event()
  
  MessageRequester("TreeGadget", GetGadgetText(#Tree_0))
  
EndProcedure


AddGadgetItem(#Tree_0, -1, "Root")
AddGadgetItem(#Tree_0, -1, "Child", 0, 1)

BindGadgetEvent(#cmdAddGadgetItem,        @cmdAddGadgetItem_Event())
BindGadgetEvent(#cmdAddGadgetItemAsChild, @cmdAddGadgetItemAsChild_Event())
BindGadgetEvent(#cmdRemoveGadgetItem,     @cmdRemoveGadgetItem_Event())
BindGadgetEvent(#cmdClearGadgetItems,     @cmdClearGadgetItems_Event())
BindGadgetEvent(#cmdCountGadgetItems,     @cmdCountGadgetItems_Event())
BindGadgetEvent(#cmdGetGadgetState,       @cmdGetGadgetState_Event())
BindGadgetEvent(#cmdGetGadgetItemState,   @cmdGetGadgetItemState_Event())

BindGadgetEvent(#cmdSetGadgetItemText,    @cmdSetGadgetItemText_Event())
BindGadgetEvent(#cmdGetGadgetItemText,    @cmdGetGadgetItemText_Event())

BindGadgetEvent(#cmdSetGadgetText,        @cmdSetGadgetText_Event())
BindGadgetEvent(#cmdGetGadgetText,        @cmdGetGadgetText_Event())

; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 27
; Folding = Ag
; EnableXP