; DesktopIconGadget

EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\DesktopIconGadget\DesktopIconGadget.pbi"

P2W_Converter_SetProfile("pb2webtest")

Global CurrentDesktopIcon

Enumeration
	#Desktop
	#digDriveC
	#digDriveD
	#digComputer
	#digPrefs
	#digTrashBin
EndEnumeration

Procedure onDesktopResize()
	
	Protected newLeft = WindowWidth (#Desktop) - GadgetWidth(#digTrashBin) - 10
	
	ResizeGadget(#digTrashBin, newLeft, 10, #PB_Ignore, #PB_Ignore)
	
EndProcedure

Procedure MessageRequesterCallback(MessageRequesterResult)
	
	Select MessageRequesterResult
		Case #PB_MessageRequester_Yes
			FreeGadget(CurrentDesktopIcon)
		Case #PB_MessageRequester_No
			HideGadget(CurrentDesktopIcon, #False)
			; revert position
			! $("#g_" + CurrentDesktopIcon).animate($("#g_" + CurrentDesktopIcon).data("origPosition"),"slow");
	EndSelect
	
EndProcedure

Procedure DesktopIconGadgetEvent()
	
	Protected EventMessage.s
	
	Select EventType()
		Case #PB_EventType_LeftDoubleClick : EventMessage = "#PB_EventType_LeftDoubleClick"
		Case #PB_EventType_LeftClick       : EventMessage = "#PB_EventType_LeftClick"
		Case #PB_EventType_RightClick      : EventMessage = "#PB_EventType_RightClick"
		Case #PB_EventType_LeftButtonUp    : EventMessage = "#PB_EventType_LeftButtonUp"
		Case #PB_EventType_LeftButtonDown  : EventMessage = "#PB_EventType_LeftButtonDown"
		Case #PB_EventType_RightButtonUp   : EventMessage = "#PB_EventType_RightButtonUp"
		Case #PB_EventType_RightButtonDown : EventMessage = "#PB_EventType_RightButtonDown"
		Default                            : EventMessage = "[unknown eventtype]"
	EndSelect
	
	EventMessage + " on "
			
	Select EventGadget()
		Case #digComputer : EventMessage + "#digComputer"
		Case #digDriveC   : EventMessage + "#digDriveC"
		Case #digDriveD   : EventMessage + "#digDriveD"
		Case #digPrefs    : EventMessage + "#digPrefs"
		Case #digTrashBin : EventMessage + "#digTrashBin"
		Default           : EventMessage + "[unknown gadget]"
	EndSelect
	
	Debug EventMessage
	
EndProcedure

Procedure DragCallback(event, ui)
	
	;	Debug "DragCallback()"
	;	Debug EventDragGadget()
	;	Debug Str(EventDragX()) + " / " + Str(EventDragY())
	;
	;	Debug event
	;	Debug ui
	;
	;	Debug "-----"
	
EndProcedure

Procedure DropCallback(event, ui)
	
	;	Debug "DropCallback()"
	;	Debug EventDropGadget()
	;	Debug Str(EventDropX()) + " / " + Str(EventDropY())
	;
	;	Debug event
	;	Debug ui
	;
	;	Debug "-----"
	
	If EventDropGadget() = #digTrashBin
		
		CurrentDesktopIcon = EventDragGadget()
		
		HideGadget(CurrentDesktopIcon, #True)
		
		MessageRequester("Really?", "Do you want to delete '" + GetGadgetText(CurrentDesktopIcon) + "'?", #PB_MessageRequester_YesNo, @MessageRequesterCallback())
		
	EndIf
	
EndProcedure

OpenWindow(#Desktop, 0, 0, 0, 0, "DesktopIconGadget-Test", #PB_Window_Maximize | #PB_Window_BorderLess)

SetWindowBackgroundImage(#Desktop, "wallpaper.jpg")

BindEvent(#PB_Event_SizeWindow, @onDesktopResize(), #Desktop)


Define DragOptions

! DragOptions = {
!		grid: [ 10, 10 ],
!	}

DesktopIconGadget(#digComputer, 10, 10, 64, 64, "Computer", 0, @"Gnome-Computer-64.png")
GadgetToolTip    (#digComputer, "Computer")
BindGadgetEvent  (#digComputer, @DesktopIconGadgetEvent())
EnableGadgetDrag (#digComputer, #True, DragOptions)
SetGadgetColor   (#digComputer, #PB_Gadget_FrontColor, #White)

DesktopIconGadget(#digDriveC, 10, 100, 64, 64, "Drive C", 0, @"Gnome-Drive-Harddisk-64.png")
GadgetToolTip    (#digDriveC, "Drive C")
BindGadgetEvent  (#digDriveC, @DesktopIconGadgetEvent())
EnableGadgetDrag (#digDriveC, #True, DragOptions)
SetGadgetColor   (#digDriveC, #PB_Gadget_FrontColor, #White)

DesktopIconGadget(#digDriveD, 10, 190, 64, 64, "Drive D", 0, @"Gnome-Drive-Harddisk-64.png")
GadgetToolTip    (#digDriveD, "Drive D:")
BindGadgetEvent  (#digDriveD, @DesktopIconGadgetEvent())
EnableGadgetDrag (#digDriveD, #True, DragOptions)
SetGadgetColor   (#digDriveD, #PB_Gadget_FrontColor, #White)

DesktopIconGadget(#digPrefs, 10, 280, 64, 64, "Preferences", 0, @"Gnome-System-Run-64.png")
GadgetToolTip    (#digPrefs, "Preferences")
BindGadgetEvent  (#digPrefs, @DesktopIconGadgetEvent())
EnableGadgetDrag (#digPrefs, #True, DragOptions)
SetGadgetColor   (#digPrefs, #PB_Gadget_FrontColor, #White)

DesktopIconGadget(#digTrashBin, 10, 0, 64, 64, "Trash", 0, @"Gnome-Edit-Delete-64.png")
GadgetToolTip    (#digTrashBin, "TrashBin")
BindGadgetEvent  (#digTrashBin, @DesktopIconGadgetEvent())
SetGadgetColor   (#digTrashBin, #PB_Gadget_FrontColor, #White)
EnableGadgetDrag (#digTrashBin, #True, DragOptions)
EnableGadgetDrop (#digTrashBin, #True, #Null)



SetDragCallback(@DragCallback())
SetDropCallback(@DropCallback())

onDesktopResize()

DataSection
	IncludeBinary "wallpaper.jpg"
	IncludeBinary "Gnome-Computer-64.png"
	IncludeBinary "Gnome-Drive-Harddisk-64.png"
	IncludeBinary "Gnome-System-Run-64.png"
	IncludeBinary "Gnome-Edit-Delete-64.png"
EndDataSection



; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 39
; FirstLine = 37
; Folding = --
; EnableXP