EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\GoogleChartGadget\GoogleChartGadget.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration
	#frmMain
	#PanelGadget
	#myTimer
	#LineChart
	#BarChart
	#PieChart
	#GeoChart
	#ScatterChart
	#Gauge
	#Map
EndEnumeration

Declare TimerEvent()

Procedure DrawLineChart()
	
	; #################
	; # LineChart
	; #################
	
	; https://google-developers.appspot.com/chart/interactive/docs/gallery/linechart
	
	Protected myData
	Protected myOptions
	
	; Set options
	
	!	myOptions = {
	!		'title':'Company Performance'
	!	};
	
	SetGadgetAttribute(#LineChart, #GoogleChartGadgetOptions, myOptions)
	
	; Set Data
	
	!	myData = [
	!		['Year', 'Sales', 'Expenses'],
	!		['2004',    1000,        400],
	!		['2005',    1170,        460],
	!		['2006',     660,       1120],
	!		['2007',    1030,        540]
	!	];
	
	SetGadgetAttribute(#LineChart, #GoogleChartGadgetData, myData)
	
EndProcedure

Procedure DrawBarChart()
	
	; #################
	; # BarChart
	; #################
	
	; https://developers.google.com/chart/interactive/docs/gallery/barchart
	
	Protected myData
	Protected myOptions
	
	; Set options
	
	!	myOptions = {
	!		'title':'Company Performance'
	!	};
	
	SetGadgetAttribute(#BarChart, #GoogleChartGadgetOptions, myOptions)
	
	; Set Data
	
	; Set Data
	
	!	myData = [
	!		['Year', 'Sales', 'Expenses'],
	!		['2004',    1000,        400],
	!		['2005',    1170,        460],
	!		['2006',     660,       1120],
	!		['2007',    1030,        540]
	!	];
	
	SetGadgetAttribute(#BarChart, #GoogleChartGadgetData, myData)
	
EndProcedure

Procedure DrawPieChart()
	
	; #################
	; # PieChart
	; #################
	
	; https://google-developers.appspot.com/chart/interactive/docs/gallery/piechart
	
	Protected myData
	Protected myOptions
	
	; Set Options
	
	! myOptions = {
	!		'title' : 'How Much Pizza I Ate Last Night',
	!		'pieHole' : '0.4'
	!	};
	
	SetGadgetAttribute(#PieChart, #GoogleChartGadgetOptions, myOptions)
	
	; Set Data
	
	!	myData = [
	!		['Topping', 'Slices'],
	!		['Mushrooms', 3],
	!		['Onions',    1],
	!		['Olives',    1],
	!		['Zucchini',  1],
	!		['Pepperoni', 2]
	!	];
	
	SetGadgetAttribute(#PieChart, #GoogleChartGadgetData, myData)
	
EndProcedure

Procedure DrawGeoChart()
	
	; #################
	; # GeoChart
	; #################
	
	; https://google-developers.appspot.com/chart/interactive/docs/gallery/geochart
	
	Protected myData
	Protected myOptions
	
	; Set Options
	
	! myOptions = {};
	
	SetGadgetAttribute(#GeoChart, #GoogleChartGadgetOptions, myOptions)
	
	; Set Data
	
	!	myData = [
	!		['Country', 'Popularity'],
	!		['Germany',          200],
	!		['United States',    300],
	!		['Brazil',           400],
	!		['Canada',           500],
	!		['France',           600],
	!		['RU',               700]
	!	];
	
	SetGadgetAttribute(#GeoChart, #GoogleChartGadgetData, myData)
	
EndProcedure

Procedure DrawScatterChart()
	
	; #################
	; # ScatterChart
	; #################
	
	; https://google-developers.appspot.com/chart/interactive/docs/gallery/scatterchart
	
	Protected myData
	Protected myOptions
	
	; Set Options
	
	!	myOptions = {
	!		'title': 'Age vs. Weight comparison',
	!		'hAxis': {'title': 'Age', 'minValue': 0, 'maxValue': 15},
	!		'vAxis': {'title': 'Weight', 'minValue': 0, 'maxValue': 15},
	!		'legend': 'none'
	!	};
	
	SetGadgetAttribute(#ScatterChart, #GoogleChartGadgetOptions, myOptions)

	; Set Data
	
	!	myData = [
	!		['Age', 'Weight'],
	!		[8,           12],
	!		[4,          5.5],
	!		[11,          14],
	!		[4,            5],
	!		[3,          3.5],
	!		[6.5,          7]
	!	];
	
	SetGadgetAttribute(#ScatterChart, #GoogleChartGadgetData, myData)
	
EndProcedure

Procedure DrawGauge()
	
	; #################
	; # Gauge
	; #################
	
	; https://google-developers.appspot.com/chart/interactive/docs/gallery/gauge
	
	Protected myOptions
	Protected myData
	
	; Set Options
	
	! myOptions = {
	!		'redFrom' : 90,
	!		'redTo' : 100,
	!		'yellowFrom' : 75,
	!		'yellowTo' : 90,
	!		'minorTicks' : 5
	!	};
	
	SetGadgetAttribute(#Gauge, #GoogleChartGadgetOptions, myOptions)
	
	; Set Data
	
	!	myData = [
	!		['Label', 'Value'],
	!		['Memory',     80],
	!		['CPU',        55],
	!		['Network',    68]
	!	];
	
	SetGadgetAttribute(#Gauge, #GoogleChartGadgetData, myData)
	
	; Set a timer for updating Gauge-Values
	
 	AddWindowTimer(#frmMain, #myTimer, 1000)
 	BindEvent(#PB_Event_Timer, @TimerEvent(), #frmMain, #myTimer)
	
EndProcedure

Procedure DrawMap()
	
	; #################
	; # Map
	; #################
	
	; https://google-developers.appspot.com/chart/interactive/docs/gallery/map
	
	Protected myOptions
	Protected myData
	
	; Set Options
	
	! myOptions = {
	!		showTooltip: true,
	!		showInfoWindow: true,
	!		enableScrollWheel: true
	!	};	
	
	SetGadgetAttribute(#Map, #GoogleChartGadgetOptions, myOptions)
	
	; Set Data
	
	! myData = google.visualization.arrayToDataTable([
	!		['Country', 'Population'],
	!		['China', 'China: 1,363,800,000'],
	!		['India', 'India: 1,242,620,000'],
	!		['US', 'US: 317,842,000'],
	!		['Indonesia', 'Indonesia: 247,424,598'],
	!		['Brazil', 'Brazil: 201,032,714'],
	!		['Pakistan', 'Pakistan: 186,134,000'],
	!		['Nigeria', 'Nigeria: 173,615,000'],
	!		['Bangladesh', 'Bangladesh: 152,518,015'],
	!		['Russia', 'Russia: 146,019,512'],
	!		['Japan', 'Japan: 127,120,000']
	!	]);
	
	SetGadgetAttribute(#Map, #GoogleChartGadgetData, myData)
	
EndProcedure

Procedure TimerEvent()
	
	Protected myData
	
	Protected RandomMemoryValue = Random(100, 0)
	Protected RandomCpuValue = Random(100, 0)
	Protected RandomNetworkValue = Random(100, 0)
	
	!	myData = [
	!		['Label', 'Value'],
	!		['Memory',  RandomMemoryValue],
	!		['CPU',     RandomCpuValue],
	!		['Network', RandomNetworkValue]
	!	];
	
	SetGadgetAttribute(#Gauge, #GoogleChartGadgetData, myData)
	
EndProcedure

Procedure PanelGadgetEvent()
	
	If IsWindowTimer(#frmMain, #myTimer)
		RemoveWindowTimer(#frmMain, #myTimer)
	EndIf
	
	Select GetGadgetState(#PanelGadget)
		Case 0 ; LineChart
			DrawLineChart()
		Case 1 ; BarChart
			DrawBarChart()
		Case 2 ; PieChart
			DrawPieChart()
		Case 3 ; GeoChart
			DrawGeoChart()
		Case 4 ; ScatterChart
			DrawScatterChart()
		Case 5 ; Gauge
			DrawGauge()
		Case 6 ; Map
			DrawMap()
	EndSelect
	
EndProcedure

Procedure Main()
	
	OpenWindow(#frmMain, #PB_Ignore, #PB_Ignore, 720, 530, "GoogleChart", #PB_Window_ScreenCentered)
	
	PanelGadget(#PanelGadget, 10, 10, 700, 500)
	
	AddGadgetItem(#PanelGadget, -1, "LineChart")
	GoogleChartGadget(#LineChart, 10, 20, 670, 440, #GoogleChartTypeLine, #GoogleChartGadgetBorder)
	
	AddGadgetItem(#PanelGadget, -1, "BarChart")
	GoogleChartGadget(#BarChart, 10, 20, 670, 440, #GoogleChartTypeBar, #GoogleChartGadgetBorder)
	
	AddGadgetItem(#PanelGadget, -1, "PieChart")
	GoogleChartGadget(#PieChart, 10, 20, 670, 440, #GoogleChartTypePie, #GoogleChartGadgetBorder)
	
	AddGadgetItem(#PanelGadget, -1, "GeoChart")
	GoogleChartGadget(#GeoChart, 10, 20, 670, 440, #GoogleChartTypeGeo, #GoogleChartGadgetBorder)
	
	AddGadgetItem(#PanelGadget, -1, "ScatterChart")
	GoogleChartGadget(#ScatterChart, 10, 20, 670, 440, #GoogleChartTypeScatter, #GoogleChartGadgetBorder)
	
	AddGadgetItem(#PanelGadget, -1, "Gauge")
	GoogleChartGadget(#Gauge, 10, 20, 670, 440, #GoogleChartTypeGauge, #GoogleChartGadgetBorder)
	
	AddGadgetItem(#PanelGadget, -1, "Map")
	GoogleChartGadget(#Map, 10, 20, 670, 440, #GoogleChartTypeMap, #GoogleChartGadgetBorder)
	
	CloseGadgetList()
	
	BindGadgetEvent(#PanelGadget, @PanelGadgetEvent())
	
	SetGadgetState(#PanelGadget, 0)
	
	PanelGadgetEvent()
	
EndProcedure

Main()

; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 335
; Folding = Ag
; EnableXP