﻿EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\JsGridGadget\JsGridGadget.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration
	#Window
EndEnumeration

Enumeration
	#myJsGridGadget
EndEnumeration

Procedure SizeWindowEvent()
	
	ResizeGadget(#myJsGridGadget, 0, 0, WindowWidth(#Window), WindowHeight(#Window))	
	
EndProcedure

Procedure JsGridGadgetEvents(Event)
	
	Select EventType()
		Case #JsGrid_EventType_DataLoaded     : Debug "#JsGrid_EventType_DataLoaded"
		Case #JsGrid_EventType_DataLoading    : Debug "#JsGrid_EventType_DataLoading"
		Case #JsGrid_EventType_Error          : Debug "#JsGrid_EventType_Error"
		Case #JsGrid_EventType_Init           : Debug "#JsGrid_EventType_Init"
		Case #JsGrid_EventType_ItemDeleted    : Debug "#JsGrid_EventType_ItemDeleted"
		Case #JsGrid_EventType_ItemDeleting   : Debug "#JsGrid_EventType_ItemDeleting"
		Case #JsGrid_EventType_ItemInserted   : Debug "#JsGrid_EventType_ItemInserted"
		Case #JsGrid_EventType_ItemInserting  : Debug "#JsGrid_EventType_ItemInserting"
		Case #JsGrid_EventType_ItemInvalid    : Debug "#JsGrid_EventType_ItemInvalid"
		Case #JsGrid_EventType_ItemUpdated    : Debug "#JsGrid_EventType_ItemUpdated"
		Case #JsGrid_EventType_ItemUpdating   : Debug "#JsGrid_EventType_ItemUpdating"
		Case #JsGrid_EventType_OptionChanged  : ; Debug "#JsGrid_EventType_OptionChanged"
		Case #JsGrid_EventType_OptionChanging :	; Debug "#JsGrid_EventType_OptionChanging"
		Case #JsGrid_EventType_PageChanged    : Debug "#JsGrid_EventType_PageChanged"
		Case #JsGrid_EventType_Refreshed      : ; Debug "#JsGrid_EventType_Refreshed"
		Case #JsGrid_EventType_Refreshing     :	; Debug "#JsGrid_EventType_Refreshing"
			
		Case #JsGrid_EventType_RowClick       : ; Debug "#JsGrid_EventType_RowClick"
		Case #JsGrid_EventType_RowDoubleClick :	; Debug "#JsGrid_EventType_RowDoubleClick"
			
		Default                               : Debug EventType()
			
	EndSelect
	
EndProcedure

SetGuiSize("100%")

OpenWindow(#Window, #PB_Ignore, #PB_Ignore, 1500, 600, "JsGridGadget()", #PB_Window_ScreenCentered | #PB_Window_SizeGadget)

BindEvent(#PB_Event_SizeWindow, @SizeWindowEvent(), #Window)

JsGridGadget(#myJsGridGadget, 0, 0, WindowWidth(#Window), WindowHeight(#Window))

BindGadgetEvent(#myJsGridGadget, @JsGridGadgetEvents(), #PB_All)

SetGadgetAttribute(#myJsGridGadget, #JsGrid_Editing, #True)
SetGadgetAttribute(#myJsGridGadget, #JsGrid_Inserting, #True)
SetGadgetAttribute(#myJsGridGadget, #JsGrid_Sorting, #True)

SetGadgetAttribute(#myJsGridGadget, #JsGrid_ConfirmDeleting, #True)
SetGadgetAttribute(#myJsGridGadget, #JsGrid_DeleteConfirm, @"Really?")
SetGadgetAttribute(#myJsGridGadget, #JsGrid_NoDataContent, @"Ooops, no data!")

; Debug "JsGrid_NoDataContent: " + Str(GetGadgetAttribute(#myJsGridGadget, #JsGrid_NoDataContent))

Procedure SetFields_JsonStyle()
	
	Define countries
	
	!	countries = [
	!		{ Name: "", Id: 0 },
	!		{ Name: "United States", Id: 1 },
	!		{ Name: "Canada", Id: 2 },
	!		{ Name: "United Kingdom", Id: 3 },
	!		{ Name: "France", Id: 4 },
	!		{ Name: "Brazil", Id: 5 },
	!		{ Name: "China", Id: 6 },
	!		{ Name: "Russia", Id: 7 }
	!	];
	! window.countries = countries;
	
	Define fld
	
	!	fld = [
	!		{ name: "Name", type: "text", width: 150 },
	!		{ name: "Age", type: "number", width: 50 },
	!		{ name: "Address", type: "text", width: 200 },
	!		{ name: "Country", type: "select", items: countries, valueField: "Id", textField: "Name" },
	!		{ name: "Married", type: "checkbox", title: "Is Married", sorting: false },
	!		{ type: "control" }
	!	]
	
	SetGadgetAttribute(#myJsGridGadget, #JsGrid_Fields, fld)
	
EndProcedure
Procedure SetFields_PbStyle()
	
	Structure sCountry
		Id.i
		Name.s
	EndStructure
	
	NewList Country.sCountry()
	
	AddElement(Country())
	Country()\Name = ""
	Country()\Id = 0
	
	AddElement(Country())
	Country()\Name = "United States"
	Country()\Id = 1
	
	AddElement(Country())
	Country()\Name = "Canada"
	Country()\Id = 2
	
	AddElement(Country())
	Country()\Name = "United Kingdom"
	Country()\Id = 3
	
	AddElement(Country())
	Country()\Name = "France"
	Country()\Id = 4
	
	AddElement(Country())
	Country()\Name = "Brazil"
	Country()\Id = 5
	
	AddElement(Country())
	Country()\Name = "China"
	Country()\Id = 6
	
	AddElement(Country())
	Country()\Name = "Russia"
	Country()\Id = 7
	
	CreateJSON(0)
	InsertJSONList(JSONValue(0), Country())
	Protected Countries = JSONValue(0)
	
	Structure sField
		name.s
		type.s
		title.s
		width.i
		items.i
		sorting.i
		valueField.s
		textField.s
	EndStructure	
	
	NewList Field.sField()
	
	AddElement(Field())
	Field()\name = "Name"
	Field()\type = "text"
	Field()\width = 150
	
	AddElement(Field())
	Field()\name = "Age"
	Field()\type = "number"
	Field()\width = 50
	
	AddElement(Field())
	Field()\name = "Address"
	Field()\type = "text"
	Field()\width = 200
	
	AddElement(Field())
	Field()\name = "Country"
	Field()\type = "select"
	Field()\items = Countries
	Field()\valueField = "Id"
	Field()\textField = "Name"
	
	AddElement(Field())
	Field()\name = "Married"
	Field()\type = "checkbox"
	Field()\title = "Is Married"
	Field()\sorting = #False
	
	AddElement(Field())
	Field()\type = "control"
	
	CreateJSON(0)
	InsertJSONList(JSONValue(0), Field())
	SetGadgetAttribute(#myJsGridGadget, #JsGrid_Fields, JSONValue(0))
	
	FreeJSON(0)
	
EndProcedure

Procedure SetData_JsonStyle()
	
	Protected dta
	
	! dta = [{
	! 		"Name": "Otto Clay",
	! 		"Age": 61,
	! 		"Country": 6,
	! 		"Address": "Ap #897-1459 Quam Avenue",
	! 		"Married": false
	! 	}, {
	! 		"Name": "Connor Johnston",
	! 		"Age": 73,
	! 		"Country": 7,
	! 		"Address": "Ap #370-4647 Dis Av.",
	! 		"Married": false
	! 	}, {
	! 		"Name": "Lacey Hess",
	! 		"Age": 29,
	! 		"Country": 7,
	! 		"Address": "Ap #365-8835 Integer St.",
	! 		"Married": false
	! 	}, {
	! 		"Name": "Timothy Henson",
	! 		"Age": 78,
	! 		"Country": 1,
	! 		"Address": "911-5143 Luctus Ave",
	! 		"Married": false
	! 	}, {
	! 		"Name": "Ramona Benton",
	! 		"Age": 43,
	! 		"Country": 5,
	! 		"Address": "Ap #614-689 Vehicula Street",
	! 		"Married": true
	! 	}, {
	! 		"Name": "Ezra Tillman",
	! 		"Age": 51,
	! 		"Country": 1,
	! 		"Address": "P.O. Box 738, 7583 Quisque St.",
	! 		"Married": true
	! 	}, {
	! 		"Name": "Dante Carter",
	! 		"Age": 59,
	! 		"Country": 1,
	! 		"Address": "P.O. Box 976, 6316 Lorem, St.",
	! 		"Married": false
	! 	}, {
	! 		"Name": "Christopher Mcclure",
	! 		"Age": 58,
	! 		"Country": 1,
	! 		"Address": "847-4303 Dictum Av.",
	! 		"Married": true
	! 	}, {
	! 		"Name": "Ruby Rocha",
	! 		"Age": 62,
	! 		"Country": 2,
	! 		"Address": "5212 Sagittis Ave",
	! 		"Married": false
	! 	}, {
	! 		"Name": "Imelda Hardin",
	! 		"Age": 39,
	! 		"Country": 5,
	! 		"Address": "719-7009 Auctor Av.",
	! 		"Married": false
	! 	}
	! ];
	
	SetGadgetAttribute(#myJsGridGadget, #JsGrid_Data, dta)
	
EndProcedure
Procedure SetData_PbStyle()
	
	Structure sItem
		Name.s
		Age.i
		Country.i
		Address.s
		Married.i
	EndStructure
	
	NewList Item.sItem()
	
	AddElement(Item())
	
	Item()\Name = "Otto Clay"
	Item()\Age = 61
	Item()\Country = 6
	Item()\Address = "Ap #897-1459 Quam Avenue"
	Item()\Married = #False
	
	CreateJSON(0)
	InsertJSONList(JSONValue(0), Item())
	SetGadgetAttribute(#myJsGridGadget, #JsGrid_Data, JSONValue(0))
	FreeJSON(0)	
	
EndProcedure

; SetFields_JsonStyle()
; SetData_JsonStyle()

SetFields_PbStyle()
SetData_PbStyle()

; IDE Options = PureBasic 5.51 (Windows - x86)
; CursorPosition = 101
; FirstLine = 29
; Folding = jh
; EnableXP
; EnableUnicode