XIncludeFile "..\..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

EnableExplicit

Enumeration
  #frmHome
  #frmFolder
  #frmMail
  #frmPrefs
  #imgHome
  #imgMail
  #imgFolder
  #imgPrefs
  #imgExit
  #WebGadget
  #frmMain = 999
EndEnumeration

Procedure onDesktopResize()
  
  Protected newTop = WindowHeight(#frmMain) - GadgetHeight(#imgExit) - 10
  Protected newLeft = WindowWidth(#frmMain) - GadgetWidth(#imgExit) - 10
  
  ResizeGadget(#imgExit, newLeft, newTop, #PB_Ignore, #PB_Ignore)
  
EndProcedure

Procedure LoadImageCallback_Home(LoadedImage)
  SetGadgetState(#imgHome, LoadedImage)
EndProcedure
Procedure LoadImageCallback_Mail(LoadedImage)
  SetGadgetState(#imgMail, LoadedImage)
EndProcedure
Procedure LoadImageCallback_Folder(LoadedImage)
  SetGadgetState(#imgFolder, LoadedImage)
EndProcedure
Procedure LoadImageCallback_Prefs(LoadedImage)
  SetGadgetState(#imgPrefs, LoadedImage)
EndProcedure
Procedure LoadImageCallback_Exit(LoadedImage)
  SetGadgetState(#imgExit, LoadedImage)
EndProcedure

Procedure CloseHome()
	CloseWindow(#frmHome)
  DisableGadget(#imgHome, #False)
EndProcedure
Procedure OpenHome()
  DisableGadget(#imgHome, #True)
  OpenWindow(#frmHome, 100, 100, 400, 300, "Home")
  BindEvent(#PB_Event_CloseWindow, @CloseHome(), #frmHome)
EndProcedure

Procedure CloseFolder()
	CloseWindow(#frmFolder)
  DisableGadget(#imgFolder, #False)
EndProcedure
Procedure OpenFolder()
  DisableGadget(#imgFolder, #True)
  OpenWindow(#frmFolder, 200, 200, 500, 400, "Folder")
  WebGadget(#WebGadget, 10, 10, 480, 380, "http://www.sanger.dk")
  BindEvent(#PB_Event_CloseWindow, @CloseFolder(), #frmFolder)
EndProcedure

Procedure CloseMail()
	CloseWindow(#frmMail)
  DisableGadget(#imgMail, #False)
EndProcedure
Procedure OpenMail()
  DisableGadget(#imgMail, #True)
  OpenWindow(#frmMail, 300, 300, 400, 300, "Mail")
  BindEvent(#PB_Event_CloseWindow, @CloseMail(), #frmMail)
EndProcedure

Procedure ClosePrefs()
	CloseWindow(#frmPrefs)
  DisableGadget(#imgPrefs, #False)
EndProcedure
Procedure OpenPrefs()
  DisableGadget(#imgPrefs, #True)
  OpenWindow(#frmPrefs, 300, 300, 400, 300, "Preferences")
  BindEvent(#PB_Event_CloseWindow, @ClosePrefs(), #frmPrefs)
EndProcedure

Procedure MessageRequesterCallback(MessageRequesterResult)
  If MessageRequesterResult = #PB_MessageRequester_Yes
    RunProgram("http://www.pb2web.de", "_self", "")
  EndIf
EndProcedure
Procedure ExitDesktop()
  MessageRequester("Exit", "Really?", #PB_MessageRequester_YesNo, @MessageRequesterCallback())
EndProcedure

OpenWindow(#frmMain, 0, 0, 0, 0, "Desktop-Demo", #PB_Window_Maximize | #PB_Window_BorderLess)

Define JQO

JQO = P2W_JQO_FromWindow(#frmMain)
P2W_JQO_CSS(JQO, "background-image", "url(wallpaper.jpg)")

ImageGadget(#imgHome, 10, 10, 64, 64, 0)
LoadImage(#PB_Any, "home.png", 0, @LoadImageCallback_Home())
SetGadgetCursor(#imgHome, #PB_Cursor_Hand)
GadgetToolTip(#imgHome, "Open Home-Window")
BindGadgetEvent(#imgHome, @OpenHome(), #PB_EventType_LeftClick)

ImageGadget(#imgMail, 10, GadgetY(#imgHome) + 64 + 10, 64, 64, 0)
LoadImage(#PB_Any, "mail.png", 0, @LoadImageCallback_Mail())
SetGadgetCursor(#imgMail, #PB_Cursor_Hand)
GadgetToolTip(#imgMail, "Open Mail-Window")
BindGadgetEvent(#imgMail, @OpenMail(), #PB_EventType_LeftClick)

ImageGadget(#imgFolder, 10, GadgetY(#imgMail) + 64 + 10, 64, 64, 0)
LoadImage(#PB_Any, "folder.png", 0, @LoadImageCallback_Folder())
SetGadgetCursor(#imgFolder, #PB_Cursor_Hand)
GadgetToolTip(#imgFolder, "Open Folder-Window")
BindGadgetEvent(#imgFolder, @OpenFolder(), #PB_EventType_LeftClick)

ImageGadget(#imgPrefs, 10, GadgetY(#imgFolder) + 64 + 10, 64, 64, 0)
LoadImage(#PB_Any, "prefs.png", 0, @LoadImageCallback_Prefs())
SetGadgetCursor(#imgPrefs, #PB_Cursor_Hand)
GadgetToolTip(#imgPrefs, "Open Preferences-Window")
BindGadgetEvent(#imgPrefs, @OpenPrefs(), #PB_EventType_LeftClick)

ImageGadget(#imgExit, 10, 0, 64, 64, 0)
LoadImage(#PB_Any, "exit.png", 0, @LoadImageCallback_Exit())
SetGadgetCursor(#imgExit, #PB_Cursor_Hand)
GadgetToolTip(#imgExit, "Exit this marvelous application")
BindGadgetEvent(#imgExit, @ExitDesktop(), #PB_EventType_LeftClick)

BindEvent(#PB_Event_SizeWindow, @onDesktopResize(), #frmMain)

onDesktopResize()

DataSection
  IncludeBinary "wallpaper.jpg"
  IncludeBinary "mail.png"
  IncludeBinary "folder.png"
  IncludeBinary "home.png"
  IncludeBinary "prefs.png"
  IncludeBinary "exit.png"
EndDataSection


; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 95
; Folding = AAg-
; EnableXP