EnableExplicit

XIncludeFile "..\..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration
	#Desktop
	#myToolbar
	#tbbNew
	#tbbOpen
	#tbbSave
	#Panel
EndEnumeration

Global NewList Editor()

Procedure AddPanel()
	
	OpenGadgetList(#Panel)
		
		AddGadgetItem(#Panel, -1, "New " + Str(CountGadgetItems(#Panel)))
		AddElement(Editor())
		Editor() = AceEditorGadget(#PB_Any, 0, 10, GetGadgetAttribute(#Panel, #PB_Panel_ItemWidth), GetGadgetAttribute(#Panel, #PB_Panel_ItemHeight) - 20)
		
	CloseGadgetList()
	
	SetGadgetItemText(Editor(), #PB_AceEditor_Theme, "eclipse")
	SetGadgetItemText(Editor(), #PB_AceEditor_Mode, "javascript")  
	
	SetGadgetText(Editor(), "Editor: " + Str(CountGadgetItems(#Panel) - 1) )
	
	SetGadgetState( #Panel, CountGadgetItems(#Panel) - 1 )
	
EndProcedure

Procedure tbbNew_Event()
	
	AddPanel()
	
EndProcedure

Procedure OpenFileRequester_Callback(FileObject, Filename.s)
	
	If Filename = "" : ProcedureReturn : EndIf
	
	Protected Filecontent.s = ""
	
	EnableJS
		;var fs = require("fs");
		;Filecontent = fs.readFileSync(Filename, "utf8");
	DisableJS
	
	; SetGadgetText(#Editor, Filecontent)
	
EndProcedure

Procedure tbbOpen_Event()
	
	OpenFileRequester("", "", "", 0, 0, @OpenFileRequester_Callback())
	
EndProcedure

Procedure SaveFileRequester_Callback(FileObject, Filename.s)
	
	If Filename = "" : ProcedureReturn : EndIf
	
	; Protected Filecontent.s = GetGadgetText(#Editor)
	
	EnableJS
		;var fs = require("fs");
		;fs.writeFileSync(Filename, Filecontent);
	DisableJS
	
EndProcedure

Procedure tbbSave_Event()
	
	SaveFileRequester("", "", "", 0, @SaveFileRequester_Callback())

EndProcedure

Procedure SizeWindow_Event()
	
	ResizeGadget(#Panel, 
	             10, 
	             ToolBarHeight(#myToolbar) + 20, 
	             DesktopWidth(#Desktop) - 20, 
	             DesktopHeight(#Desktop) - ToolBarHeight(#myToolbar) - 30)
	
	ForEach Editor()
		
  	ResizeGadget(Editor(),
  	             0,
  	             10,
  	             GetGadgetAttribute(#Panel, #PB_Panel_ItemWidth),
  	             GetGadgetAttribute(#Panel, #PB_Panel_ItemHeight) - 20)
  	
  Next
  
EndProcedure

P2W_SetDesktopID(#Desktop)

CreateToolBar(#myToolbar, WindowID(#Desktop))

ToolBarStandardButton(#tbbNew, #PB_ToolBarIcon_New)
ToolBarToolTip(#myToolbar, #tbbNew, "New")

ToolBarStandardButton(#tbbOpen, #PB_ToolBarIcon_Open)
ToolBarToolTip(#myToolbar, #tbbOpen, "Open")

ToolBarStandardButton(#tbbSave, #PB_ToolBarIcon_Save)
ToolBarToolTip(#myToolbar, #tbbSave, "Save")

BindEvent(#PB_Event_Menu, @tbbNew_Event(),  #Desktop, #tbbNew)
BindEvent(#PB_Event_Menu, @tbbOpen_Event(), #Desktop, #tbbOpen)
BindEvent(#PB_Event_Menu, @tbbSave_Event(), #Desktop, #tbbSave)

PanelGadget(#Panel, 
            10, 
            ToolBarHeight(#myToolbar) + 15, 
            DesktopWidth(#Desktop) - 20, 
            DesktopHeight(#Desktop) - ToolBarHeight(#myToolbar) - 30) ; ,
            ; #PB_PanelGadget_Closable | #PB_PanelGadget_Sortable)

CloseGadgetList()

BindEvent(#PB_Event_SizeWindow, @SizeWindow_Event(), #Desktop)

AddPanel()

; 
; Define JavaScriptSnippet_Right.s = "function myTestRight() {" + #CRLF$ +
;                                    "  var myVar = 1;" + #CRLF$ +
;                                    "}" + #CRLF$
; 
; Define JavaScriptSnippet_Wrong.s = "function myTestWrong( {" + #CRLF$ +
;                                    "  var myVar = 1;" + #CRLF$ +
;                                    "}" + #CRLF$
; 
; SetGadgetText(#Editor, JavaScriptSnippet_Right + #CRLF$ + JavaScriptSnippet_Wrong)
; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 18
; Folding = --
; EnableXP