﻿Structure sP2W_Grid_ColumnModel
	align.s ; Possible values are "left", "right" and "center".
	className.s ; Class to be assigned to whole column.
	dataIndx.i ; Zero based index in array or key name in JSON of the column.
	dataType.s ; Possible string values are "string","integer" and "float". 
	editable.i ; #True or #False
	editor.i ; callback function
	getEditCellData.i ; It's a callback function used to save data from custom editor.
	hidden.i ; Column can be hidden using this option.
	render.i ; It's a callback function which needs to return view of data for a cell.
	title.s ; Title or Heading of the column.
	width.i ; Width of the column.
EndStructure

Structure sP2W_Grid_DataModel
	beforeSend.l
	curPage.l
	xData.l
	dataType.l
	error.l
	getData.l
	getUrl.l
	location.l
	method.l
	paging.s ; Paging can be enabled for both local and remote requests. It has 2 possible values "local" and "remote". Paging is disabled when it's null.
	rPP.l ; It denotes initial results per page when paging has been enabled.
	rPPOptions.l ; Results per page options in dropdown when paging has been enabled.
	sortDir.l
	sortIndx.l
	sorting.l
EndStructure

Structure sP2W_Grid_SelectionModel
	type.s ; row or cell
	mode.s ; single, range or block
EndStructure

Structure sP2W_Grid_ScrollModel
	horizontal.l	; #True or #False
	pace.s 				; Possible values are 'consistent', 'optimum' and 'fast'
EndStructure

Structure sP2W_Grid_EditModel
	clicksToEdit.l
	saveKey.l
EndStructure

Structure sP2W_Grid_GridOptions
	bottomVisible.l
	columnBorders.l
	customData.l
	draggable.l
	editable.l
	editModel.sP2W_Grid_EditModel
	flexHeight.l
	flexWidth.l
	freezeCols.l
	height.l
	hoverMode.l
	minWidth.l
	numberCell.l
	numberCellWidth.l
	oddRowsHighlight.l
	resizable.l
	roundCorners.l
	rowBorders.l
	scrollModel.sP2W_Grid_ScrollModel
	selectionModel.sP2W_Grid_SelectionModel
	sortable.l
	title.s
	topVisible.l
	width.l
	wrap.l
EndStructure

P2W_Converter_Begin_Comment

Procedure P2W_GridGadget(Gadget, x, y, Width, Height, GridOptions, Array ColumnModel.sP2W_Grid_ColumnModel(1), DataModel, Array GridData.s(2))
EndProcedure

P2W_Converter_End_Comment
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 42
; Folding = A-
; EnableUnicode
; EnableXP