
#PB_WidgetType_Button         = "Button"
#PB_WidgetType_String         = "String"
#PB_WidgetType_ListView       = "ListView"
#PB_WidgetType_HeaderButton   = "HeaderButton"
#PB_WidgetType_Container      = "Container"
#PB_WidgetType_Spacer         = "Spacer"
#PB_WidgetType_Navbar         = "Navbar"
#PB_WidgetType_Controlgroup   = "Controlgroup"
#PB_WidgetType_ListItem       = "ListItem"
#PB_WidgetType_CheckBox       = "CheckBox"
#PB_WidgetType_Radio          = "Radio"
#PB_WidgetType_Fieldset       = "Fieldset"
#PB_WidgetType_Panel          = "Panel"
#PB_WidgetType_Link           = "Link"
#PB_WidgetType_Flipswitch     = "Flipswitch"
#PB_WidgetType_Text           = "Text"

; Attributes:

#PB_Widget_Icon = 1
#PB_Widget_Inline = 2
#PB_Widget_Mini = 3

#PB_Widget_IconPosition = 4
#PB_Widget_IconPosition_Left = 1
#PB_Widget_IconPosition_Right = 2
#PB_Widget_IconPosition_Top = 3
#PB_Widget_IconPosition_Bottom = 4
#PB_Widget_IconPosition_NoText= 5

#PB_ListView_DataFilter = 1
#PB_ListView_DataFilterPlaceholder = 2

#PB_Orientation_Horizontal = "horizontal"
#PB_Orientation_Vertical = "vertical"

#PB_Panel_Left = "left"
#PB_Panel_Right = "right"

#PB_Panel_Display_Reveal = "reveal"
#PB_Panel_Display_Overlay = "overlay"
#PB_Panel_Display_Push = "push"

#PB_Widget_Unchecked = 0
#PB_Widget_Checked = 1

! var currentPage;
! var currenContainer;

! var eventWidget;
! var eventType;

UseMobile()

; --------------

; Procedure EventWidget()
; 	! return eventWidget;
; EndProcedure
; 
; Procedure EventType()
; 	! return eventType;
; EndProcedure

Procedure.s GetWidgetType(Widget)

	!	var selector = $("#widget_" + Widget);
	!	if (selector.length === 0) return; // cCommon.WidgetIsNotInitialized("WidgetType()");
	! return selector.data("WidgetType");

EndProcedure

Procedure SetWidgetText(Widget, Text.s)
	
	! var selector = $("#widget_" + Widget);
	
	Protected WidgetType.s = GetWidgetType(Widget)
	
	Select WidgetType
		Case #PB_WidgetType_Button, #PB_WidgetType_Text
			! selector.text(Text);
		Case #PB_WidgetType_String
			! selector.val(Text);
	EndSelect
	
EndProcedure

; --------------

Procedure SetPageHeader(Page, Text.s)
	
	! var selector = $("#page_" + Page).find("div[data-role='header']").find("h1");
	! selector.text(Text);	
	! $.mobile.resetActivePageHeight();
	
EndProcedure

Procedure SetPageFooter(Page, Text.s)
	
	! var selector = $("#page_" + Page).find("div[data-role='footer']").find("h1");
	! selector.text(Text);	
	! $.mobile.resetActivePageHeight();
	
EndProcedure

Procedure HidePageHeader(Page, State)
	! var selector = $("#page_" + Page).find("div[data-role='header']");
	! if (State==false || State==0) {
	!		selector.show();
	! } else {
	!		selector.hide();
	! }
	! $.mobile.resetActivePageHeight();
EndProcedure

Procedure HidePageFooter(Page, State)
	! var selector = $("#page_" + Page).find("div[data-role='footer']");
	! if (State==false || State==0) {
	!		selector.show();
	! } else {
	!		selector.hide();
	! }
	! $.mobile.resetActivePageHeight();
EndProcedure

Procedure OpenPage(Page, BackPage=-1)
	
	Protected myDiv.s
	Protected BackButton.s
	
	If BackPage = -1
		BackButton = "data-add-back-btn='false'"
	Else
		BackButton = "data-add-back-btn='true'"
	EndIf
	
	myDiv = "<div data-role='page'>" + 
	        "<div data-role='header' data-position='fixed' " + BackButton + "><h1 /></div>" + 
	        "<div class='ui-content' role='main' />" + 
	        "<div data-role='footer' data-position='fixed'><h1 /></div>" + 
	        "</div>"
	
	! var selector = $(myDiv);
	! if (Page == cConstants.PB_Any) Page = cCommon.guid();
	! if ($("#page_" + Page).length > 0) ClosePage(Page);
	! selector.attr("id", "page_" + Page);
	
	! currentPage = Page;
	! currentContainer = selector.find(".ui-content");
	! selector.page();
	
	! $("body").append(selector);
	! $(":mobile-pagecontainer").pagecontainer( "change", $("#page_" + Page) );
	
	! // $.mobile.resetActivePageHeight();
	
	!	selector.on("click", "[data-rel=back]", function (e) {
	If BackPage > -1
		!		e.stopImmediatePropagation();
		!		e.preventDefault();
		!		$.mobile.changePage("#page_" + BackPage);
	EndIf
	!	});
	
	
	! return Page;
	
EndProcedure

Procedure PanelWidget(Widget, Position.s = #PB_Panel_Left, Display.s = #PB_Panel_Display_Reveal)
	
	! if (Widget === cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! selector = $("<div />");
	
	! selector.attr("id", "widget_" + Widget);
	! selector.attr("data-role", "panel");
	! selector.attr("data-position", Position);
	! selector.attr("data-display", Display);
	! selector.data("WidgetType", PB_WidgetType_Panel);
	
	! $("#page_" + currentPage).prepend(selector.panel());
	
	! return Widget;	
	
EndProcedure

Procedure ShowPanelWidget(Widget)
	
	! $("#widget_" + Widget).panel("open");
	
EndProcedure

Procedure HidePanelWidget(Widget)
	
	! $("#widget_" + Widget).panel("close");
	
EndProcedure

Procedure ClosePage(Page)
	! var selector = $("#page_" + Page);
	! selector.remove();
EndProcedure

Procedure HeaderWidget(Widget, Text.s = "")
	
	If Trim(Text) = ""
	! var selector = $("<a href='#' class='ui-btn ui-corner-all ui-btn-inline ui-mini ui-btn-left ui-btn-icon-left ui-icon-refresh' data-iconpos='notext'>&nbsp;</a>");
	Else
	! var selector = $("<a href='#' class='ui-btn ui-corner-all ui-btn-inline ui-mini ui-btn-left ui-btn-icon-left ui-icon-refresh'>" + Text + "</a>");
	EndIf
	
		
	
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	! selector.attr("id", "widget_" + Widget);
	! selector.data("WidgetType", PB_WidgetType_HeaderButton);
	
	! selector.bind("click", function (event, ui) {
	! 	var cb = selector.data("onLeftClick");
	! 	if (typeof cb === "function") {
	! 		if (event.which === 1) {
	! 			cb();
	! 		}
	! 	}
	! });		
	
	! $("#page_" + currentPage).find("div[data-role='header']").prepend(selector);
	! return Widget;
	
EndProcedure

Procedure FooterButton(FooterButton, Text.s)
	
	! var selector = $("<a href='#' class='ui-btn ui-corner-all ui-btn-inline ui-mini ui-btn-left ui-btn-icon-left ui-icon-power'>" + Text + "</a>");
	! $("#footer_" + currentFooter).prepend(selector);
	
EndProcedure

Procedure RemovePage(Page)
EndProcedure

Procedure ShowPage(Page)
	!	setTimeout(function () {
	! 	$("body").pagecontainer( "change", "#page_" + Page );
	!	}, 100); // delay above zero	
EndProcedure

Procedure HidePage(Page)
	!	setTimeout(function () {
	! 	var selector = $("#page_" + Page);
	! 	selector.hide();
	!	}, 100); // delay above zero	
EndProcedure



Procedure ButtonWidget_BindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", Callback);
	
EndProcedure
Procedure ButtonWidget_UnbindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", null);
	
EndProcedure

Procedure ListViewWidget_BindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", Callback);
	
EndProcedure
Procedure ListViewWidget_UnbindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", null);
	
EndProcedure

Procedure HeaderButton_BindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", Callback);
	
EndProcedure
Procedure HeaderButton_UnbindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", null);
	
EndProcedure

Procedure StringWidget_BindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_KeyUp
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyUp)) selector.data("onKeyUp", Callback);
	
EndProcedure
Procedure StringWidget_UnbindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_KeyUp
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyUp)) selector.data("onKeyUp", null);
	
EndProcedure

Procedure FlipswitchWidget_BindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_Change
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change)) selector.data("onChange", Callback);
	
EndProcedure
Procedure FlipswitchWidget_UnbindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_Change
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change)) selector.data("onChange", null);
	
EndProcedure


Procedure BindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	Protected WidgetType.s = GetWidgetType(Widget)
	
	Select WidgetType
		Case #PB_WidgetType_Button
			ButtonWidget_BindWidgetEvent(Widget, Callback, EventType)
		Case #PB_WidgetType_ListView
			ListViewWidget_BindWidgetEvent(Widget, Callback, EventType)
		Case #PB_WidgetType_String
			StringWidget_BindWidgetEvent(Widget, Callback, EventType)
		Case #PB_WidgetType_HeaderButton
			HeaderButton_BindWidgetEvent(Widget, Callback, EventType)
		Case #PB_WidgetType_Flipswitch
			FlipswitchWidget_BindWidgetEvent(Widget, Callback, EventType)
	EndSelect
	
EndProcedure

Procedure FreeWidget(Widget)
	
	! var selector = $("#widget_" + Widget);
	
	! selector.remove();
	
	! selector = $("label[for='widget_" + Widget + "']");
	
	! selector.remove();
	
EndProcedure

Procedure CloseWidgetList()
	
	! currentContainer = currentContainer.parent().parent();
	
	!	currentContainer.trigger( "create" );
	
EndProcedure

Procedure ButtonWidget(Widget, Text.s)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("<button />");
	
	! selector.attr("id", "widget_" + Widget);
	
	! selector.data("WidgetType", PB_WidgetType_Button);
	
	! selector.bind("click", function (event, ui) {
	! 	var cb = selector.data("onLeftClick");
	! 	if (typeof cb === "function") {
	! 		if (event.which === 1) {
	!				cEvent.eventType = cConstants.PB_EventType_LeftClick;
	!				cEvent.eventWidget = Widget;
	! 			cb(event, ui);
	! 		}
	! 	}
	! });	
	
	! currentContainer.append(selector).trigger('create');	
	
	SetWidgetText(Widget, Text)
	
	! return Widget;

EndProcedure

Procedure ControlgroupWidget(Widget, Orientation.s = #PB_Orientation_Vertical)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("<div />");
	
	! selector.attr("id", "widget_" + Widget);
	! selector.attr("data-role", "controlgroup");
	! selector.attr("data-type", Orientation);
	! selector.data("WidgetType", PB_WidgetType_Controlgroup);
	! currentContainer.append(selector.controlgroup());
	! return Widget;
	
EndProcedure

Procedure NavbarWidget(Widget)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("<div />");
	! selector.append($("<ul />"));
	! selector.attr("id", "widget_" + Widget);
	! selector.attr("data-role", "navbar");
	! selector.data("WidgetType", PB_WidgetType_Navbar);
	! currentContainer.append(selector);
	! return Widget;
	
EndProcedure

Procedure ListItemWidget(Widget)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("<li />");
	! selector.attr("id", "widget_" + Widget);
	
; 	! var a = selector.find("a");
; 	! a.attr("href", "#");
; 	! a.text(Text);
; 	

	! selector.data("WidgetType", PB_WidgetType_ListItem);
	! currentContainer.append(selector);
	! return Widget;
	
EndProcedure

Procedure LinkWidget(Widget, Text.s, hRef.s = "#")
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("<a />");
	! selector.attr("id", "widget_" + Widget);
 	! selector.attr("href", hRef);
	! selector.text(Text);
	
	! selector.click(function() {
	! 	$(this).parent().parent().find("a").each(function() {
	!   	$(this).removeClass("ui-btn-active");
	! 	});
	! });
	
	
	! selector.data("WidgetType", PB_WidgetType_Link);
	! currentContainer.append(selector);
	! return Widget;
	
EndProcedure

Procedure CheckBoxWidget(Widget, Text.s)
	
	! if (Widget === cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! selector = $("<label for='widget_" + Widget + "' />");
	! selector.text(Text);
	! currentContainer.append(selector);
	
	! var selector = $("<input type='checkbox' />");
	! // selector.attr("name", "widget_" + Widget);
	! selector.attr("id", "widget_" + Widget);
	! selector.data("WidgetType", PB_WidgetType_CheckBox);
	! currentContainer.append(selector);
	
	! return Widget;

EndProcedure

Procedure RadioWidget(Widget, Text.s)
	
	! if (Widget === cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! selector = $("<label for='widget_" + Widget + "' />");
	! selector.text(Text);
	! currentContainer.append(selector);
	
	! var selector = $("<input type='radio' />");
	
	! var name = currentContainer.attr("id");
	! if (!name) name = currentContainer.parent().attr("id");
	
	! selector.attr("name", name);
	! selector.attr("id", "widget_" + Widget);
	! selector.data("WidgetType", PB_WidgetType_Radio);
	! currentContainer.append(selector);
	
	! return Widget;

EndProcedure

Procedure FieldsetWidget(Widget, Text.s = "", Orientation.s = #PB_Orientation_Vertical)
	
	! if (Widget === cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("<fieldset><legend /></fieldset>");
	! selector.attr("id", "widget_" + Widget);
	! selector.attr("data-role", "controlgroup");
	! selector.attr("data-type", Orientation);
	! selector.find("legend").text(Text);
	! selector.data("WidgetType", PB_WidgetType_Fieldset);
	! currentContainer.append(selector);
	
	! return Widget;

EndProcedure

Procedure FlipswitchWidget(Widget, Labeltext.s = "", DataOnText.s = "On", DataOffText.s = "Off")
	
	! if (Widget === cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);

	! var selector;
	
	! selector = $("<label for='widget_" + Widget + "' />");
	! selector.text(Labeltext);
	! currentContainer.append(selector);
	
	! selector = $("<input type='checkbox' />");
	! selector.attr("id", "widget_" + Widget);
	! selector.attr("name", "widget_" + Widget);
	! selector.attr("data-role", "flipswitch");
	! selector.attr("data-on-text", DataOnText);
	! selector.attr("data-off-text", DataOffText);
	! selector.attr("data-wrapper-class", "custom-size-flipswitch");
	! selector.data("WidgetType", PB_WidgetType_Flipswitch);
	! currentContainer.append(selector);
	
	! selector.bind("change", function (event, ui) {
	! 	var cb = selector.data("onChange");
	! 	if (typeof cb === "function") { 
	!			cEvent.eventType = cConstants.PB_EventType_LeftClick;
	!			cEvent.eventWidget = Widget;
	! 		cb(event, ui);
	!		}
	! });	
	
	! return Widget;	
	
EndProcedure

Procedure StringWidget(Widget, LabelText.s, WidgetText.s = "", Flags = 0)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var type = " type='text' ";
	! var datatype = "";
	
	!	if (cCommon.CheckFlag(Flags, cConstants.PB_String_Numeric)) {
	! 	type = " type='number' ";
	! } else if (cCommon.CheckFlag(Flags, cConstants.PB_String_Password)) {
	! 	type = " type='password' ";
	! } else if (cCommon.CheckFlag(Flags, cConstants.PB_String_Search)) {
	! 	type = " type='text' ";
	! 	datatype = " data-type='search' ";
	! }
	
	! var selector = $("<label for='widget_" + Widget + "'>" + LabelText + "</label><input " + type + " " + datatype + " id='widget_" + Widget + "' value='" + WidgetText + "'>");
	
	! selector.data("WidgetType", PB_WidgetType_String);
	! currentContainer.append(selector);
	
	! $("#widget_" + Widget).textinput();
	
	! $("#widget_" + Widget).on("keyup", function () {
	! 	var cb = $("#widget_" + Widget).data("onKeyUp");
	! 	if (typeof cb === "function") {
	!			cb();
	! 	}
	! });
	
	! return Widget;
	
EndProcedure

Procedure ListViewWidget(Widget)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	!	var selector = $("<ul />");
	
	! selector.attr("id", "widget_" + Widget);
	! selector.attr("data-role", "listview");
	! selector.attr("data-inset", "true");
	
	! selector.data("DataFilter", false);
	! selector.data("DataFilterPlaceholder", "Filter...");
	
	! selector.data("WidgetType", PB_WidgetType_ListView);
		
	! currentContainer.append(selector);
	
	!	selector.listview().listview('refresh');	
	
	! selector.on('click', ' > li', function () {
	! 	var cb = selector.data("onLeftClick");
	! 	if (typeof cb === "function") {
	! 		if (event.which === 1) {
	!     	var selectedIndex = $(this).index();
	!     	var selectedText  = $(this).text();
	! 			cb(selectedIndex, selectedText);
	! 		}
	! 	}
	! });	
	
	! return Widget;
	
EndProcedure

Procedure SetWidgetAttribute_Button(Widget, Attribute, Value)
	
	! var selector = $("#widget_" + Widget);
	
	Select Attribute
			
		Case #PB_Widget_Icon
			! selector.buttonMarkup({ icon: Value });
			
		Case #PB_Widget_Inline
			
			Select Value
				Case #True
					! selector.addClass("ui-btn-inline");
				Case #False
					! selector.removeClass("ui-btn-inline");
			EndSelect
			
		Case #PB_Widget_Mini
			
			Select Value
				Case #True
					! selector.addClass("ui-mini");
				Case #False
					! selector.removeClass("ui-mini");
			EndSelect
			
		Case #PB_Widget_IconPosition
			
			! selector.removeClass("ui-btn-icon-left");
			! selector.removeClass("ui-btn-icon-right");
			! selector.removeClass("ui-btn-icon-top");
			! selector.removeClass("ui-btn-icon-bottom");
			! selector.removeClass("ui-btn-icon-notext");
			
			Select Value
				Case #PB_Widget_IconPosition_Right
					! Value = "right";
				Case #PB_Widget_IconPosition_Top
					! Value = "top";
				Case #PB_Widget_IconPosition_Bottom
					! Value = "bottom";
				Case #PB_Widget_IconPosition_NoText
					! Value = "notext";
				Default
					! Value = "left";
			EndSelect
			
			! selector.addClass("ui-btn-icon-" + Value);
			
	EndSelect
	
EndProcedure

Procedure SetWidgetAttribute_ListItem(Widget, Attribute, Value)
	
	! var selector = $("#widget_" + Widget);
	
	Select Attribute
			
		Case #PB_Widget_Icon
			If Value
				! selector.attr("data-icon", Value);
			Else
				! selector.attr("data-icon", "false");
			EndIf
			
	EndSelect
	
EndProcedure

Procedure SetWidgetAttribute_ListView(Widget, Attribute, Value)
	
	! var selector = $("#widget_" + Widget);
	
	Select Attribute
			
		Case #PB_ListView_DataFilter
			
			Select Value
				Case #True
					! selector.data("DataFilter", true);
				Case #False
					! selector.data("DataFilter", false);
			EndSelect
	
		Case #PB_ListView_DataFilterPlaceholder
			! selector.data("DataFilterPlaceholder", Value);
			
	EndSelect
	
	! selector.attr("data-filter", selector.data("DataFilter"));
	
	!	currentContainer.trigger( "create" );
	
	! selector.parent().find("input").attr("placeholder", selector.data("DataFilterPlaceholder"));

EndProcedure

Procedure SetWidgetAttribute(Widget, Attribute, Value)
	
	Protected WidgetType.s = GetWidgetType(Widget)
	
	Select WidgetType
		Case #PB_WidgetType_Button
			SetWidgetAttribute_Button(Widget, Attribute, Value)
		Case #PB_WidgetType_ListView
			SetWidgetAttribute_ListView(Widget, Attribute, Value)
		Case #PB_WidgetType_ListItem
			SetWidgetAttribute_ListItem(Widget, Attribute, Value)
		Case #PB_WidgetType_String
		Case #PB_WidgetType_HeaderButton
	EndSelect
	
EndProcedure

Procedure AddWidgetItem_Controlgroup(Widget, Item)
	
	! $("#widget_" + Widget).find(".ui-controlgroup-controls").append($("#widget_" + Item));
	
	! var selector = $("label[for='widget_" + Item + "']");
	
	! if (selector.length > 0) $("#widget_" + Widget).find(".ui-controlgroup-controls").append(selector);
	
EndProcedure

Procedure AddWidgetItem_Navbar(Widget, Item)
	
	! var selector = $("#widget_" + Widget);
	! if (selector.find("li").length > 0) selector.navbar("destroy");
	! selector = clearNavBarStyle(selector);
	! selector.find("ul").append($("#widget_" + Item));
	! selector.navbar();
	
EndProcedure

Procedure clearNavBarStyle(navbar)
	
	!	navbar.find("*").andSelf().each(function(){
	!		$(this).removeClass(function(i, cn){
	!			var matches = cn.match (/ui-[\w\-]+/g) || [];
	!   	return (matches.join (' '));
	!   });
	!		if ($(this).attr("class") == "") {
	!			$(this).removeAttr("class");
	!		}
	!	});
	!	return navbar;   
	
EndProcedure

Procedure AddWidgetItem_Fieldset(Widget, Item)
	
	If GetWidgetType(Item) = #PB_WidgetType_Radio
		! $("#widget_" + Item).attr("name", $("#widget_" + Widget).attr("id"));
	EndIf
	
	! $("#widget_" + Widget).append($("#widget_" + Item));
	
	! var selector = $("label[for='widget_" + Item + "']");
	
	! if (selector.length > 0) $("#widget_" + Widget).append(selector);
	
EndProcedure

Procedure AddWidgetItem_Panel(Widget, Item)
	
	If GetWidgetType(Item) = #PB_WidgetType_Radio
		! $("#widget_" + Item).attr("name", $("#widget_" + Widget).attr("id"));
	EndIf
	
	! $("#widget_" + Widget).append($("#widget_" + Item));
	! var selector = $("label[for='widget_" + Item + "']");
	! if (selector.length > 0) $("#widget_" + Widget).append(selector);
	
EndProcedure

Procedure AddWidgetItem_ListView(Widget, Item)
	
	! var selector = $("#widget_" + Widget);
	
	! selector.append($("#widget_" + Item));
	
	! selector.listview('refresh');
	
EndProcedure

Procedure AddWidgetItem_ListItem(Widget, Item)
	
	! var selector = $("#widget_" + Widget);
	
	! selector.append($("#widget_" + Item));
	
EndProcedure

Procedure AddWidgetItem(Widget, Item)
	
	Protected WidgetType.s = GetWidgetType(Widget)
	
	Select WidgetType
		Case #PB_WidgetType_Controlgroup
			AddWidgetItem_Controlgroup(Widget, Item)
		Case #PB_WidgetType_Navbar
			AddWidgetItem_Navbar(Widget, Item)
		Case #PB_WidgetType_Fieldset
			AddWidgetItem_Fieldset(Widget, Item)
		Case #PB_WidgetType_Panel
			AddWidgetItem_Panel(Widget, Item)
		Case #PB_WidgetType_ListView
			AddWidgetItem_ListView(Widget, Item)
		Case #PB_WidgetType_ListItem
			AddWidgetItem_ListItem(Widget, Item)
	EndSelect
	
EndProcedure

Procedure AddWidgetItems(Widget, Items.s)
	
	! var selector = $("#widget_" + Widget);
	
	! selector.append(Items);
	
	! selector.listview('refresh');
	
EndProcedure

Procedure.s GetWidgetText(Widget)
	
	! var selector = $("#widget_" + Widget);
	! return selector.val();
	
EndProcedure

Procedure DisableWidget(Widget, State)
	
	! var selector = $("#widget_" + Widget);	
	
	Protected WidgetType.s = GetWidgetType(Widget)
	
	Select WidgetType
		Case #PB_WidgetType_Button
			! if (State == 1 || State == true) {
			! 	selector.button("disable");
			! } else {
			! 	selector.button("enable");
			! }
		Case #PB_WidgetType_String
			! if (State == 1 || State == true) {
			! 	selector.textinput("disable");
			! } else {
			! 	selector.textinput("enable");
			! }
	EndSelect
	
EndProcedure

Procedure Notify(Message.s, Timeout = 1000)
	
	! var selector = $('<div data-role="popup" data-overlay-theme="a" data-transition="fade"><p>' + Message + '</p></div>');
	! $('body').append(selector).trigger('create');
	! selector.popup( "open" );
	! window.setTimeout( function() { selector.popup( "close" ) }, Timeout);
	
EndProcedure

Procedure MobileMessageRequester(Page, Title.s, Message.s, Flags, Callback = #Null)
	
	Protected html.s = ""
	
	Protected buttons.s = ""
	
	Select Flags
		Case #PB_MessageRequester_Ok
			buttons	 = "<a id='btnOK' href='#' class='ui-btn ui-corner-all ui-shadow ui-btn-inline'>OK</a>"
			
		Case #PB_MessageRequester_YesNo
			buttons = "<a id='btnOK'     href='#' class='ui-btn ui-corner-all ui-shadow ui-btn-inline'>OK</a>" + 
			          "<a id='btnCancel' href='#' class='ui-btn ui-corner-all ui-shadow ui-btn-inline'>Abbrechen</a>" 
			          
	EndSelect
	
	html = "<div data-role='popup' id='MsgBox' data-overlay-theme='b' data-theme='a' data-dismissible='false'>" +
	       " <div data-role='header'>" + 
	       "  <h1>" + Title + "</h1><a href='#' Data-rel='back' class='ui-btn ui-corner-all ui-shadow ui-btn-a ui-icon-delete ui-btn-icon-notext ui-btn-right'>Schliessen</a>" + 
	       " </div>" + 
	       " <div role='main' class='ui-content'>" + 
	       "  <h3 class='ui-title'>" + Message + "</h3>" + 
	       "  <div role='main' class='ui-content'>" + buttons + "</div>" + 
	       " </div>" + 
	       "</div>";
	
	! //append popup to DOM, tell jqm to enhance and initialize the popup
	! // and to remove the popup from DOM on close
	! $("#page_" + Page).append(html).find("#MsgBox").enhanceWithin().popup({
	!		afterclose: function (event, ui) {
	!			//remove from DOM on close
	!			$("#MsgBox").remove();
	!		}
	! }).popup("open");
	
	! //Add click handler for button in popup
	! $("#MsgBox").on("click", "#btnOK", function(){
	!		$("#MsgBox").popup("close");
	!		if (typeof Callback == "function") {
	!			Callback(cConstants.PB_MessageRequester_Ok);
	!   }
	! });
	
	! //Add click handler for button in popup
	! $("#MsgBox").on("click", "#btnCancel", function(){
	!		$("#MsgBox").popup("close");
	!		if (typeof Callback == "function") {
	!			Callback(cConstants.PB_MessageRequester_Cancel);
	!   }
	! });
	
EndProcedure

Procedure SpacerWidget(Widget, Space.s)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("span");
	! selector.css("margin", Space);
	! selector.attr("id", "widget_" + Widget);
	! selector.data("WidgetType", PB_WidgetType_Spacer);
	
	! currentContainer.append(selector);
	
	! return Widget;
	
	
EndProcedure

Procedure GetWidgetState(Widget)
	
	! var selector = $("#widget_" + Widget);
	
	Select GetWidgetType(Widget)
			
		Case #PB_WidgetType_Flipswitch
			
			! if (selector.prop("checked")) return PB_Widget_Checked;
			! return PB_Widget_Unchecked;
			
	EndSelect
	
EndProcedure
	
Procedure SetWidgetState(Widget, State)
	
	! var selector = $("#widget_" + Widget);
	
	Select GetWidgetType(Widget)
			
		Case #PB_WidgetType_Flipswitch
			
			Select State
				Case #PB_Widget_Checked
					! selector.attr('checked', 'checked');
				Case #PB_Widget_Unchecked
					! selector.removeAttr('checked');
			EndSelect
			
			! selector.flipswitch( "refresh" );			
			
	EndSelect
	
EndProcedure

Procedure TextWidget(Widget, Text.s)
	
	! if (Widget === cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);

	! var selector = $("<div />");
	! selector.text(Text);
	! selector.attr("id", "widget_" + Widget);
	! selector.data("WidgetType", PB_WidgetType_Text);
	! currentContainer.append(selector);
	
	! return Widget;
	
EndProcedure

Procedure RefreshPage()
	! $("#page_" + currentPage).trigger( "create" );
EndProcedure

! cDebugger.Debug = function (String) {
!  console.log(String);
! };

; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 597
; FirstLine = 135
; Folding = AAAAAAAAAA9
; EnableXP